var db = require('../../config/db');
var path = require('path');
var moment = require('moment');
var http = require("https");
let jwt = require('jsonwebtoken');
const AWS = require('aws-sdk');
var path = require('path');
const SFA_masterModel = require("./../../models/app/SFA_masterModel");
const Master = require("./../../models/app/masterModel");



var Home = function (data) {
    
};


Home.getBannerData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';  


        if(postData.loginType == 99){
            whereCondition += " AND (tg_master_banner.sales_user_banner = '1' )";
        }
        if(postData.loginType == 1){
            whereCondition += " AND (tg_master_banner.distributor_banner = '1' )";
        }
        if(postData.loginType == 10){
            whereCondition += " AND (tg_master_banner.retailer_banner = '1' )";
        }
        
        
        var queryString = "SELECT tg_master_banner.*, CONCAT('"+postData.image_app_path+"', tg_master_banner.image_path) as image_path  FROM tg_master_banner WHERE  status = ? AND tg_master_banner.deleted = ? "+ whereCondition +" ORDER BY ordering ASC ";
        var filter = [1, 0];
    
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Home.getTodayPointData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';  

        if(postData.loginType == 99){
            whereCondition += " AND (tg_customer_wallet_detail.user_id = '"+postData.sfa_app_user_id+"' )";
        }else{
            whereCondition += " AND (tg_customer_wallet_detail.customer_id = '"+postData.sfa_app_user_id+"' )";
        }

        var queryString = "SELECT IF(SUM(point),SUM(point),0) as totalPoints  FROM tg_customer_wallet_detail WHERE 1 = 1 AND DATE(created_on) = ? AND point >= ? " + whereCondition ;
        var filter = [moment(new Date()).format('YYYY-MM-DD'), 0];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var totalPoints = 0;
                if(res.length){
                    totalPoints = res[0].totalPoints
                }
                resolve(totalPoints);
            }
        });
    });
};

Home.getLast7DaysPointData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';  
        if(postData.loginType == 99){
            whereCondition += " AND (tg_customer_wallet_detail.user_id = '"+postData.sfa_app_user_id+"' )";
        }else{
            whereCondition += " AND (tg_customer_wallet_detail.customer_id = '"+postData.sfa_app_user_id+"' )";
        }

        var queryString = "SELECT IF(SUM(point),SUM(point),0) as totalPoints  FROM tg_customer_wallet_detail WHERE 1 = 1  AND DATE(created_on) >= ? AND point >= ? " +whereCondition;
        var filter = [moment(new Date()).subtract(7, "days").format('YYYY-MM-DD'), 0];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var totalPoints = 0;
                if(res.length){
                    totalPoints = res[0].totalPoints
                }
                resolve(totalPoints);
            }
        });
    });
};


Home.getMonthPointData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';  

        if(postData.loginType == 99){
            whereCondition += " AND (tg_customer_wallet_detail.user_id = '"+postData.sfa_app_user_id+"' )";
        }else{
            whereCondition += " AND (tg_customer_wallet_detail.customer_id = '"+postData.sfa_app_user_id+"' )";
        }
        var queryString = "SELECT IF(SUM(point),SUM(point),0) as totalPoints  FROM tg_customer_wallet_detail WHERE 1 = 1 AND  MONTH(created_on)=MONTH(CURDATE()) AND point >= ? " + whereCondition;
        var filter = [0];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var totalPoints = 0;
                if(res.length){
                    totalPoints = res[0].totalPoints
                }
                resolve(totalPoints);
            }
        });
    });
};


Home.getWalletPointData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        

        var whereCondition = '';  

        if(postData.loginType == 99){
            whereCondition += " AND (tg_customer_wallet_detail.user_id = '"+postData.sfa_app_user_id+"' )";
        }else{
            whereCondition += " AND (tg_customer_wallet_detail.customer_id = '"+postData.sfa_app_user_id+"' )";
        }
        
        var queryString = "SELECT IF(SUM(point),SUM(point),0) as totalPoints  FROM tg_customer_wallet_detail WHERE 1 = 1 "+ whereCondition;
        var filter = [];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var totalPoints = 0;
                if(res.length){
                    totalPoints = res[0].totalPoints
                }
                resolve(totalPoints);
            }
        });
    });
};


Home.getSiteImageDetailData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        var queryString = "SELECT CONCAT('"+postData.image_app_path+"', tg_customer_site_data.site_image) as site_image   FROM tg_customer_site_data WHERE customer_id  = ? ORDER BY ID DESC LIMIT 5";
        var filter = [postData.sfa_app_user_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Home.getProjectData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        var queryString = "SELECT tg_customer_project.* FROM tg_customer_project WHERE customer_id  = ? ORDER BY ID DESC LIMIT 5";
        var filter = [postData.sfa_app_user_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};




Home.getProductCategoryData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        // var queryString = "SELECT  COUNT(tg_master_product.id) as total_product_available, tg_master_product.product_category, CONCAT('"+postData.image_app_path+"', tg_master_product.product_image) as product_image_path FROM tg_master_product WHERE status = ? "+whereCondition+" GROUP BY tg_master_product.product_category";
        // var filter = [1];

        postData.limit = 5;
        postData.start = 0;
        var queryString = "SELECT tg_master_product_category.name as product_category,CONCAT('"+postData.image_app_path+"', tg_master_product_category.filename) as product_image_path  FROM tg_master_product_category WHERE status = ? AND deleted = ? ORDER BY ID DESC LIMIT ? OFFSET ? ";
        var filter = [1,0, postData.limit, postData.start];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                // resolve(res);
                if(res.length){
                    var i = res.length - 1;
                    res.forEach(async element => {
                        element.total_product_available = await Master.getProductListCount({"filter" : {"product_category" : element.product_category}})
                        if(i==0){
                            resolve(res);
                        }
                        i--;
                    });
                }else{
                    resolve(res);
                }
            }
        });
    });
};


Home.getTodayAttendanceData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';  
        var queryString = "SELECT * FROM tg_attendance WHERE user_id = ? AND attend_date = ? AND deleted = ? ORDER BY ID DESC";
        var filter = [postData.sfa_app_user_id, moment(new Date()).format('YYYY-MM-DD'), 0];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0]
                }
                resolve(data);
            }
        });
    });
};



Home.getCustTypeList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if(postData.loginType == 1){
            var queryString = "SELECT tg_customer_type.* FROM tg_customer_type WHERE status  = ? AND for_network = ? AND id != ? "+whereCondition+" ORDER BY ID DESC";
            var filter = [1, 1, postData.loginType];
        }else{
            var queryString = "SELECT tg_customer_type.* FROM tg_customer_type WHERE status  = ? AND for_network = ? "+whereCondition+" ORDER BY ID DESC";
            var filter = [1, 1];
        }

        console.log('queryString',queryString);
        console.log('filter',filter, 'postData', postData);
        
        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {

                if(res.length){
                    var i = res.length - 1;
                    res.forEach(async element => {

                        element.count = await SFA_masterModel.getAssignedRetailerNetworkListCount({"filter" : {"cust_type_id" : element.id},'sfa_app_user_id' : postData.sfa_app_user_id, 'appType' : postData.appType});

                        if(i == 0){
                            resolve(res);
                        }
                        i--;
                    });
                }else{
                    resolve(res);

                }
                
                
                
            }
        });
    });
};


Home.getLeadTypeList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        var queryString = "SELECT tg_customer_type.* FROM tg_customer_type WHERE status  = ? AND for_lead = ? "+whereCondition+" ORDER BY ID DESC";
        var filter = [1, 1];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {

                if(res.length){
                    var i = res.length - 1;
                    res.forEach(async element => {
                        
                        element.count = await SFA_masterModel.getDistributorNetworkCount({"filter" : {"cust_type_id" : element.id, "is_lead" : '1'}, "sfa_app_user_assignedDrIds" : postData.sfa_app_user_assignedDrIds, "sfa_app_user_assignedStateName" : postData.sfa_app_user_assignedStateName, 'sfa_app_user_id' : postData.sfa_app_user_id, 'sfa_app_user_assignedBeatPlan' : postData.sfa_app_user_assignedBeatPlan});
                        
                        if(i == 0){
                            resolve(res);
                        }
                        i--;
                    });
                }else{
                    resolve(res);

                }
                
                
                
            }
        });
    });
};



Home.getPendingCheckinList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        var queryString = "SELECT tg_checkin.*,tg_customer.first_name,tg_customer.last_name, tg_customer.company_name,tg_customer.street,tg_customer.state_name,tg_customer.district_name,tg_customer.mobile as mobile_no FROM tg_checkin LEFT JOIN tg_customer ON tg_customer.id = tg_checkin.customer_id WHERE  tg_checkin.deleted = ?  AND tg_checkin.user_id  = ? AND tg_checkin.stop_time  IS NULL  "+whereCondition+" ORDER BY tg_checkin.ID DESC";
        var filter = [0, postData.sfa_app_user_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


module.exports = Home;

