var db = require('../../config/db');
var path = require('path');
var moment = require('moment');
var http = require("https");
let jwt = require('jsonwebtoken');
const AWS = require('aws-sdk');
var path = require('path');
const { encrypt, decrypt, encrypter, my_simple_crypt } = require('../../config/common');
const mime = require('mime');
const fs = require("fs");
var request = require('request');


const s3 = new AWS.S3({
    accessKeyId: process.env.AWS_ACCESS_KEY,
    secretAccessKey: process.env.AWS_SECRET_ACCESS_KEY,
    s3bucket: process.env.S3_BUCKET,
    region: process.env.S3_REGION,
});


var User = function (data) {
    
};


User.getAppVersion = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT * FROM tg_app_version WHERE platform = ? AND version >= ? AND mandatory = ?"
        var filter = [postData.platform, postData.version, 1];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};



User.checkMobileNumber = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT id, cust_type FROM tg_customer WHERE mobile = ?"
        var filter = [postData.mobile_no];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};


User.findByMobileNumber = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT id FROM tg_customer WHERE mobile = ?"
        var filter = [postData.mobile_no];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0];
                }
                console.log('data',data);
                resolve(data);
            }
        });
    });
};


User.checkLastLoginOtpRequest = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT * FROM tg_customer WHERE mobile = ? AND DATE_ADD(NOW(), INTERVAL  '5:30' HOUR_MINUTE) <= DATE_ADD(otp_updated_on, INTERVAL tg_customer.otp_valid_upto second);"
        var filter = [postData.mobile_no];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};



User.findByMobileNumber_Temp = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT id FROM tg_temp_register WHERE mobile = ?"
        var filter = [postData.mobile_no];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0];
                }
                console.log('data',data);
                resolve(data);
            }
        });
    });
};


User.checkLastLoginOtpRequest_Temp = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT * FROM tg_temp_register WHERE mobile = ? AND DATE_ADD(NOW(), INTERVAL  '5:30' HOUR_MINUTE) <= DATE_ADD(otp_updated_on, INTERVAL tg_temp_register.otp_valid_upto second);"
        var filter = [postData.mobile_no];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};


User.findByMobileNumber_salesUser = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT tg_system_users.id FROM tg_system_users LEFT JOIN tg_master_role ON tg_master_role.id = tg_system_users.role WHERE tg_system_users.mobile_no = ? AND tg_system_users.deleted = ? AND tg_system_users.status = ?  AND tg_master_role.for_sales_user = ?";
        var filter = [postData.mobile_no, 0, 1, 1];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0];
                }
                console.log('data',data);
                resolve(data);
            }
        });
    });
};


User.checkLastLoginOtpRequest_salesUser = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT * FROM tg_system_users WHERE mobile_no = ? AND DATE_ADD(NOW(), INTERVAL  '5:30' HOUR_MINUTE) <= DATE_ADD(otp_updated_on, INTERVAL tg_system_users.otp_valid_upto second);"
        var filter = [postData.mobile_no];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};


User.registerInsertOtp_Temp = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            mobile: postData.mobile_no ? postData.mobile_no : '',
            otp_code: postData.otp_code ? postData.otp_code : '',
            otp_valid_upto: 60,
            otp_updated_on: nowDateTime,
            created_on:nowDateTime
        }
        
        var queryString = "INSERT INTO tg_temp_register set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                console.log('res ==>',res);
                resolve(res);
            }
        });
    });
};


User.registerUpdateOtp_Temp = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var queryString = "UPDATE tg_temp_register SET otp_code = ?,  otp_updated_on = ?, otp_valid_upto = ? WHERE mobile = ?;"
        var filter = [postData.otp_code,  nowDateTime, 60, postData.mobile_no];
        console.log("otp",postData.otp_code)
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                console.log('res ==>',res);
                resolve(res);
            }
        });
    });
};


User.registerCheckOtpRequest_Temp = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT id FROM tg_temp_register WHERE mobile = ? AND  otp_code = ?";
        var filter = [postData.mobile_no, postData.otp_code];
        
        console.log('queryString',queryString);
        console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};


User.registerCheckOtpVerify_Temp = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "UPDATE tg_temp_register SET mobile_verified = ?  WHERE id = ?;"
        var filter = [1, postData.id];
        
        console.log('queryString',queryString);
        console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};


User.checkOtpRequest = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT id FROM tg_customer WHERE mobile = ? AND  otp_code = ?";
        var filter = [postData.sfa_app_user_mobile, postData.otp_code];
        
        console.log('queryString',queryString);
        console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};

User.sendOtp = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        
        if(process.env.OTP_SERVICE == "development" ||  process.env.OTP_SERVICE_MOBILE.includes(postData.mobile_no)){
            return resolve(true);
        }
        
        var apiKey = '1cef14-8fa380-79259f-7a48e1-36aea3';
        var sender = 'SAYAST';
        var mobile_no = postData.mobile_no;
        // var message = postData.otp_code+ ' is your OTP to login into Saya Stationary App.'
        
        var message =  'Hello Welcome to Saya your Login OTP is ' + postData.otp_code+ ' valid up to 5 Minutes. Team Saya Stationeries Private Limited'
        var messagetype = 'TXT';
        
        if(postData.message_type == 'redeem_request'){
            var message =  'Hello  '+postData.first_name+' Welcome to Saya your Login OTP is ' + postData.otp_code+ ' valid up to 5 Minutes. Team Saya Stationeries Private Limited'
            // var message = 'Dear '+postData.first_name+', One time password to redeem '+postData.point+' Points is '+postData.otp_code+' for gift '+postData.gift_name+'. Team SayaST.';
        }
        
        // console.log('postData',postData);
        // console.log('message',message);
        
        
        var options = {
            'method': 'POST',
            'url': 'http://api.pinnacle.in/index.php/sms/json',
            'headers': {
                'apikey': apiKey,
                'Content-Type': 'application/json',
            },
            body: JSON.stringify({
                'sender': sender,
                // 'numbers': '91'+mobile_no,
                'message': [
                    {
                        'number' : mobile_no,
                        'text' : message
                    }
                ],
                'messagetype': messagetype
            })
        };
        
        console.log('options',options);
        request(options, function (error, response) {
            if (error) throw new Error(error);
            console.log(response.body);
            resolve(response.body)
        });
        
    });
}



User.loginUpdateOtp = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var queryString = "UPDATE tg_customer SET otp_code = ?,  otp_updated_on = ?, otp_valid_upto = ? WHERE mobile = ?;"
        var filter = [postData.otp_code,  nowDateTime, 60, postData.mobile_no];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                console.log('res ==>',res);
                resolve(res);
            }
        });
    });
};



User.loginUpdateOtp_salesUser = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var queryString = "UPDATE tg_system_users SET otp_code = ?,  otp_updated_on = ?, otp_valid_upto = ? WHERE mobile_no = ?;"
        var filter = [postData.otp_code,  nowDateTime, 60, postData.mobile_no];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                console.log('res ==>',res);
                resolve(res);
            }
        });
    });
};


User.loginCheckOtpRequest = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT id,session_token,company_name as name,mobile,cust_type,cust_type_id,first_name,last_name, CONCAT('"+postData.image_app_path+"', tg_customer.profile_image) as profile_image FROM tg_customer WHERE mobile = ? AND  otp_code = ?";
        var filter = [postData.mobile_no, postData.otp_code];
        
        console.log('queryString',queryString);
        console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};


User.loginCheckOtpRequest_salesUser = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT id,session_token,name,mobile_no,designation, CONCAT('"+postData.image_app_path+"', tg_system_users.profile_image) as profile_image FROM tg_system_users WHERE mobile_no = ? AND  otp_code = ?";
        var filter = [postData.mobile_no, postData.otp_code];
        
        console.log('queryString',queryString);
        console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};



User.updateSessionToken = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var tokenData = { 'name': postData.name ? postData.name : '', 'mobile_no': postData.mobile_no ? postData.mobile_no : '', 'password': postData.password ? postData.password : '' };
        let token = jwt.sign({ tokenData }, global.config.secretKey, {
            algorithm: global.config.algorithm,
        });
        postData.session_token = token;
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var queryString = "UPDATE tg_customer SET session_token = ?, token_updated_on = ? WHERE id = ?;"
        var filter = [postData.session_token, nowDateTime, postData.id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                console.log('res ==>',res);
                res.session_token = postData.session_token;
                resolve(res);
            }
        });
    });
};



User.updateSessionToken_salesUser = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var tokenData = { 'name': postData.name ? postData.name : '', 'mobile_no': postData.mobile_no ? postData.mobile_no : '', 'password': postData.password ? postData.password : '' };
        let token = jwt.sign({ tokenData }, global.config.secretKey, {
            algorithm: global.config.algorithm,
        });
        postData.session_token = token;
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var queryString = "UPDATE tg_system_users SET session_token = ?, token_updated_on = ?,  last_used = ? WHERE id = ?;"
        var filter = [postData.session_token, nowDateTime,nowDateTime, postData.id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                console.log('res ==>',res);
                res.session_token = postData.session_token;
                resolve(res);
            }
        });
    });
};


User.findReferredCode = function (postData) {
    console.log("postData",postData);
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT id,first_name FROM tg_customer WHERE referral_code = ?"
        var filter = [postData.referred_by_code];
        console.log("querystring",queryString);
        console.log("filter",filter);

        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                console.log('res',res);
                var data = {};
                if(res.length){
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};


User.getReferralBonusPoint = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT * FROM tg_master_point WHERE status = ?"
        var filter = [1];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                console.log('res',res);
                var data = {};
                if(res.length){
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};


User.sendWalletPoints = function (postData) {
    return new Promise(async function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        var insertData = {
            customer_id: postData.customer_id ? postData.customer_id : 0,
            user_id: postData.user_id ? postData.user_id : 0,
            against_customer_id : postData.against_customer_id ? postData.against_customer_id : 0,
            type: postData.type ? postData.type : '',
            point : postData.point ? postData.point : 0,
            coupon_id : postData.coupon_id ? postData.coupon_id : 0,
            gift_id : postData.gift_id ? postData.gift_id : 0,
            offer_id : postData.offer_id ? postData.offer_id : 0,
            product_id : postData.product_id ? postData.product_id : 0,
            redeem_request_id : postData.redeem_request_id ? postData.redeem_request_id : 0,
            redeem_id : postData.redeem_id ? postData.redeem_id : 0,
            created_on:nowDateTime
        }
        
        var queryString = "INSERT INTO tg_customer_wallet_detail set ?";
        
        db.query(queryString, insertData, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var updateNetworkWalletPoints = await User.updateNetworkWalletPoints(postData);
                console.log('updateNetworkWalletPoints',updateNetworkWalletPoints);

                var updateSalesUserWalletPoints = await User.updateSalesUserWalletPoints(postData);
                console.log('updateSalesUserWalletPoints',updateSalesUserWalletPoints);


                
                resolve(res);
            }
        });
    });
};


User.updateNetworkWalletPoints = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var queryString = "UPDATE ?? SET wallet_points = wallet_points + ?, updated_on = ? WHERE id = ?;"
        var filter = ["tg_customer", postData.point, nowDateTime, postData.customer_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};

User.updateSalesUserWalletPoints = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var queryString = "UPDATE ?? SET wallet_points = wallet_points + ?, updated_on = ? WHERE id = ?;"
        var filter = ["tg_system_users", postData.point, nowDateTime, postData.user_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



User.registerAppUser = function (postData) {
    return new Promise(async function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        
        var tokenData = { 'first_name': postData.first_name ? postData.first_name : '', 'mobile': postData.mobile ? postData.mobile : '', 'last_name': postData.password ? postData.last_name : '' };
        let token = jwt.sign({ tokenData }, global.config.secretKey, {
            algorithm: global.config.algorithm,
        });
        
        postData.session_token = token;
        
        var insertData = {
            cust_type: postData.cust_type ? postData.cust_type : '',
            cust_type_id: postData.cust_type_id ? postData.cust_type_id : 0,
            company_type : postData.company_type ? postData.company_type : '',
            company_name : postData.company_name ? postData.company_name : '',
            first_name: postData.first_name ? postData.first_name : '',
            last_name: postData.last_name ? postData.last_name : '',
            mobile: postData.mobile ? postData.mobile : null,
            email: postData.email ? postData.email : null,
            street: postData.street ? postData.street : '',
            state_name: postData.state_name ? postData.state_name : '',
            district_name: postData.district_name ? postData.district_name : '',
            city: postData.city ? postData.city : '',
            pincode: postData.pincode ? postData.pincode : '',
            // branch : postData.branch.name ? postData.branch.name : '',
            status : 'Verified',
            profile_image : postData.profile_image ? postData.profile_image : '',
            session_token : postData.session_token ? postData.session_token : '',
            fcm_token : postData.fcm_token ? postData.fcm_token : '',
            date_of_birth : postData.date_of_birth ? postData.date_of_birth : '0000-00-00',
            date_of_anniversary : postData.date_of_anniversary ? postData.date_of_anniversary : '0000-00-00',
            bank_name : postData.bank_name ? postData.bank_name : '',
            account_number : postData.account_number ? postData.account_number : '',
            account_holder_name : postData.account_holder_name ? postData.account_holder_name : '',
            ifsc_code : postData.ifsc_code ? postData.ifsc_code : '',
            cheque_image : postData.cheque_image ? postData.cheque_image : '',
            referral_code : postData.user_referral_code ? postData.user_referral_code : null,
            referred_by_code : postData.referral_code ? postData.referral_code : null,
            registered: 0,
            otp_valid_upto: 60,
            updated_on: nowDateTime,
            created_on:nowDateTime,
            created_by_name : 'Self',
            created_by_type : 'app',
            created_by : '0',
        }
        
        
        var queryString = "INSERT INTO tg_customer set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                res.session_token = postData.session_token ? postData.session_token : null;
                resolve(res);
            }
        });
    });
};



User.updateReferredDetails = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            referred_by : postData.referred_by ? postData.referred_by : 0,
            referred_by_name : postData.referred_by_name ? postData.referred_by_name : '',
            referred_by_code : postData.referred_by_code ? postData.referred_by_code : '',
            referral_code : postData.referral_code ? postData.referral_code : null,
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_customer", updateDataValues, postData.id];
        
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



User.addCustomerDocument = function (postData) {
    return new Promise(async function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            customer_id : postData.customer_id ? postData.customer_id : 0,
            doc_type : postData.doc_type ? postData.doc_type : '',
            doc_type_value : postData.doc_type_value ? postData.doc_type_value : '',
            doc_filename : postData.doc_filename ? postData.doc_filename : '',
            doc_filename_1 : postData.doc_filename_1 ? postData.doc_filename_1 : '',
            created_on:nowDateTime
        }
        
        var queryString = "INSERT INTO tg_customer_document set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


User.deleteCustomerDocument = function (postData) {
    return new Promise(async function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            deleted : 1,
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE customer_id = ? AND doc_type = ?;"
        var filter = ["tg_customer_document", updateDataValues, postData.sfa_app_user_id, postData.doc_type];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


User.addCustomerDealer = function (postData) {
    return new Promise(async function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var company_name = postData.dealer?.company_name ? postData.dealer.company_name : '';
        var mobile =  postData.dealer?.mobile ? postData.dealer.mobile : '';
        
        var insertData = {
            customer_id : postData.customer_id ? postData.customer_id : 0,
            dealer_id : postData.dealer?.id,
            carpenter_id : postData.carpenter?.id,
            architect_id : postData.architect?.id,
            name : company_name ? company_name : '',
            mobile : mobile ? mobile : '',
            created_on:nowDateTime,
            updated_on:nowDateTime
        }
        
        var queryString = "INSERT INTO tg_customer_dealer set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


User.deleteCustomerDealer = function (postData) {
    return new Promise(async function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            deleted : 1,
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE customer_id = ?;"
        var filter = ["tg_customer_dealer", updateDataValues, postData.sfa_app_user_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


User.addCustomerAssignedSalesUser = function (postData) {
    return new Promise(async function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var user_id = postData.sales_employee?.id ? postData.sales_employee.id : 0;
        var user_name =  postData.sales_employee?.name ? postData.sales_employee.name : '';
        var user_code =  postData.sales_employee?.emp_code ? postData.sales_employee.emp_code : '';
        
        var insertData = {
            customer_id : postData.customer_id ? postData.customer_id : 0,
            user_id : user_id,
            user_name : user_name,
            user_code : user_code,
            deleted : 0,
            created_on:nowDateTime,
        }
        
        var queryString = "INSERT INTO tg_customer_assigned_user set ?";
        
        // console.log('insertData',insertData);
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


User.deleteCustomerAssignedSalesUser = function (postData) {
    return new Promise(async function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            deleted : 1,
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE customer_id = ?;"
        var filter = ["tg_customer_assigned_user", updateDataValues, postData.sfa_app_user_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


User.addCustomerPartnerData = function (postData) {
    return new Promise(async function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        const valueData = [];
        
        postData.partner_detail_array.forEach(x => {
            valueData.push([postData.customer_id ? postData.customer_id : 0,x.partner_detail_name?x.partner_detail_name:'',x.partner_detail_adhar_front?x.partner_detail_adhar_front:'',x.partner_detail_adhar_back?x.partner_detail_adhar_back:'',x.partner_detail_pan?x.partner_detail_pan:'',nowDateTime,0]);
        });
        
        var sql = "INSERT INTO tg_customer_partner (customer_id, name, aadhaar_front, aadhaar_back, pan, created_on, deleted) VALUES ?";
        db.query(sql, [valueData], function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



User.deleteCustomerPartnerData = function (postData) {
    return new Promise(async function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            deleted : 1,
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE customer_id = ?;"
        var filter = ["tg_customer_partner", updateDataValues, postData.sfa_app_user_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


User.base64ToFile = async function (postData, folderName) {
    
    
    
    return new Promise(async function (resolve, reject) {
        
        var monthYear = moment(new Date()).format('YYYY-MM');
        var base64String = postData.base64 ? postData.base64 : '';
        
        // var base64Data = Buffer.from(base64String.replace(/^data:video\/\w+;base64,/, ""),'base64');
        const fileType = base64String.split(';')[0].split('/')[1];
        const format = base64String.substring(base64String.indexOf('data:')+5, base64String.indexOf(';base64'));
        
        // console.log('format',format);
        var getFileTypeValue = format.split('/')[0];
        console.log('getFileTypeValue',getFileTypeValue);
        
        if(getFileTypeValue == 'video'){
            var base64Data = Buffer.from(base64String.replace(/^data:video\/\w+;base64,/, ""),'base64');
        }else if(getFileTypeValue == 'application'){
            // console.log('else if');
            var base64Data = Buffer.from(base64String.replace(/^data:application\/\w+;base64,/, ""),'base64');
        }else{
            console.log('else');
            var base64Data = Buffer.from(base64String.replace(/^data:image\/\w+;base64,/, ""),'base64');
        }
        
        // console.log('base64Data',base64Data);
        
        var fileName = getUniqueFilename(fileType);
        const params = {
            Bucket: s3.config.s3bucket,
            Key: s3.config.s3bucket+'/asean-ply/'+ monthYear+'/'+ fileName , // File name you want to save as in S3
            Body: base64Data,
            // Body: Buffer.from(base64String, 'base64'), // <---------
            ContentEncoding: 'base64', // required
            // ContentType: 'video/'+fileType // required. Notice the back ticks
            ContentType: format
        }
        
        console.log('params',params);
        
        let location = '';
        let key = '';
        try {
            var data = {};
            const { Location, Key } = await s3.upload(params).promise();
            location = Location;
            key = Key;
            console.log('successfully uploaded the image!', location);
            data.fileName = fileName ? monthYear +'/'+ fileName : '';
            data.Location = location;
            console.log('getFileTypeValue *_*', getFileTypeValue);
            console.log('fileType *_*', fileType);          
            resolve(data);
        } catch (error) {
            console.log('error', error);
            reject(error);
        }
        
    });
    
}


User.unlinkFile = async function (postData,type) {
    
    return new Promise(async function (resolve, reject) {
        
        var fileName = postData.filename ? postData.filename : '';
        
        s3.deleteObject({
            Bucket: s3.config.s3bucket,
            Key: 'asean-ply/' + fileName
        }, function (err, data) {
            if (err) {
                console.log('err', err);
                return reject(err);
            }
            console.log('data', data);
            console.log('file deleted successfully');
            resolve(data);
        });
    });
    
}



User.getUserDetailByToken = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT id,session_token,company_name,first_name, mobile, referral_code, cust_type_id, cust_type, status, state_name, district_name, login_block FROM tg_customer WHERE session_token = ? AND deleted = ?"
        var filter = [postData,0];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                console.log('res',res);
                var data = {};
                if(res.length){
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};



User.getUserDetailByToken_salesUser = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT id,session_token,name, status,emp_code,mobile_no as mobile,email, role FROM tg_system_users WHERE session_token = ? AND deleted = ? AND status = ?";
        var filter = [postData, 0, 1];
        
        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                // console.log('res',res);
                var data = {};
                if(res.length){
                    data = res[0];
                    data.first_name = data.name ? data.name : '';
                    data.isBranchHead = data.role == 5 ? true : false;
                    var getAssignedUserIds = await User.getUserAssignedUserIds(data);
                    data.sfa_app_user_id = data.id;
                    console.log('getAssignedUserIds',getAssignedUserIds.assigned_user_id);
                    data.assigned_user_ids = getAssignedUserIds.assigned_user_id ? getAssignedUserIds.assigned_user_id : ''
                    var getUserAssignedDrIds = await User.getUserAssignedDrIds(data);
                    data.assigned_dr_ids = getUserAssignedDrIds.assigned_dr_id ? getUserAssignedDrIds.assigned_dr_id : ''
                    var getUserAssignedWorkingStates = await User.getUserAssignedWorkingStates(data);
                    console.log('getUserAssignedWorkingStates',getUserAssignedWorkingStates);
                    data.assigned_state_name = getUserAssignedWorkingStates;
                    var getUserAssignedBeats = await User.getUserAssignedBeats(data);
                    console.log('getUserAssignedBeats',getUserAssignedBeats);
                    data.assigned_beat = getUserAssignedBeats;
                    var getTodayAssignedBeatPlan = await User.getTodayAssignedBeatPlan(data);
                    data.getTodayAssignedBeatPlan = getTodayAssignedBeatPlan;
                }
                resolve(data);
            }
        });
    });
};


User.getUserAssignedUserIds = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        // var queryString = "SELECT GROUP_CONCAT(DISTINCT(assigned_user_id)) as assigned_user_id FROM ?? WHERE user_id = ?"
        // var filter = ["tg_system_user_assign", postData.id];
        
        
        var queryString = "SELECT GROUP_CONCAT(DISTINCT(user_id)) as assigned_user_id FROM ?? WHERE assigned_user_id = ? AND deleted = ?"
        var filter = ["tg_system_user_assign", postData.id, 0];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};


User.getUserAssignedDrIds = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT GROUP_CONCAT(DISTINCT(customer_id)) as assigned_dr_id FROM ?? WHERE user_id = ? AND deleted = ?"
        // var filter = ["tg_customer_sys_user_assign", postData.id];
        var filter = ["tg_customer_assigned_user", postData.id, 0];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};


User.getUserAssignedWorkingStates = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        // var queryString = "SELECT GROUP_CONCAT(DISTINCT(state_name) SEPARATOR ',' ) as assigned_state_name FROM ?? WHERE user_id = ?"
        var queryString = "SELECT state_name as assigned_state_name FROM ?? WHERE user_id = ? AND deleted = ?"
        var filter = ["tg_system_user_assign_state", postData.id, 0];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var assignedWorkingStateData = [];
                if(res.length){
                    var i = res.length - 1;
                    res.forEach(async x => {
                        assignedWorkingStateData.push(x.assigned_state_name);
                        if(i==0){
                            resolve(assignedWorkingStateData);
                        }
                        i--;
                    });
                }else{
                    resolve(assignedWorkingStateData);
                }
            }
        });
    });
};

User.getUserAssignedBeats = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT beat as assigned_beat FROM ?? WHERE user_id = ? AND deleted = ?"
        var filter = ["tg_system_user_assign_beat", postData.id, 0];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var assignedWorkingBeatData = [];
                if(res.length){
                    var i = res.length - 1;
                    res.forEach(async x => {
                        assignedWorkingBeatData.push(x.assigned_beat);
                        if(i==0){
                            resolve(assignedWorkingBeatData);
                        }
                        i--;
                    });
                }else{
                    resolve(assignedWorkingBeatData);
                }
            }
        });
    });
};


User.getProfileData_salesUser = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT tg_system_users.*, IF(tg_system_users.profile_image != '',CONCAT('"+postData.image_app_path+"', tg_system_users.profile_image), '') as profile_image ,  IF(tg_system_users.aadhar_back != '',CONCAT('"+postData.image_app_path+"', tg_system_users.aadhar_back), '') as aadhar_back, IF(tg_system_users.aadhar_front != '',CONCAT('"+postData.image_app_path+"', tg_system_users.aadhar_front), '') as aadhar_front, IF(tg_system_users.chequebook != '',CONCAT('"+postData.image_app_path+"', tg_system_users.chequebook), '') as chequebook, IF(tg_system_users.pan_back != '',CONCAT('"+postData.image_app_path+"', tg_system_users.pan_back), '') as pan_back, IF(tg_system_users.pan_front != '',CONCAT('"+postData.image_app_path+"', tg_system_users.pan_front), '') as pan_front  FROM tg_system_users WHERE id = ?"
        var filter = [postData.sfa_app_user_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                // console.log('res',res);
                var data = {};
                if(res.length){
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};


User.getAssignedUser_salesUser = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT tg_system_user_assign.* FROM  tg_system_user_assign WHERE  tg_system_user_assign.user_id = ? AND tg_system_user_assign.deleted = ?  ORDER BY tg_system_user_assign.id ASC";
        var filter = [postData.sfa_app_user_id, 0];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


User.getAssignedState_salesUser = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT tg_system_user_assign_state.* FROM  tg_system_user_assign_state WHERE  tg_system_user_assign_state.user_id = ? AND tg_system_user_assign_state.deleted = ?  ORDER BY tg_system_user_assign_state.id ASC";
        var filter = [postData.sfa_app_user_id, 0];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


User.getAssignedProductDivision_salesUser = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT tg_system_user_assign_product_division.* FROM  tg_system_user_assign_product_division WHERE  tg_system_user_assign_product_division.user_id = ? AND tg_system_user_assign_product_division.deleted = ?  ORDER BY tg_system_user_assign_product_division.id ASC";
        var filter = [postData.sfa_app_user_id, 0];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



User.getProfileData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT tg_customer.*, IF(tg_customer.profile_image != '',CONCAT('"+postData.image_app_path+"', tg_customer.profile_image), '') as profile_image ,  IF(tg_customer.cheque_image != '',CONCAT('"+postData.image_app_path+"', tg_customer.cheque_image), '') as cheque_image   FROM tg_customer WHERE id = ?"
        var filter = [postData.sfa_app_user_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                // console.log('res',res);
                var data = {};
                if(res.length){
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};



User.getUserDocumentData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT tg_customer_document.*, IF(tg_customer_document.doc_filename != '',CONCAT('"+postData.image_app_path+"', tg_customer_document.doc_filename), '') as doc_filename , IF(tg_customer_document.doc_filename_1 != '',CONCAT('"+postData.image_app_path+"', tg_customer_document.doc_filename_1), '') as doc_filename_1 FROM tg_customer_document WHERE customer_id = ? AND deleted = ?";
        var filter = [postData.sfa_app_user_id, 0];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



User.getDealerDataInfo = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT tg_customer_dealer.* FROM tg_customer_dealer WHERE customer_id = ? AND deleted = ?"
        var filter = [postData.sfa_app_user_id, 0];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


User.getAssignedSEDataInfo = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT tg_customer_assigned_user.* FROM tg_customer_assigned_user WHERE customer_id = ? AND deleted = ?"
        var filter = [postData.sfa_app_user_id, 0];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


User.getDealerPartnerData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT tg_customer_partner.*, IF(tg_customer_partner.aadhaar_front != '',CONCAT('"+postData.image_app_path+"', tg_customer_partner.aadhaar_front), '') as aadhaar_front, IF(tg_customer_partner.aadhaar_back != '',CONCAT('"+postData.image_app_path+"', tg_customer_partner.aadhaar_back), '') as aadhaar_back , IF(tg_customer_partner.pan != '',CONCAT('"+postData.image_app_path+"', tg_customer_partner.pan), '') as pan  FROM tg_customer_partner WHERE customer_id = ? AND deleted = ?";
        var filter = [postData.sfa_app_user_id, 0];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


User.getWalletPoints = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if(postData.walletDetailType == 'General'){
            whereCondition += " AND (type IN ('welcome_bonus', 'bonus_point', 'referral_owner', 'referral_user'))"; 
        }
        
        if(postData.walletDetailType == 'Coupon Scan'){
            whereCondition += " AND (type IN ('coupon_code'))"; 
        }
        
        // console.log('test',postData.filter.offer_ids.length);
        // console.log('test string',postData.filter.offer_ids.toString());
        
        // if(postData.filter.offer_ids.length){
        //     whereCondition += " AND (offer_id IN ('"+postData.filter.offer_ids.toString()+"'))"; 
        // }
        
        if(postData.filter?.type){
            whereCondition += " AND (type = '"+postData.filter.type+"' )"; 
        }
        
        if(postData.filter?.offer_id){
            whereCondition += " AND (tg_customer_wallet_detail.offer_id = '"+postData.filter.offer_id+"' )"; 
        }
        
        if(postData.loginType == 99){
            whereCondition += " AND (tg_customer_wallet_detail.user_id = '"+postData.sfa_app_user_id+"' )";
        }else{
            whereCondition += " AND (tg_customer_wallet_detail.customer_id = '"+postData.sfa_app_user_id+"' )";
        }
        
        var queryString = "SELECT IF(SUM(point),SUM(point),0) as totalPoints  FROM tg_customer_wallet_detail WHERE  1 = 1 "+ whereCondition
        var filter = [];
        
        console.log('queryString',queryString);
        console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var totalPoints = 0;
                if(res.length){
                    totalPoints = res[0].totalPoints
                }
                resolve(totalPoints);
            }
        });
    });
};


User.getLastBalanceUpdateData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        whereCondition = '';
        if(postData.loginType == 99){
            whereCondition += " AND (tg_customer_wallet_detail.user_id = '"+postData.sfa_app_user_id+"' )";
        }else{
            whereCondition += " AND (tg_customer_wallet_detail.customer_id = '"+postData.sfa_app_user_id+"' )";
        }
        
        
        var queryString = "SELECT created_on  FROM tg_customer_wallet_detail WHERE 1 = 1 " + whereCondition+"  ORDER BY ID DESC LIMIT 1"
        var filter = [];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = 0;
                if(res.length){
                    data = res[0]
                }
                resolve(data);
            }
        });
    });
};



User.updateFcmToken = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var queryString = "UPDATE tg_customer SET fcm_token = ?,  updated_on = ? WHERE id = ?;"
        var filter = [postData.fcm_token,  nowDateTime, postData.sfa_app_user_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                console.log('res ==>',res);
                resolve(res);
            }
        });
    });
};


User.updateFcmToken_salesUser = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var queryString = "UPDATE tg_system_users SET fcm_token = ?,  updated_on = ? WHERE id = ?;"
        var filter = [postData.fcm_token,  nowDateTime, postData.sfa_app_user_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                console.log('res ==>',res);
                resolve(res);
            }
        });
    });
};



User.updateProfileDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            company_type : postData.company_type ? postData.company_type : '',
            company_name : postData.company_name ? postData.company_name : '',
            first_name: postData.first_name ? postData.first_name : '',
            last_name: postData.last_name ? postData.last_name : '',
            mobile: postData.mobile ? postData.mobile : '',
            email: postData.email ? postData.email : null,
            street: postData.street ? postData.street : '',
            state_name: postData.state_name ? postData.state_name : '',
            district_name: postData.district_name ? postData.district_name : '',
            city: postData.city ? postData.city : '',
            pincode: postData.pincode ? postData.pincode : '',
            // branch : postData.branch.name ? postData.branch.name : '',
            profile_image : postData.profile_image ? postData.profile_image : '',
            fcm_token : postData.fcm_token ? postData.fcm_token : '',
            date_of_birth : postData.date_of_birth ? postData.date_of_birth : '0000-00-00',
            date_of_anniversary : postData.date_of_anniversary ? postData.date_of_anniversary : '0000-00-00',
            bank_name : postData.bank_name ? postData.bank_name : '',
            account_number : postData.account_number ? postData.account_number : '',
            account_holder_name : postData.account_holder_name ? postData.account_holder_name : '',
            ifsc_code : postData.ifsc_code ? postData.ifsc_code : '',
            cheque_image : postData.cheque_image ? postData.cheque_image : '',
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_customer", updateDataValues, postData.sfa_app_user_id];
        
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


User.updateProfileImage = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            // company_type : postData.company_type ? postData.company_type : '',
            // company_name : postData.company_name ? postData.company_name : '',
            // first_name: postData.first_name ? postData.first_name : '',
            // last_name: postData.last_name ? postData.last_name : '',
            // mobile: postData.mobile ? postData.mobile : '',
            // email: postData.email ? postData.email : null,
            // street: postData.street ? postData.street : '',
            // state_name: postData.state_name ? postData.state_name : '',
            // district_name: postData.district_name ? postData.district_name : '',
            // city: postData.city ? postData.city : '',
            // pincode: postData.pincode ? postData.pincode : '',
            // branch : postData.branch.name ? postData.branch.name : '',
            profile_image : postData.profile_image ? postData.profile_image : '',
            // fcm_token : postData.fcm_token ? postData.fcm_token : '',
            // date_of_birth : postData.date_of_birth ? postData.date_of_birth : '0000-00-00',
            // date_of_anniversary : postData.date_of_anniversary ? postData.date_of_anniversary : '0000-00-00',
            // bank_name : postData.bank_name ? postData.bank_name : '',
            // account_number : postData.account_number ? postData.account_number : '',
            // account_holder_name : postData.account_holder_name ? postData.account_holder_name : '',
            // ifsc_code : postData.ifsc_code ? postData.ifsc_code : '',
            // cheque_image : postData.cheque_image ? postData.cheque_image : '',
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_customer", updateDataValues, postData.sfa_app_user_id];
        
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


User.updateProfileImage_salesUser = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            profile_image : postData.profile_image ? postData.profile_image : '',
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_system_users", updateDataValues, postData.sfa_app_user_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};




User.updateProfileDetail_salesUser = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            emergency_contact : postData.emergency_contact ? postData.emergency_contact : '',
            email: postData.email ? postData.email : null,
            street: postData.street ? postData.street : '',
            state_name: postData.state_name ? postData.state_name : '',
            district_name: postData.district_name ? postData.district_name : '',
            city: postData.city ? postData.city : '',
            pincode: postData.pincode ? postData.pincode : '',
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_system_users", updateDataValues, postData.sfa_app_user_id];
        
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


User.updateSeInformation = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            se_code : postData.se_code ? postData.se_code : '',
            se_name : postData.se_name ? postData.se_name : '',
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_customer", updateDataValues, postData.sfa_app_user_id];
        
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



User.updateProfileDocument = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            doc_type : postData.doc_type ? postData.doc_type : '',
            doc_type_value : postData.doc_type_value ? postData.doc_type_value : '',
            doc_filename : postData.doc_filename ? postData.doc_filename : '',
            doc_filename_1 : postData.doc_filename_1 ? postData.doc_filename_1 : '',
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_customer_document", updateDataValues, postData.document_id];
        
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


User.addDealerInformation = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            customer_id : postData.sfa_app_user_id ? postData.sfa_app_user_id : 0,
            name : postData.name ? postData.name : '',
            mobile : postData.mobile ? postData.mobile : null,
            cp_name : postData.cp_name ? postData.cp_name : '',
            address : postData.address ? postData.address : '',
            created_on: nowDateTime,
        }
        
        var queryString = "INSERT INTO tg_customer_dealer set ?";
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


User.updateDealerInformation = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            name : postData.name ? postData.name : '',
            mobile : postData.mobile ? postData.mobile : null,
            cp_name : postData.cp_name ? postData.cp_name : '',
            address : postData.address ? postData.address : '',
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_customer_dealer", updateDataValues, postData.dealer_id];
        
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


User.logout = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var queryString = "UPDATE tg_customer SET session_token = ?,  updated_on = ? WHERE id = ?;"
        var filter = [null,  nowDateTime, postData.sfa_app_user_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                console.log('res ==>',res);
                resolve(res);
            }
        });
    });
};

User.logout_salesUser = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var queryString = "UPDATE tg_system_users SET session_token = ?,  updated_on = ? WHERE id = ?;"
        var filter = [null,  nowDateTime, postData.sfa_app_user_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                console.log('res ==>',res);
                resolve(res);
            }
        });
    });
};


User.deleteAccount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var queryString = "UPDATE tg_customer SET session_token = ?, deleted = ?,  updated_on = ? WHERE id = ?;"
        var filter = [null,  1, nowDateTime, postData.sfa_app_user_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                console.log('res ==>',res);
                resolve(res);
            }
        });
    });
};


User.deleteAccount_salesUser = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var queryString = "UPDATE tg_system_users SET session_token = ?, deleted = ?,  updated_on = ? WHERE id = ?;"
        var filter = [null,  1, nowDateTime, postData.sfa_app_user_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                console.log('res ==>',res);
                resolve(res);
            }
        });
    });
};



User.getUserPointListCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        if(postData.filter.type){
            whereCondition += " AND (type = '"+postData.filter.type+"' )"; 
        }
        
        if(postData.walletDetailType == 'General'){
            whereCondition += " AND (type IN ('welcome_bonus', 'bonus_point', 'referral_owner', 'referral_user'))"; 
        }
        
        if(postData.walletDetailType == 'Coupon Scan'){
            whereCondition += " AND (type IN ('coupon_code'))"; 
        }
        
        
        // if(postData.filter.offer_ids.length){
        //     whereCondition += " AND (tg_customer_wallet_detail.offer_id IN ('"+postData.filter.offer_ids.toString()+"'))"; 
        // }
        
        if(postData.filter.offer_id){
            whereCondition += " AND (tg_customer_wallet_detail.offer_id = '"+postData.filter.offer_id+"' )"; 
        }
        
        
        if(postData.loginType == 99){
            whereCondition += " AND (tg_customer_wallet_detail.user_id = '"+postData.sfa_app_user_id+"' )";
        }else{
            whereCondition += " AND (tg_customer_wallet_detail.customer_id = '"+postData.sfa_app_user_id+"' )";
        }
        
        
        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount  FROM tg_customer_wallet_detail WHERE  1  = 1 " + whereCondition;
        var filter = [];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var totalCount = 0;
                if(res.length){
                    totalCount = res[0].totalCount ? res[0].totalCount : 0;
                }
                resolve(totalCount);
            }
        });
    });
};


User.getUserPointListData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if(postData.filter.type){
            whereCondition += " AND (type = '"+postData.filter.type+"' )"; 
        }
        
        if(postData.walletDetailType == 'General'){
            whereCondition += " AND (type IN ('welcome_bonus', 'bonus_point', 'referral_owner', 'referral_user'))"; 
        }
        
        if(postData.walletDetailType == 'Coupon Scan'){
            whereCondition += " AND (type IN ('coupon_code'))"; 
        }
        
        
        if(postData.filter.offer_id){
            whereCondition += " AND (tg_customer_wallet_detail.offer_id = '"+postData.filter.offer_id+"' )"; 
        }
        
        // if(postData.filter.offer_ids.length){
        //     whereCondition += " AND (tg_customer_wallet_detail.offer_id IN ('"+postData.filter.offer_ids.toString()+"'))"; 
        // }
        
        if(postData.loginType == 99){
            whereCondition += " AND (tg_customer_wallet_detail.user_id = '"+postData.sfa_app_user_id+"' )";
        }else{
            whereCondition += " AND (tg_customer_wallet_detail.customer_id = '"+postData.sfa_app_user_id+"' )";
        }
        
        
        var queryString = "SELECT tg_customer_wallet_detail.*,IF(tg_master_product.product_image != '' , CONCAT('"+postData.image_app_path+"', tg_master_product.product_image), '' ) as product_image_path,tg_offer.title as offer_title,tg_offer.code as offer_code, tg_master_gift.title as gift_title, CONCAT('"+postData.image_app_path+"', tg_master_gift.image_filename) as gift_image_filename , tg_coupon.coupon_code,tg_coupon.product_name,tg_coupon.product_code,tg_coupon.used_on as coupon_scanned_on, tg_customer.first_name as against_first_name, tg_customer.last_name as against_last_name, tg_customer.cust_type as against_cust_type FROM tg_customer_wallet_detail LEFT JOIN tg_customer ON tg_customer.id = tg_customer_wallet_detail.against_customer_id   LEFT JOIN tg_coupon ON tg_coupon.id = tg_customer_wallet_detail.coupon_id LEFT JOIN tg_master_gift ON tg_master_gift.id = tg_customer_wallet_detail.gift_id LEFT JOIN tg_master_product ON tg_master_product.id = tg_customer_wallet_detail.product_id LEFT JOIN tg_offer ON tg_offer.id = tg_customer_wallet_detail.offer_id  WHERE 1 = 1 "+whereCondition+" ORDER BY tg_customer_wallet_detail.ID DESC LIMIT ? OFFSET ?";
        var filter = [postData.limit, postData.start];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                if(res.length){
                    var i = res.length - 1;
                    res.forEach(async x => {
                        x.image_app_path = await User.getIconData({"type" : x.type})
                        // x.remark = '';
                        if(i==0){
                            resolve(res);
                        }
                        i--;
                    });
                }else{
                    resolve(res);
                }
            }
        });
    });
};


User.getIconData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT image_url FROM ?? WHERE status = ? AND type = ?";        
        var filter = ["tg_master_icon", 1, postData.type];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0].image_url ? res[0].image_url : '';
                }
                resolve(data);
            }
        });
    });
};


User.checkCouponCodeValid = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDate = moment(new Date()).format('YYYY-MM-DD');
        
        var queryString = "SELECT id, point, product_id , offer_id FROM tg_coupon WHERE valid_upto >= ? AND coupon_code = ? ORDER BY ID DESC LIMIT 1"
        var filter = [nowDate, postData.coupon_code];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {
                    couponValid : false
                };
                if(res.length){
                    data = res[0];
                    data.couponValid = true
                }
                resolve(data);
            }
        });
    });
};


User.checkCouponOfferActive = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDate = moment(new Date()).format('YYYY-MM-DD');
        
        var queryString = "SELECT id FROM tg_offer WHERE status = ? AND id = ?"
        var filter = [1, postData.offer_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var offerActive = false;
                if(res.length){
                    offerActive = true
                }
                resolve(offerActive);
            }
        });
    });
};


User.checkCouponCodeAvailable = function (postData) {
    console.log("logintypepostdata",postData)
    
    return new Promise(function (resolve, reject) {
        
        var nowDate = moment(new Date()).format('YYYY-MM-DD');

        // valid_upto is removed 
        
        if(postData.sfa_app_user_cust_type_id == 10){
            var queryString = "SELECT id,used_by_retailer,used_by_retailer_name, retailer_point, distributor_point, sales_user_point, product_id , offer_id FROM tg_coupon WHERE coupon_code = ? ORDER BY ID DESC LIMIT 1"
            var filter = [ postData.coupon_code];
        }else{
            var queryString = "SELECT id, point, product_id , offer_id FROM tg_coupon WHERE valid_upto >= ? AND coupon_code = ? AND used_by = ? ORDER BY ID DESC LIMIT 1"
            var filter = [nowDate, postData.coupon_code, 0];
        }

        
        console.log('queryString',queryString);
        console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};


User.redeemCouponCode = function (postData) {
    console.log("postdataupdatedvalues", postData);
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        
        // if(postData.sfa_app_user_cust_type_id == 3){
        //     var updateDataValues = {
        //         point: postData.point ? postData.point : 0,
        //         used_by_carpenter_on: nowDateTime,
        //         used_by_carpenter: postData.sfa_app_user_id,
        //         used_by_carpenter_name: postData.sfa_app_user_name,
        //         used_by_carpenter_mobile: postData.sfa_app_user_mobile,
        //     }
        // }else if(postData.sfa_app_user_cust_type_id == 4){
        //     var updateDataValues = {
        //         point: postData.point ? postData.point : 0,
        //         used_by_architect_on: nowDateTime,
        //         used_by_architect: postData.sfa_app_user_id,
        //         used_by_architect_name: postData.sfa_app_user_name,
        //         used_by_architect_mobile: postData.sfa_app_user_mobile,
        //     }
        // }else{
        //     var updateDataValues = {
        //         point: postData.point ? postData.point : 0,
        //         used_on: nowDateTime,
        //         used_by: postData.sfa_app_user_id,
        //         used_by_name: postData.sfa_app_user_name,
        //         used_by_type_id: postData.sfa_app_user_cust_type_id ? postData.sfa_app_user_cust_type_id : 0,
        //         used_by_type_name: postData.sfa_app_user_cust_type_name ? postData.sfa_app_user_cust_type_name : '',
        //     }
        // }
        
        var updateDataValues = {
            used_by_retailer: postData.sfa_app_user_id ? postData.sfa_app_user_id : 0,
            used_by_retailer_on: nowDateTime,
            used_by_retailer_name: postData.sfa_app_user_name,
            used_by_retailer_mobile: postData.sfa_app_user_mobile,
            used_by_retailer_district_name : postData.sfa_app_user_district_name,
            used_by_retailer_state_name : postData.sfa_app_user_state_name,
            used_by_distributor: postData.used_by_distributor ? postData.used_by_distributor : 0,
            used_by_distributor_on: nowDateTime,
            used_by_distributor_name: postData.used_by_distributor_name,
            used_by_distributor_mobile: postData.used_by_distributor_mobile,
            
            used_by_sales_user: postData.used_by_sales_user ? postData.used_by_sales_user : 0,
            used_by_sales_user_on: nowDateTime,
            used_by_sales_user_name: postData.used_by_sales_user_name,
            used_by_sales_user_mobile: postData.used_by_sales_user_mobile,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_coupon", updateDataValues, postData.coupon_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                console.log('res ==>',res);
                resolve(res);
            }
        });
    });
};







User.sendReedemRequest = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            redeem_request_id : postData.redeem_request_id ? postData.redeem_request_id : null,
            customer_id : postData.sfa_app_user_id ? postData.sfa_app_user_id : 0,
            cust_type_id : postData.sfa_app_user_cust_type_id ? postData.sfa_app_user_cust_type_id : 0,
            cust_type_name : postData.sfa_app_user_cust_type_name ? postData.sfa_app_user_cust_type_name : '',
            gift_id : postData.gift_id ? postData.gift_id : 0, 
            gift_title : postData.gift_title ? postData.gift_title : '', 
            offer_id : postData.offer_id ? postData.offer_id : 0, 
            offer_title : postData.offer_title ? postData.offer_title : '', 
            offer_code : postData.offer_code ? postData.offer_code : '', 
            gift_point : postData.gift_point ? postData.gift_point : 0,
            shipment_address : postData.address ? postData.address : '',
            gift_status : 'Pending',
            redeem_status : 'Pending',
            created_on: nowDateTime,
        }
        
        var queryString = "INSERT INTO tg_customer_redeem_request set ?";
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


User.updateRedeemRequestId = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            redeem_request_id : postData.redeem_request_id ? postData.redeem_request_id : null,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_customer_redeem_request", updateDataValues, postData.redeem_id];
        
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


User.getRedeemRequestHistoryCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount  FROM tg_customer_redeem_request WHERE customer_id = ? ORDER BY ID DESC";
        var filter = [postData.sfa_app_user_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var totalCount = 0;
                if(res.length){
                    totalCount = res[0].totalCount ? res[0].totalCount : 0;
                }
                resolve(totalCount);
            }
        });
    });
};


User.getRedeemRequestHistoryListData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        var queryString = "SELECT tg_customer_redeem_request.*, CONCAT('"+postData.image_app_path+"', tg_master_gift.image_filename) as gift_image_filename  FROM tg_customer_redeem_request LEFT JOIN tg_master_gift ON tg_master_gift.id = tg_customer_redeem_request.gift_id  WHERE tg_customer_redeem_request.customer_id = ? ORDER BY tg_customer_redeem_request.ID DESC LIMIT ? OFFSET ?";
        var filter = [postData.sfa_app_user_id, postData.limit, postData.start];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                if(res.length){
                    var i = res.length - 1;
                    res.forEach(async x => {
                        x.image_app_path = postData.image_app_path;
                        // x.offerImagedata = await Master.getOfferImageData(x);
                        // x.offer_image_path = x.offerImagedata.length ? x.offerImagedata[0].banner_filename : '';
                        if(i==0){
                            resolve(res);
                        }
                        i--;
                    });
                }else{
                    resolve(res);
                }
            }
        });
    });
};


User.getGiftDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        var queryString = "SELECT tg_master_gift.title,tg_master_gift.points FROM tg_master_gift WHERE  id = ? "+ whereCondition;
        var filter = [postData.gift_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};


User.getTodayAssignedBeatPlan = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        var nowDate = moment(new Date()).format('YYYY-MM-DD');
        
        var queryString = "SELECT tg_beat_plan_detail.beat_name FROM tg_beat_plan_detail WHERE  tg_beat_plan_detail.deleted = ?  AND tg_beat_plan_detail.user_id  = ? AND tg_beat_plan_detail.beat_date  = ? "+whereCondition;
        var filter = [0 , postData.sfa_app_user_id, nowDate];
        
        console.log('queryString',queryString);
        console.log('filter',filter);
        
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var assignedBeatPlanData = [];
                if(res.length){
                    var i = res.length - 1;
                    res.forEach(async x => {
                        assignedBeatPlanData.push(x.beat_name);
                        if(i==0){
                            resolve(assignedBeatPlanData);
                        }
                        i--;
                    });
                }else{
                    resolve(assignedBeatPlanData);
                }
            }
        });
    });
};


var getUniqueFilename = function (fileType) {
    var timestamp = (new Date()).getTime();
    var randomInteger = Math.floor((Math.random() * 1000000) + 1);
    var randomCharacter = generateRandomNumber(25);
    return timestamp + '_' + randomInteger + '_' + randomCharacter + '.' + fileType;
};


function generateRandomNumber(length) {
    var result = '';
    var characters = 'ABCDEFGHJKMNPQRSTUVWXYZ';
    var charactersLength = characters.length;
    for (var i = 0; i < length; i++) {
        result += characters.charAt(Math.floor(Math.random() * charactersLength));
    }
    return result;
}


module.exports = User;

