var db = require('../../config/db');
var path = require('path');
var moment = require('moment');
var http = require("https");
const { encrypt, decrypt, encrypter, my_simple_crypt } = require('../../config/common');
const axios = require('axios');


var Cron = function (data) {
    
};


Cron.getLastCheckinDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';        
        whereCondition += " AND ((tg_checkin.checkin_date) = '"+moment(new Date()).format('YYYY-MM-DD')+"')"; 
        
        var queryString = "SELECT tg_checkin.* FROM tg_checkin  WHERE  1 = 1 "+ whereCondition+" GROUP BY tg_checkin.user_id ORDER BY tg_checkin.id DESC";
        var filter = [postData.limit, postData.start];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Cron.getLastAttendanceDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';        
        whereCondition += " AND ((tg_attendance.attend_date) = '"+moment(new Date()).format('YYYY-MM-DD')+"')"; 
        
        var queryString = "SELECT tg_attendance.* FROM tg_attendance  WHERE  1 = 1 "+ whereCondition+" GROUP BY tg_attendance.user_id ORDER BY tg_attendance.id DESC";
        var filter = [postData.limit, postData.start];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



Cron.updateUserLatLng = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            last_lat : postData.stop_lat ? postData.stop_lat : postData.start_lat,
            last_lng : postData.stop_lng ? postData.stop_lng : postData.start_lng,
            last_address : postData.stop_address ? postData.stop_address : postData.start_address,
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_system_users", updateDataValues, postData.user_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



Cron.getSalesExecutiveData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';        
        whereCondition += " AND (tg_master_role.for_sales_user = '1')"; 
        
        var queryString = "SELECT tg_system_users.id as user_id FROM tg_system_users LEFT JOIN tg_master_role ON tg_master_role.id = tg_system_users.role WHERE  tg_system_users.deleted = ? AND tg_system_users.status = ? "+ whereCondition;
        var filter = [0, 1];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Cron.getNotStoppedAttendance = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';        
        whereCondition += " AND ((tg_attendance.attend_date) = '"+moment(new Date()).format('YYYY-MM-DD')+"')"; 
        
        var queryString = "SELECT tg_attendance.* FROM tg_attendance  WHERE  1 = 1 AND stop_time IS NULL "+ whereCondition;
        var filter = [];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Cron.getLiveTrackDataWithoutAddress = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';        
        var queryString = "SELECT tg_system_users_location.* FROM tg_system_users_location  WHERE  1 = 1 AND address = '' OR address IS NULL "+ whereCondition;
        var filter = [];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};

Cron.updateAddressLiveTrack = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var updateDataValues = {
            address : postData.address ? postData.address : '',
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_system_users_location", updateDataValues, postData.id];
        
        console.log('queryString',queryString);
        console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



Cron.getTodayAssignedBeatPlanData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';        
        whereCondition += " AND ((tg_beat_plan_detail.beat_date) = '"+moment(new Date()).format('YYYY-MM-DD')+"')"; 
        
        var queryString = "SELECT tg_beat_plan_detail.*, GROUP_CONCAT(DISTINCT(tg_beat_plan_detail.beat_name)) as assigned_beat_name FROM tg_beat_plan_detail  WHERE  1 = 1 AND deleted = ?  "+ whereCondition + " GROUP BY tg_beat_plan_detail.user_id";
        var filter = [0];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



Cron.getLiveTrackUserData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDate = moment(new Date()).format('YYYY-MM-DD');
        // var nowDate = '2023-09-30';
        var whereCondition = '';
        whereCondition += " AND (DATE(tg_system_users_location.created_on) = '"+nowDate+"')"; 
        var queryString = "SELECT tg_system_users_location.* FROM tg_system_users_location  WHERE  1 = 1 "+ whereCondition + " GROUP BY user_id";
        var filter = [postData.user_id];
        
        console.log('queryString',queryString);
        console.log('filter',filter);
        
        // return false;
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Cron.getLiveTrackDataForGoogleKm = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDate = moment(new Date()).format('YYYY-MM-DD');
        // var nowDate = '2023-09-27';
        var whereCondition = '';
        whereCondition += " AND (DATE(tg_system_users_location.created_on) = '"+nowDate+"')"; 
        var queryString = "SELECT tg_system_users_location.* FROM tg_system_users_location  WHERE  1 = 1 AND user_id = ? "+ whereCondition;
        var filter = [postData.user_id];
        
        console.log('queryString',queryString);
        console.log('filter',filter);
        
        // return false;
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                // Fixed source coordinates
                // console.log('res -->', res);
                // return false;
                var apiKey = process.env.GOOGLE_MAP_APIKEY;
                var attendance_id = 0;
                if(res.length){
                    
                    var i = res.length - 1;
                    var destinations = [];
                    res.forEach(element => {
                        if(element.attendance_id){
                            attendance_id = element.attendance_id;
                        }
                        destinations.push({lat : element.lat, lon: element.lng});     
                        if(i == 0){
                            
                            // Create an array to store the API request URLs
                            const apiUrls = destinations.map(destination => {
                                const destinationLat = destination.lat;
                                const destinationLon = destination.lon;
                                const sourceLat = res[0].lat;
                                const sourceLon = res[0].lng;
                                return `https://maps.googleapis.com/maps/api/distancematrix/json?origins=${sourceLat},${sourceLon}&destinations=${destinationLat},${destinationLon}&key=${apiKey}`;
                            });
                            
                            // Make parallel API requests
                            Promise.all(apiUrls.map(apiUrl => axios.get(apiUrl)))
                            .then(async responses => {
                                var j = responses.length - 1;
                                await responses.forEach(async (response, index) => {
                                    if (response.status === 200) {
                                        // const distance = response.data.rows[0].elements[0].distance.text;
                                        const distance = response.data.rows[0].elements[0].distance.value;
                                        console.log('distance -->', JSON.stringify(distance));
                                        var google_km =  distance / 1000;
                                        console.log(`Distance from source to destination ${index + 1}: ${google_km}`);
                                        console.log('google_km -->',google_km);
                                        
                                        var data = {};
                                        data.google_km = google_km;
                                        data.attendance_id = attendance_id;
                                        data.user_id = res[0].user_id;
                                        // console.log('index',index);
                                        // console.log('j',j);
                                        if(j == 0){
                                            resolve(data);
                                        }
                                        j--;
                                    } else {
                                        console.error(`Error fetching data for destination ${index + 1} from Google Maps API`);
                                        resolve(res);
                                    }
                                });
                            })
                            .catch(error => {
                                console.error('Error:', error);
                            });
                            
                        }
                        i--;
                    });
                }else{
                    resolve(res);
                } 
            }
        });
    });
};



Cron.updateGoogleKmData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            google_km : postData.google_km ? postData.google_km : '0',
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_attendance", updateDataValues, postData.attendance_id];
        
        console.log('queryString',queryString);
        console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



module.exports = Cron;
