var db = require('../../config/db');
const Network = require("./../../models/web/networkModel");
var path = require('path');
var moment = require('moment');
var http = require("https");
var request = require('request');
let jwt = require('jsonwebtoken');
var md5 = require('md5');
const { encrypt, decrypt, encrypter, my_simple_crypt } = require('../../config/common');


var Dashboard = function (data) {
    
};


Dashboard.getDashboardCountData = function (postData) {
    
    return new Promise(async function (resolve, reject) {
        
        
        var getActiveOfferCount = await Dashboard.getOfferCount({"type" : 'active'});
        var getGiftCount =  await Dashboard.getGiftCount({"filter" : {"status" : 1}});
        var getPendingRedeemRqstCount = await  Dashboard.getRedeemRequestCount({"filter" : {"redeem_status" : "Pending"}});
        var balanceCouponValue = await Dashboard.getBalanceCouponPoints({"filter" : {"statusName" : "Available"}});
        var retailerCount = await Dashboard.getNetworkCount({"filter" : {"cust_type_id" : 10}});
        var distributorCount = await Dashboard.getNetworkCount({"filter" : {"cust_type_id" : 1}});
        var productCount = await Dashboard.getProductCount({});
        
        var data = {
            activeOffer : getActiveOfferCount,
            giftCount : getGiftCount,
            pendingRedeemRqst: getPendingRedeemRqstCount,
            balanceCouponValue : balanceCouponValue,
            retailerCount : retailerCount,
            distributorCount : distributorCount,
            productCount : productCount
        }
        
        resolve(data);
        
    });
};



Dashboard.getOfferCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        if(postData.type == 'active'){
            whereCondition += " AND (status = '1')"; 
        }else if(postData.type == 'deactive'){
            whereCondition += " AND (status = '0')"; 
        }else{
            whereCondition += " AND (1 = 1)"; 
        }
        
        
        var queryString = "SELECT IF(COUNT(tg_offer.id),COUNT(tg_offer.id),0) as totalCount FROM tg_offer WHERE  deleted = ? "+ whereCondition
        var filter = [0];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


Dashboard.getGiftCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        if(postData.filter.status){
            whereCondition += " AND (status = '"+postData.filter.status+"')"; 
        }
        
        var queryString = "SELECT IF(COUNT(tg_master_gift.id),COUNT(tg_master_gift.id),0) as totalCount FROM tg_master_gift WHERE  1 = 1 "+ whereCondition
        var filter = [];
        
        // console.log('queryString',queryString);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


Dashboard.getRedeemRequestCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if(postData.filter.redeem_status){
            whereCondition += " AND (redeem_status LIKE '%"+postData.filter.redeem_status+"%')"; 
        }
        
        var queryString = "SELECT IF(COUNT(tg_customer_redeem_request.id),COUNT(tg_customer_redeem_request.id),0) as totalCount FROM tg_customer_redeem_request  WHERE  1 = 1 "+ whereCondition
        var filter = [];
        
        // console.log('queryString',queryString);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


Dashboard.getBalanceCouponPoints = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if(postData.filter.search){
            whereCondition += " AND (title LIKE '%"+postData.filter.search+"%'  OR code LIKE '%"+postData.filter.search+"%' OR description LIKE '%"+postData.filter.search+"%')"; 
        }
        
        if(postData.filter.date_from && postData.filter.date_to) {
            whereCondition += 'AND ( DATE(tg_coupon.created_on) BETWEEN  "' + moment(new Date(postData.filter.date_from)).format('YYYY-MM-DD') + '" AND "' + moment(new Date(postData.filter.date_to)).format('YYYY-MM-DD') + '" )';
        }
        
        if(postData.filter.statusName != 'All' && postData.filter.statusName != undefined){
            if(postData.filter.statusName == 'Scanned'){
                whereCondition += " AND (used_by != '0')"; 
            }
            if(postData.filter.statusName == 'Available'){
                whereCondition += " AND (used_by = '0')"; 
            }
        }
        
        
        var queryString = "SELECT IF(SUM(architect_point),SUM(architect_point),0) as totalBalanceArchitectPoint, IF(SUM(carpenter_point),SUM(carpenter_point),0) as totalBalanceCarpenterPoint FROM tg_coupon WHERE  tg_coupon.status = ? "+ whereCondition
        var filter = [1];
        
        // console.log('queryString',queryString);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};


Dashboard.getNetworkCount = function (postData) {
    
    return new Promise(function (resolve, reject) { 
        
        var whereCondition = '';
        
        if(postData.filter.date_from && postData.filter.date_to) {
            whereCondition += 'AND ( DATE(tg_customer.created_on) BETWEEN  "' + moment(new Date(postData.filter.date_from)).format('YYYY-MM-DD') + '" AND "' + moment(new Date(postData.filter.date_to)).format('YYYY-MM-DD') + '" )';
        }
        
        if(postData.filter.cust_type_id){
            whereCondition += " AND (cust_type_id = '"+postData.filter.cust_type_id+"')"; 
        }
        
        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount FROM tg_customer WHERE deleted = ? AND 1 = 1 "+ whereCondition
        var filter = [0];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};



Dashboard.getProductCount = function (postData) {
    
    return new Promise(function (resolve, reject) { 
        
        var whereCondition = '';
        
        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount FROM tg_master_product WHERE  1 = 1 "+ whereCondition
        var filter = [];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


Dashboard.getTopDistributorNetwork = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        if(postData.filter.date_from && postData.filter.date_to) {
            whereCondition += 'AND ( DATE(tg_customer.created_on) BETWEEN  "' + moment(new Date(postData.filter.date_from)).format('YYYY-MM-DD') + '" AND "' + moment(new Date(postData.filter.date_to)).format('YYYY-MM-DD') + '" )';
        }
        
        if(postData.filter.cust_type_id){
            whereCondition += " AND (cust_type_id = '"+postData.filter.cust_type_id+"')"; 
        }
        
        var queryString = "SELECT tg_customer.first_name, tg_customer.last_name, tg_customer.mobile, tg_customer.wallet_points FROM tg_customer WHERE  1 = 1 "+ whereCondition +" ORDER BY  tg_customer.wallet_points DESC LIMIT 15";
        var filter = [];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};





Dashboard.getDisNetworkDataStateWise = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if(postData.filter.date_from && postData.filter.date_to) {
            whereCondition += 'AND ( DATE(tg_customer.created_on) BETWEEN  "' + moment(new Date(postData.filter.date_from)).format('YYYY-MM-DD') + '" AND "' + moment(new Date(postData.filter.date_to)).format('YYYY-MM-DD') + '" )';
        }

        if(postData.cust_type_id) {
            whereCondition += 'AND ( tg_customer.cust_type_id = "'+postData.cust_type_id+'" )';
        }
        
        var queryString = "SELECT  IF(COUNT(tg_customer.id),COUNT(tg_customer.id),0) as count, IF(state_name!='',state_name,'Other') as state_name  FROM tg_customer WHERE  tg_customer.state_name IS NOT NULL AND deleted = ? "+ whereCondition +" GROUP BY tg_customer.state_name";
        var filter = [0];
        
        console.log('queryString',queryString);
        console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var drDataBranchWiseBarGraph = {};
                var branchList = [];
                var count = [];
                if(res.length){
                    var i = res.length - 1;
                    res.forEach(x => {
                        branchList.push(x.state_name);
                        count.push(x.count);
                        if(i==0){
                            var drDataBranchWiseBarGraph = {
                                branchList : branchList,
                                count : count,
                            }
                            resolve(drDataBranchWiseBarGraph);
                        }
                        i--;
                    });
                }else{
                    resolve(drDataBranchWiseBarGraph);
                }
                
            }
        });
    });
};


// in WIP
Dashboard.getSfaDashboardCountData = function (postData) {
    
    return new Promise(async function (resolve, reject) {
        
        // var getCustLeadTypeList = await Dashboard.getCustLeadTypeList();
        
        // var data = {
        //     getCustLeadTypeList : getCustLeadTypeList
        // }
        
        var statusArrayData = [
            // {'status' : 'All'},
            {'status' : 'Pending'},
            {'status' : 'Qualified'},
            {'status' : 'Disqualified'},
            {'status' : 'Win'},
            {'status' : 'Lost'}
        ]
        var leadCountPieGraph = {};
        var statusList = [];
        var count = [];
        var i = statusArrayData.length - 1;
        statusArrayData.forEach(async element => {
            element.count = await Network.getNetworkCountByStatus(element);
            // console.log('element.count',element.count);
            statusList.push(element.status);
            count.push(element.count);
            if(i == 0){
                leadCountPieGraph = {
                    statusList : statusList,
                    count : count,
                }   
                resolve(leadCountPieGraph);
            }
            i--;
        });
    });
};


Dashboard.getLatestCheckinUserData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        var orderByCondition = ' ORDER BY tg_checkin.ID DESC';
        
        var queryString = "SELECT tg_checkin.*, tg_system_users.name as user_name,tg_system_users.mobile_no,tg_system_users.emp_code, tg_customer.company_name,tg_customer.first_name as cust_first_name,tg_customer.last_name as cust_last_name , tg_system_user_assign.assigned_user_name as reporting_manager,  IF(tg_checkin.doc_filename != '',CONCAT('"+postData.image_app_path+"', tg_checkin.doc_filename), '') as doc_filename_path FROM tg_checkin  LEFT JOIN  tg_system_users ON tg_system_users.id = tg_checkin.user_id  LEFT JOIN  tg_system_user_assign ON tg_system_user_assign.user_id = tg_checkin.user_id  LEFT JOIN  tg_customer ON tg_customer.id = tg_checkin.customer_id  WHERE  1 = 1 "+ whereCondition +" GROUP BY tg_checkin.id "+ orderByCondition +" LIMIT ? OFFSET ? ";
        var filter = [15, 0];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var i = res.length - 1;
                if(res.length){
                    res.forEach(x => {
                        x.customer_encrypt_id = encrypt(x.customer_id.toString());
                        if(i==0){
                            resolve(res);
                        }
                        i--;
                    });
                }else{
                    resolve(res);
                }
            }
        });
    });
};

Dashboard.getTopSalesExecutive = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        var queryString = "SELECT tg_system_users.name,tg_system_users.emp_code  FROM tg_system_users WHERE  1 = 1 "+ whereCondition +" LIMIT 10";
        var filter = [];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Dashboard.getCustLeadTypeList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        var queryString = "SELECT tg_customer_type.id,tg_customer_type.name  FROM tg_customer_type WHERE status  = ? AND for_lead = ? "+whereCondition+" ORDER BY ID DESC";
        var filter = [1, 1];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                
                if(res.length){
                    var i = res.length - 1;
                    res.forEach(async element => {
                        
                        element.count = await Dashboard.getNetworkCount({"filter" : {"cust_type_id" : element.id , "is_lead" : "1", "status" : "Pending"}});
                        
                        if(i == 0){
                            resolve(res);
                        }
                        i--;
                    });
                }else{
                    resolve(res);
                    
                }
            }
        });
    });
};


// sfa code

Dashboard.getLeadDataSourceWise = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        if(postData.filter.date_from && postData.filter.date_to) {
            whereCondition += 'AND ( DATE(tg_customer.created_on) BETWEEN  "' + moment(new Date(postData.filter.date_from)).format('YYYY-MM-DD') + '" AND "' + moment(new Date(postData.filter.date_to)).format('YYYY-MM-DD') + '" )';
        }
        
        var queryString = "SELECT  IF(COUNT(tg_customer.id),COUNT(tg_customer.id),0) as lead_count, IF(lead_source!='',lead_source,'Other') as lead_source  FROM tg_customer WHERE  tg_customer.lead_source IS NOT NULL AND is_lead = ? AND deleted = ? "+ whereCondition +" GROUP BY tg_customer.lead_source";
        var filter = [1, 0];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var leadSourceBarGraph = {};
                var sourceList = [];
                var count = [];
                if(res.length){
                    var i = res.length - 1;
                    res.forEach(x => {
                        sourceList.push(x.lead_source);
                        count.push(x.lead_count);
                        if(i==0){
                            var leadSourceBarGraph = {
                                sourceList : sourceList,
                                count : count,
                            }
                            resolve(leadSourceBarGraph);
                        }
                        i--;
                    });
                }else{
                    resolve(leadSourceBarGraph);
                }
                
            }
        });
    });
};


// Dashboard.getDisNetworkDataStateWise = function (postData) {
    
//     return new Promise(function (resolve, reject) {
        
//         var whereCondition = '';
//         if(postData.filter.date_from && postData.filter.date_to) {
//             whereCondition += 'AND ( DATE(tg_customer.created_on) BETWEEN  "' + moment(new Date(postData.filter.date_from)).format('YYYY-MM-DD') + '" AND "' + moment(new Date(postData.filter.date_to)).format('YYYY-MM-DD') + '" )';
//         }
        
//         var queryString = "SELECT  IF(COUNT(tg_customer.id),COUNT(tg_customer.id),0) as count, IF(state_name!='',state_name,'Other') as state_name  FROM tg_customer WHERE  tg_customer.state_name IS NOT NULL AND is_lead = ? AND deleted = ? "+ whereCondition +" GROUP BY tg_customer.state_name";
//         var filter = [postData.is_lead, 0];
        
//         console.log('queryString',queryString);
//         console.log('filter',filter);
        
//         db.query(queryString, filter, function (err, res) {
//             if (err) {
//                 console.log("error: ", err);
//                 return reject(err);
//             }
//             else {
//                 if(postData.is_lead == "1"){
//                     var leadStateWiseBarGraph = {};
//                     var stateList = [];
//                     var count = [];
//                     if(res.length){
//                         var i = res.length - 1;
//                         res.forEach(x => {
//                             stateList.push(x.state_name);
//                             count.push(x.count);
//                             if(i==0){
//                                 var leadStateWiseBarGraph = {
//                                     stateList : stateList,
//                                     count : count,
//                                 }
//                                 resolve(leadStateWiseBarGraph);
//                             }
//                             i--;
//                         });
//                     }else{
//                         resolve(leadStateWiseBarGraph);
//                     }
//                 }else{
//                     var leadStateWiseGraph = [];
//                     if(res.length){
//                         var i = res.length - 1;
//                         res.forEach(x => {
//                             leadStateWiseGraph.push({'state_name' : x.state_name, 'count' : x.count});
//                             if(i==0){
//                                 resolve(leadStateWiseGraph);
//                             }
//                             i--;
//                         });
//                     }else{
//                         resolve(leadStateWiseGraph);
//                     }
//                 }
//             }
//         });
//     });
// };




Dashboard.getDisNetworkDataCustTypeWise = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        if(postData.filter.date_from && postData.filter.date_to) {
            whereCondition += 'AND ( DATE(tg_customer.created_on) BETWEEN  "' + moment(new Date(postData.filter.date_from)).format('YYYY-MM-DD') + '" AND "' + moment(new Date(postData.filter.date_to)).format('YYYY-MM-DD') + '" )';
        }
        
        var queryString = "SELECT  IF(COUNT(tg_customer.id),COUNT(tg_customer.id),0) as count, IF(cust_type!='',cust_type,'Other') as cust_type  FROM tg_customer WHERE  tg_customer.state_name IS NOT NULL AND is_lead = ? AND deleted = ? "+ whereCondition +" GROUP BY tg_customer.cust_type";
        var filter = [postData.is_lead, 0];
        
        console.log('queryString',queryString);
        console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                // var custTypeList = [];
                // if(res.length){
                //     var i = res.length - 1;
                //     res.forEach(x => {
                //         custTypeList.push([x.cust_type, x.count]);
                //         if(i==0){
                //             resolve(custTypeList);
                //         }
                //         i--;
                //     });
                // }else{
                //     resolve(custTypeList);
                // }

                var custTypeList = [];
                if(res.length){
                    var i = res.length - 1;
                    res.forEach(x => {
                        custTypeList.push({'cust_type' : x.cust_type, 'count' : x.count});
                        if(i==0){
                            resolve(custTypeList);
                        }
                        i--;
                    });
                }else{
                    resolve(custTypeList);
                }
                
            }
        });
    });
};


Dashboard.getSalesUserWorkingLatLng = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        if(postData.for_sales_user){
            whereCondition += " AND (tg_master_role.for_sales_user = '"+postData.for_sales_user+"')"; 
        }
        
        var queryString = "SELECT tg_system_users.id, tg_system_users.name, tg_system_users.mobile_no, tg_system_users.email,tg_system_users.emp_code, tg_system_users.last_lat, tg_system_users.last_lng,tg_system_users.last_address, tg_master_role.name as role, tg_system_users.updated_on FROM tg_system_users LEFT JOIN tg_master_role ON tg_master_role.id = tg_system_users.role WHERE  tg_system_users.deleted = ? AND tg_system_users.last_lat IS NOT NULL  "+ whereCondition +" ORDER BY id DESC, name ASC LIMIT ? OFFSET ? ";
        var filter = [0, postData.limit, postData.start];
        
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var i = res.length - 1;
                if(res.length){
                    res.forEach(x => {
                        x.user_encrypt_id = encrypt(x.id.toString());
                        if(i==0){
                            resolve(res);
                        }
                        i--;
                    });
                }else{
                    resolve(res);
                }    
            }
        });
    });
};



Dashboard.getSalesUserWorkingState = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        if(postData.for_sales_user){
            whereCondition += " AND (tg_master_role.for_sales_user = '"+postData.for_sales_user+"')"; 
        }
        
        var queryString = "SELECT tg_system_user_assign_state.state_name FROM tg_system_user_assign_state  WHERE  tg_system_user_assign_state.deleted = ? AND tg_system_user_assign_state.state_name != '' "+ whereCondition +" GROUP BY tg_system_user_assign_state.state_name ORDER BY tg_system_user_assign_state.state_name ASC";
        var filter = [0];
        
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var dataArray = [];
                if(res.length){
                    var i = res.length - 1;
                    res.forEach(async x => {
                        var userCount = await Dashboard.getSalesUserByWorkingStateCount(x);
                        dataArray.push({'name':x.state_name,'y':userCount, 'drilldown' : x.state_name.replace(/\s+/g, '-').toLowerCase()})
                        if(i==0){
                            resolve(dataArray);
                        }
                        i--;
                    });
                }else{
                    resolve(dataArray);
                }    
            }
        });
    });
};



Dashboard.getSalesUserWorkingStateDrillDownGraph = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        if(postData.for_sales_user){
            whereCondition += " AND (tg_master_role.for_sales_user = '"+postData.for_sales_user+"')"; 
        }
        
        var queryString = "SELECT tg_system_user_assign_state.state_name FROM tg_system_user_assign_state  WHERE  tg_system_user_assign_state.deleted = ? AND tg_system_user_assign_state.state_name != '' "+ whereCondition +" GROUP BY tg_system_user_assign_state.state_name ORDER BY tg_system_user_assign_state.state_name ASC";
        var filter = [0];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var dataArray = [];
                if(res.length){
                    var i = res.length - 1;
                    res.forEach(async x => {
                        var getSalesUserByWorkingState = await Dashboard.getSalesUserByWorkingState(x);
                        // console.log('getSalesUserByWorkingState',getSalesUserByWorkingState);
                        // console.log('getSalesUserByWorkingState',getSalesUserByWorkingState);
                        // console.log('getSalesUserByWorkingState',getSalesUserByWorkingState);
                        dataArray.push({'name':x.state_name, 'id' : x.state_name.replace(/\s+/g, '-').toLowerCase(), data : getSalesUserByWorkingState})
                        // console.log('dataArray', dataArray);
                        // return false;

                        if(i==0){
                            resolve(dataArray);
                        }
                        i--;
                    });
                }else{
                    resolve(dataArray);
                }    
            }
        });
    });
};





Dashboard.getSalesUserByWorkingStateCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        if(postData.for_sales_user){
            whereCondition += " AND (tg_master_role.for_sales_user = '"+postData.for_sales_user+"')"; 
        }
        
        var queryString = "SELECT IF(COUNT(tg_system_users.id),COUNT(tg_system_users.id),0) as totalCount FROM tg_system_user_assign_state LEFT JOIN tg_system_users ON tg_system_users.id = tg_system_user_assign_state.user_id WHERE  tg_system_user_assign_state.deleted = ? AND tg_system_user_assign_state.state_name = ? "+ whereCondition+" GROUP BY tg_system_user_assign_state.user_id";
        var filter = [0, postData.state_name];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var totalCount = 0;
                if(res.length){
                    totalCount = res[0].totalCount ? res[0].totalCount : 0;
                }
                resolve(totalCount);
            }
        });
    });
};

Dashboard.getSalesUserByWorkingState = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        if(postData.for_sales_user){
            whereCondition += " AND (tg_master_role.for_sales_user = '"+postData.for_sales_user+"')"; 
        }
        
        var queryString = "SELECT tg_system_users.name, tg_system_users.emp_code, tg_system_user_assign_state.state_name FROM tg_system_user_assign_state LEFT JOIN tg_system_users ON tg_system_users.id = tg_system_user_assign_state.user_id WHERE  tg_system_user_assign_state.deleted = ? AND tg_system_user_assign_state.state_name = ? "+ whereCondition+" GROUP BY tg_system_user_assign_state.user_id";
        var filter = [0, postData.state_name];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = [];
                var i = res.length - 1;
                if(res.length){
                    res.forEach(x => {
                        data.push([x.name, x.emp_code])
                        if(i == 0){
                            resolve(data);
                        }
                        i--;
                    });
                }else{
                    resolve(data);
                }
            }
        });
    });
};


module.exports = Dashboard;