var db = require('../../config/db');
var path = require('path');
var moment = require('moment');
var http = require("https");
var request = require('request');
let jwt = require('jsonwebtoken');
var md5 = require('md5');
const { encrypt, decrypt, encrypter, my_simple_crypt } = require('../../config/common');
const AWS = require('aws-sdk');


const s3 = new AWS.S3({
    accessKeyId: process.env.AWS_ACCESS_KEY,
    secretAccessKey: process.env.AWS_SECRET_ACCESS_KEY,
    s3bucket: process.env.S3_BUCKET,
    region: process.env.S3_REGION,
});

var Master = function (data) {
    
};

// master brand start 

Master.getBrandCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if (postData.filter.search) {
            whereCondition += " AND (name LIKE '%" + postData.filter.search + "%'  OR code LIKE '%" + postData.filter.search + "%' OR description LIKE '%" + postData.filter.search + "%')";
        }
        if (postData.filter.name) {
            whereCondition += " AND (name LIKE '%" + postData.filter.name + "%')";
        }
        if (postData.filter.code) {
            whereCondition += " AND (code LIKE '%" + postData.filter.code + "%')";
        }
        if (postData.filter.description) {
            whereCondition += " AND (description LIKE '%" + postData.filter.description + "%')";
        }
        if (postData.filter.status) {
            whereCondition += " AND (status LIKE '%" + postData.filter.status + "%')";
        }
        if (postData.filter.created_on) {
            whereCondition += " AND (created_on = '" + postData.filter.created_on + "')";
        }
        
        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount FROM tg_master_brand WHERE  1 = 1 AND deleted = 0" + whereCondition
        var filter = [];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if (res.length) {
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


Master.getBrandList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if (postData.filter.search) {
            whereCondition += " AND (name LIKE '%" + postData.filter.search + "%'  OR code LIKE '%" + postData.filter.search + "%' OR description LIKE '%" + postData.filter.search + "%')";
        }
        if (postData.filter.name) {
            whereCondition += " AND (name LIKE '%" + postData.filter.name + "%')";
        }
        if (postData.filter.code) {
            whereCondition += " AND (code LIKE '%" + postData.filter.code + "%')";
        }
        if (postData.filter.description) {
            whereCondition += " AND (description LIKE '%" + postData.filter.description + "%')";
        }
        if (postData.filter.status) {
            whereCondition += " AND (status LIKE '%" + postData.filter.status + "%')";
        }
        if (postData.filter.created_on) {
            whereCondition += " AND (created_on = '" + postData.filter.created_on + "')";
        }
        
        var queryString = "SELECT *  FROM tg_master_brand WHERE  1 = 1 AND deleted = ? " + whereCondition + " ORDER BY name ASC LIMIT ? OFFSET ? ";
        var filter = [0, postData.limit, postData.start];
        
        console.log('queryString', queryString);
        console.log('filter', filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



Master.addBrandData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            name: postData.name ? postData.name : '',
            code: postData.code ? postData.code : '',
            description: postData.description ? postData.description : '',
            status: postData.status ? postData.status : 0,
            updated_on: nowDateTime,
            created_on: nowDateTime
        }
        
        var queryString = "INSERT INTO tg_master_brand set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Master.updateBrandData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            name: postData.name ? postData.name : '',
            code: postData.code ? postData.code : '',
            description: postData.description ? postData.description : '',
            status: postData.status ? postData.status : 0,
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_master_brand", updateDataValues, postData.brand_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};

Master.deleteBrandData = function (postData) {
    return new Promise(function (resolve, reject) {
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            deleted: 1,
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_master_brand", updateDataValues, postData.id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
}

Master.getBrandDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT *  FROM tg_master_brand WHERE  id = ? ";
        var filter = [postData.brand_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if (res.length) {
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};


// master brand end


// master holiday code start

Master.getHolidayCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if (postData.filter.search) {
            whereCondition += " AND (name LIKE '%" + postData.filter.search + "%'  OR code LIKE '%" + postData.filter.search + "%' OR description LIKE '%" + postData.filter.search + "%')";
        }
        if (postData.filter.name) {
            whereCondition += " AND (name LIKE '%" + postData.filter.name + "%')";
        }
        if (postData.filter.code) {
            whereCondition += " AND (code LIKE '%" + postData.filter.code + "%')";
        }
        if (postData.filter.description) {
            whereCondition += " AND (description LIKE '%" + postData.filter.description + "%')";
        }
        if (postData.filter.status) {
            whereCondition += " AND (status LIKE '%" + postData.filter.status + "%')";
        }
        if (postData.filter.created_on) {
            whereCondition += " AND (created_on = '" + postData.filter.created_on + "')";
        }
        
        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount FROM tg_master_holiday WHERE  1 = 1 " + whereCondition
        var filter = [];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if (res.length) {
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


Master.getHolidayListData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if (postData.filter.search) {
            whereCondition += " AND (name LIKE '%" + postData.filter.search + "%'  OR code LIKE '%" + postData.filter.search + "%' OR description LIKE '%" + postData.filter.search + "%')";
        }
        if (postData.filter.name) {
            whereCondition += " AND (name LIKE '%" + postData.filter.name + "%')";
        }
        if (postData.filter.code) {
            whereCondition += " AND (code LIKE '%" + postData.filter.code + "%')";
        }
        if (postData.filter.description) {
            whereCondition += " AND (description LIKE '%" + postData.filter.description + "%')";
        }
        if (postData.filter.status) {
            whereCondition += " AND (status LIKE '%" + postData.filter.status + "%')";
        }
        if (postData.filter.created_on) {
            whereCondition += " AND (created_on = '" + postData.filter.created_on + "')";
        }
        
        var queryString = "SELECT *  FROM tg_master_holiday WHERE  1 = 1 " + whereCondition + " ORDER BY id DESC LIMIT ? OFFSET ? ";
        var filter = [postData.limit, postData.start];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



Master.addHolidayData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            holiday_title: postData.holiday_title ? postData.holiday_title : '',
            holiday_date: postData.holiday_date ? moment(postData.holiday_date).format('YYYY-MM-DD') : '',
            holiday_type: postData.holiday_type ? postData.holiday_type : '',
            deleted: postData.deleted ? postData.deleted : 0,
            updated_on: nowDateTime,
            created_on: nowDateTime,
            created_by: postData.sfa_web_user_id ? postData.sfa_web_user_id : 0,
            created_by_type: postData.sfa_web_user_type ? postData.sfa_web_user_type : '',
            created_by_name: postData.sfa_web_user_name ? postData.sfa_web_user_name : '',
        }
        
        var queryString = "INSERT INTO tg_master_holiday set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Master.updateHolidayData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            holiday_title: postData.holiday_title ? postData.holiday_title : '',
            holiday_date: postData.holiday_date ? moment(postData.holiday_date).format('YYYY-MM-DD') : '',
            holiday_type: postData.holiday_type ? postData.holiday_type : '',
            deleted: postData.deleted ? postData.deleted : 0,
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_master_holiday", updateDataValues, postData.holiday_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Master.getHolidayDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT *  FROM tg_master_holiday WHERE  id = ? ";
        var filter = [postData.holiday_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if (res.length) {
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};


// master holiday code end

// Product group start

Master.getProductGroupCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if (postData.filter.search) {
            whereCondition += " AND (name LIKE '%" + postData.filter.search + "%'  OR code LIKE '%" + postData.filter.search + "%' OR description LIKE '%" + postData.filter.search + "%')";
        }
        if (postData.filter.name) {
            whereCondition += " AND (name LIKE '%" + postData.filter.name + "%')";
        }
        if (postData.filter.code) {
            whereCondition += " AND (code LIKE '%" + postData.filter.code + "%')";
        }
        if (postData.filter.description) {
            whereCondition += " AND (description LIKE '%" + postData.filter.description + "%')";
        }
        if (postData.filter.status) {
            whereCondition += " AND (status LIKE '%" + postData.filter.status + "%')";
        }
        if (postData.filter.created_on) {
            whereCondition += " AND (created_on = '" + postData.filter.created_on + "')";
        }
        
        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount FROM tg_master_product_group WHERE  deleted = ? " + whereCondition
        var filter = [0];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if (res.length) {
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


Master.getProductGroupList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if (postData.filter.search) {
            whereCondition += " AND (name LIKE '%" + postData.filter.search + "%'  OR code LIKE '%" + postData.filter.search + "%' OR description LIKE '%" + postData.filter.search + "%')";
        }
        if (postData.filter.category_name) {
            whereCondition += " AND (name LIKE '%" + postData.filter.category_name + "%')";
        }
        if (postData.filter.name) {
            whereCondition += " AND (name LIKE '%" + postData.filter.name + "%')";
        }
        if (postData.filter.code) {
            whereCondition += " AND (code LIKE '%" + postData.filter.code + "%')";
        }
        if (postData.filter.description) {
            whereCondition += " AND (description LIKE '%" + postData.filter.description + "%')";
        }
        if (postData.filter.status) {
            whereCondition += " AND (status LIKE '%" + postData.filter.status + "%')";
        }
        if (postData.filter.created_on) {
            whereCondition += " AND (created_on = '" + postData.filter.created_on + "')";
        }
        
        var queryString = "SELECT *  FROM tg_master_product_group WHERE  deleted = ? " + whereCondition + " ORDER BY name ASC LIMIT ? OFFSET ? ";
        var filter = [0, postData.limit, postData.start];
        
        console.log('queryString', queryString);
        console.log('filter', filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



Master.addProductGroupData = function (postData) {
    // console.log("postdata",postData)
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            category_name: postData.product_category ? postData.product_category : "",
            name: postData.name ? postData.name : '',
            code: postData.code ? postData.code : '',
            description: postData.description ? postData.description : '',
            filename: postData.image_path ? postData.image_path : '',
            status: postData.status ? postData.status : 0,
            updated_on: nowDateTime,
            created_on: nowDateTime
        }
        
        var queryString = "INSERT INTO tg_master_product_group set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Master.updateProductGroupData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            category_name: postData.product_category ? postData.product_category : "",
            name: postData.name ? postData.name : '',
            code: postData.code ? postData.code : '',
            description: postData.description ? postData.description : '',
            filename: postData.image_path ? postData.image_path : '',
            status: postData.status ? postData.status : 0,
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_master_product_group", updateDataValues, postData.group_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



Master.deleteProductGroupData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            deleted: 1,
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_master_product_group", updateDataValues, postData.id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Master.getProductGroupDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT *  FROM tg_master_product_group WHERE  id = ? ";
        var filter = [postData.group_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if (res.length) {
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};




// Product group end


// Product category start

Master.getProductCategoryCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if (postData.filter.search) {
            whereCondition += " AND (name LIKE '%" + postData.filter.search + "%'  OR code LIKE '%" + postData.filter.search + "%' OR description LIKE '%" + postData.filter.search + "%')";
        }
        if (postData.filter.name) {
            whereCondition += " AND (name LIKE '%" + postData.filter.name + "%')";
        }
        if (postData.filter.code) {
            whereCondition += " AND (code LIKE '%" + postData.filter.code + "%')";
        }
        if (postData.filter.description) {
            whereCondition += " AND (description LIKE '%" + postData.filter.description + "%')";
        }
        if (postData.filter.status) {
            whereCondition += " AND (status LIKE '%" + postData.filter.status + "%')";
        }
        if (postData.filter.created_on) {
            whereCondition += " AND (created_on = '" + postData.filter.created_on + "')";
        }
        
        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount FROM tg_master_product_category WHERE  deleted = ? " + whereCondition
        var filter = [0];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if (res.length) {
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


Master.getProductCategoryList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if (postData.filter.search) {
            whereCondition += " AND (name LIKE '%" + postData.filter.search + "%'  OR code LIKE '%" + postData.filter.search + "%' OR description LIKE '%" + postData.filter.search + "%')";
        }
        if (postData.filter.name) {
            whereCondition += " AND (name LIKE '%" + postData.filter.name + "%')";
        }
        if (postData.filter.code) {
            whereCondition += " AND (code LIKE '%" + postData.filter.code + "%')";
        }
        if (postData.filter.description) {
            whereCondition += " AND (description LIKE '%" + postData.filter.description + "%')";
        }
        if (postData.filter.status) {
            whereCondition += " AND (status LIKE '%" + postData.filter.status + "%')";
        }
        if (postData.filter.created_on) {
            whereCondition += " AND (created_on = '" + postData.filter.created_on + "')";
        }
        
        var queryString = "SELECT tg_master_product_category.*,  IF(tg_master_product_category.filename != '',CONCAT('" + postData.image_app_path + "', tg_master_product_category.filename), '') as filename_path FROM tg_master_product_category WHERE  deleted = ? " + whereCondition + " ORDER BY tg_master_product_category.name ASC LIMIT ? OFFSET ? ";
        var filter = [0, postData.limit, postData.start];
        
        console.log('queryString', queryString);
        console.log('filter', filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Master.addProductCategoryData = function (postData) {
    console.log("data", postData)
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            name: postData.name ? postData.name : '',
            code: postData.code ? postData.code : '',
            description: postData.description ? postData.description : '',
            filename: postData.image_path ? postData.image_path : '',
            status: postData.status ? postData.status : 0,
            updated_on: nowDateTime,
            created_on: nowDateTime
        }
        // console.log("data", insertData)
        
        var queryString = "INSERT INTO tg_master_product_category set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Master.updateProductCategoryData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            name: postData.name ? postData.name : '',
            code: postData.code ? postData.code : '',
            description: postData.description ? postData.description : '',
            filename: postData.image_path ? postData.image_path : '',
            status: postData.status ? postData.status : 0,
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_master_product_category", updateDataValues, postData.category_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Master.deleteProductCategoryData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            deleted: 1,
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_master_product_category", updateDataValues, postData.category_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};

Master.getProductCategoryDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT *  FROM tg_master_product_category WHERE  id = ? ";
        var filter = [postData.category_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if (res.length) {
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};

// Product category end

// Product Type Start

Master.getProductTypeCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if (postData.filter.search) {
            whereCondition += " AND (name LIKE '%" + postData.filter.search + "%'  OR code LIKE '%" + postData.filter.search + "%' OR description LIKE '%" + postData.filter.search + "%')";
        }
        if (postData.filter.name) {
            whereCondition += " AND (name LIKE '%" + postData.filter.name + "%')";
        }
        if (postData.filter.code) {
            whereCondition += " AND (code LIKE '%" + postData.filter.code + "%')";
        }
        if (postData.filter.description) {
            whereCondition += " AND (description LIKE '%" + postData.filter.description + "%')";
        }
        if (postData.filter.status) {
            whereCondition += " AND (status LIKE '%" + postData.filter.status + "%')";
        }
        if (postData.filter.created_on) {
            whereCondition += " AND (created_on = '" + postData.filter.created_on + "')";
        }
        
        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount FROM tg_master_product_type WHERE  deleted = ? " + whereCondition
        var filter = [0];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if (res.length) {
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


Master.getProductTypeList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if (postData.filter.search) {
            whereCondition += " AND (name LIKE '%" + postData.filter.search + "%'  OR code LIKE '%" + postData.filter.search + "%' OR description LIKE '%" + postData.filter.search + "%')";
        }
        if (postData.filter.name) {
            whereCondition += " AND (name LIKE '%" + postData.filter.name + "%')";
        }
        if (postData.filter.code) {
            whereCondition += " AND (code LIKE '%" + postData.filter.code + "%')";
        }
        if (postData.filter.description) {
            whereCondition += " AND (description LIKE '%" + postData.filter.description + "%')";
        }
        if (postData.filter.status) {
            whereCondition += " AND (status LIKE '%" + postData.filter.status + "%')";
        }
        if (postData.filter.created_on) {
            whereCondition += " AND (created_on = '" + postData.filter.created_on + "')";
        }
        
        var queryString = "SELECT tg_master_product_type.* FROM tg_master_product_type WHERE  deleted = ? " + whereCondition + " ORDER BY tg_master_product_type.name ASC LIMIT ? OFFSET ? ";
        var filter = [0, postData.limit, postData.start];
        
        console.log('queryString', queryString);
        console.log('filter', filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};

Master.addProductTypeData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            name: postData.name ? postData.name : '',
            code: postData.code ? postData.code : '',
            description: postData.description ? postData.description : '',
            status: postData.status ? postData.status : 0,
            updated_on: nowDateTime,
            created_on: nowDateTime
        }
        
        var queryString = "INSERT INTO tg_master_product_type set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};

Master.updateProductTypeData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            name: postData.name ? postData.name : '',
            code: postData.code ? postData.code : '',
            description: postData.description ? postData.description : '',
            status: postData.status ? postData.status : 0,
            updated_on: nowDateTime,
        }
        console.log(postData)
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_master_product_type", updateDataValues, postData.type_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};

Master.getProductTypeDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT *  FROM tg_master_product_type WHERE  id = ? ";
        var filter = [postData.type_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if (res.length) {
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};

Master.deleteProductTypeData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            deleted: 1,
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_master_product_type", updateDataValues, postData.id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};

// Product Type End

// Product Size Start

Master.addProductSizeData = function (postData) {
    return new Promise(function (resolve, reject) {
        console.log("postData", postData)
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            size: postData.size ? postData.size : '',
            rate: postData.rate ? postData.rate : '',
            description: postData.description ? postData.description : '',
            status: postData.status ? postData.status : 0,
            updated_on: nowDateTime,
            created_on: nowDateTime
        }
        
        var queryString = "INSERT INTO tg_master_product_size set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};

Master.updateProductSizeData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            size: postData.size ? postData.size : '',
            rate: postData.rate ? postData.rate : '',
            description: postData.description ? postData.description : '',
            status: postData.status ? postData.status : 0,
            updated_on: nowDateTime,
        }
        console.log(postData)
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_master_product_size", updateDataValues, postData.size_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};

Master.deleteProductSizeData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            deleted: 1,
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_master_product_size", updateDataValues, postData.size_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Master.getProductSizeDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT *  FROM tg_master_product_size WHERE  id = ? ";
        var filter = [postData.size_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if (res.length) {
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};

// Product Color Start

Master.getProductColorCount = function (postData) {
    // console.log("data",postData)
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if (postData.filter.search) {
            whereCondition += " AND (name LIKE '%" + postData.filter.search + "%'  OR code LIKE '%" + postData.filter.search + "%' OR description LIKE '%" + postData.filter.search + "%')";
        }
        if (postData.filter.name) {
            whereCondition += " AND (name LIKE '%" + postData.filter.name + "%')";
        }
        if (postData.filter.code) {
            whereCondition += " AND (code LIKE '%" + postData.filter.code + "%')";
        }
        if (postData.filter.description) {
            whereCondition += " AND (description LIKE '%" + postData.filter.description + "%')";
        }
        if (postData.filter.status) {
            whereCondition += " AND (status LIKE '%" + postData.filter.status + "%')";
        }
        if (postData.filter.created_on) {
            whereCondition += " AND (created_on = '" + postData.filter.created_on + "')";
        }
        
        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount FROM tg_master_product_color WHERE  1 = 1 AND deleted = 0" + whereCondition
        var filter = [];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if (res.length) {
                    data = res[0].totalCount;
                }
                console.log("data: ", data);
                resolve(data);
            }
        });
    });
};

Master.getProductColorList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if (postData.filter.search) {
            whereCondition += " AND (name LIKE '%" + postData.filter.search + "%'  OR code LIKE '%" + postData.filter.search + "%' OR description LIKE '%" + postData.filter.search + "%')";
        }
        if (postData.filter.name) {
            whereCondition += " AND (name LIKE '%" + postData.filter.name + "%')";
        }
        if (postData.filter.code) {
            whereCondition += " AND (code LIKE '%" + postData.filter.code + "%')";
        }
        if (postData.filter.description) {
            whereCondition += " AND (description LIKE '%" + postData.filter.description + "%')";
        }
        if (postData.filter.status) {
            whereCondition += " AND (status LIKE '%" + postData.filter.status + "%')";
        }
        if (postData.filter.created_on) {
            whereCondition += " AND (created_on = '" + postData.filter.created_on + "')";
        }
        
        var queryString = "SELECT *  FROM tg_master_product_color WHERE  1 = 1 AND deleted = 0" + whereCondition + " ORDER BY status DESC, name ASC LIMIT ? OFFSET ? ";
        var filter = [postData.limit, postData.start];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};

Master.addProductColorData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            name: postData.name ? postData.name : '',
            code: postData.code ? postData.code : '',
            description: postData.description ? postData.description : '',
            status: postData.status ? postData.status : 0,
            updated_on: nowDateTime,
            created_on: nowDateTime
        }
        
        var queryString = "INSERT INTO tg_master_product_color set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Master.updateProductColorData = function (postData) {
    // console.log("postdata",postData)
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            name: postData.name ? postData.name : '',
            code: postData.code ? postData.code : '',
            description: postData.description ? postData.description : '',
            status: postData.status ? postData.status : 0,
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_master_product_color", updateDataValues, postData.color_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};

Master.deleteProductColorData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            deleted: 1,
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_master_product_color", updateDataValues, postData.color_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};

Master.getProductColorDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        
        var queryString = "SELECT *  FROM tg_master_product_attributes WHERE  product_id = ? ";
        var filter = [postData.product_id];
        
        console.log('queryString',queryString);
        console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};
Master.getProductImageDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        
        var queryString = "SELECT *  FROM tg_master_product_image WHERE  product_id = ? AND status = ? AND deleted = ? ";
        var filter = [postData.product_id,1,0];
        
        console.log('queryString',queryString);
        console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};
// Product unit start

Master.getProductUnitCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if (postData.filter.search) {
            whereCondition += " AND (name LIKE '%" + postData.filter.search + "%'  OR code LIKE '%" + postData.filter.search + "%' OR description LIKE '%" + postData.filter.search + "%')";
        }
        if (postData.filter.name) {
            whereCondition += " AND (name LIKE '%" + postData.filter.name + "%')";
        }
        if (postData.filter.code) {
            whereCondition += " AND (code LIKE '%" + postData.filter.code + "%')";
        }
        if (postData.filter.description) {
            whereCondition += " AND (description LIKE '%" + postData.filter.description + "%')";
        }
        if (postData.filter.status) {
            whereCondition += " AND (status LIKE '%" + postData.filter.status + "%')";
        }
        if (postData.filter.created_on) {
            whereCondition += " AND (created_on = '" + postData.filter.created_on + "')";
        }
        
        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount FROM tg_master_product_unit WHERE  1 = 1 AND deleted = 0" + whereCondition
        var filter = [];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if (res.length) {
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


Master.getProductUnitList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if (postData.filter.search) {
            whereCondition += " AND (name LIKE '%" + postData.filter.search + "%'  OR code LIKE '%" + postData.filter.search + "%' OR description LIKE '%" + postData.filter.search + "%')";
        }
        if (postData.filter.name) {
            whereCondition += " AND (name LIKE '%" + postData.filter.name + "%')";
        }
        if (postData.filter.code) {
            whereCondition += " AND (code LIKE '%" + postData.filter.code + "%')";
        }
        if (postData.filter.description) {
            whereCondition += " AND (description LIKE '%" + postData.filter.description + "%')";
        }
        if (postData.filter.status) {
            whereCondition += " AND (status LIKE '%" + postData.filter.status + "%')";
        }
        if (postData.filter.created_on) {
            whereCondition += " AND (created_on = '" + postData.filter.created_on + "')";
        }
        
        var queryString = "SELECT *  FROM tg_master_product_unit WHERE  1 = 1 AND deleted = 0" + whereCondition + " ORDER BY status DESC, name ASC LIMIT ? OFFSET ? ";
        var filter = [postData.limit, postData.start];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



Master.addProductUnitData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            name: postData.name ? postData.name : '',
            code: postData.code ? postData.code : '',
            description: postData.description ? postData.description : '',
            status: postData.status ? postData.status : 0,
            updated_on: nowDateTime,
            created_on: nowDateTime
        }
        
        var queryString = "INSERT INTO tg_master_product_unit set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Master.updateProductUnitData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            name: postData.name ? postData.name : '',
            code: postData.code ? postData.code : '',
            description: postData.description ? postData.description : '',
            status: postData.status ? postData.status : 0,
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_master_product_unit", updateDataValues, postData.unit_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};

Master.deleteProductUnitData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            deleted: 1,
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_master_product_unit", updateDataValues, postData.unit_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};

Master.getProductUnitDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        
        var queryString = "SELECT *  FROM tg_master_product_unit WHERE  id = ? ";
        var filter = [postData.unit_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {}
                if (res.length) {
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};


// Product unit end

Master.getBeatListCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if (postData.filter.created_on) {
            whereCondition += " AND (created_on = '" + postData.filter.created_on + "')";
        }
        
        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount FROM tg_beat_plan WHERE  1 = 1 AND deleted = 0" + whereCondition
        var filter = [];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if (res.length) {
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


Master.getBeatList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if (postData.filter.created_on) {
            whereCondition += " AND (created_on = '" + postData.filter.created_on + "')";
        }
        
        var queryString = "SELECT *  FROM tg_beat_plan WHERE  1 = 1 AND deleted = 0" + whereCondition + "  LIMIT ? OFFSET ? ";
        var filter = [postData.limit, postData.start];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                // resolve(res);
                var i = res.length - 1;
                if (res.length) {
                    res.forEach(x => {
                        x.encrypt_id = encrypt(x.id.toString());
                        if (i == 0) {
                            resolve(res);
                        }
                        i--;
                    });
                } else {
                    resolve(res);
                }
            }
        });
    });
};


Master.getBeatPlanData = function (postData) {
    return new Promise(function (resolve, reject) {
        var whereCondition = '';
        // if(postData.date){
        //     whereCondition += " AND (DATE_FORMAT(tg_beat_plan_detail.beat_date,'%Y-%m-%d') = '"+postData.date+"')"; 
        // }
        if (postData.date) {
            postData.date = moment(postData.date).format('YYYY-MM-DD');
            whereCondition += " AND (beat_date = '" + postData.date + "')";
        }
        if (postData?.beat_plan_id) {
            // postData.beat_plan_id = decrypt(postData.beat_plan_id);
            whereCondition += " AND (beat_plan_id = '" + postData.beat_plan_id + "')";
        }
        
        
        if (postData?.beat_detail?.beat_name) {
            whereCondition += " AND (tg_beat_plan_detail.beat_name LIKE '%" + postData.beat_detail.beat_name + "%')";
        }
        
        if (postData?.beat_detail?.user_name) {
            whereCondition += " AND (tg_beat_plan_detail.user_name LIKE '%" + postData.beat_detail.user_name + "%')";
        }
        
        if (postData?.beat_detail?.beat_date) {
            whereCondition += " AND (DATE(tg_beat_plan_detail.beat_date) = '" + moment(postData.beat_detail.beat_date).format('YYYY-MM-DD') + "')";
        }
        
        var queryString = "SELECT *  FROM tg_beat_plan_detail WHERE  1 = 1 AND deleted = 0" + whereCondition + " ORDER BY tg_beat_plan_detail.beat_date ASC";
        var filter = [];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Master.checkSalesUserAlreadyAssign = function (postData) {
    return new Promise(function (resolve, reject) {
        var beat_plan_month = moment(postData.beat_plan_date).format('YYYY-MM');
        // return false;
        var whereCondition = '';
        
        var queryString = "SELECT id  FROM tg_beat_plan WHERE  1 = 1 AND deleted = 0 AND user_id = ? AND beat_plan_month = ?" + whereCondition + "";
        var filter = [postData.user_id, beat_plan_month];
        
        console.log('queryString', queryString);
        console.log('filter', filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if (res.length) {
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};

Master.addBeatData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        var beat_plan_month = postData.Date;
        var newdate = moment(beat_plan_month).format('YYYY-MM');
        // return false;
        var insertData = {
            beat_plan_month: newdate ? newdate : '',
            user_id: postData.user_id ? postData.user_id : '',
            user_name: postData.user_name ? postData.user_name : '',
            user_role: postData.user_role ? postData.user_role : 0,
            user_role_name: postData.role_name ? postData.role_name : 0,
            created_by: postData.sfa_web_user_id ? postData.sfa_web_user_id : 0,
            created_by_name: postData.sfa_web_user_name ? postData.sfa_web_user_name : '',
            created_on: nowDateTime,
        }
        
        var queryString = "INSERT INTO tg_beat_plan set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};

Master.addBeatDetailData = function (postData) {
    return new Promise(function (resolve, reject) {
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        postData.beat_plan_date = moment(postData.beat_plan_date).format('YYYY-MM-DD');
        const valueData = [];
        
        postData.beat_data.forEach(x => {
            valueData.push([postData.beat_plan_id ? postData.beat_plan_id : 0, x ? x : '', postData.description ? postData.description : '', postData.user_id ? postData.user_id : 0, postData.user_name ? postData.user_name : '', postData.beat_plan_date ? postData.beat_plan_date : '', postData.sfa_web_user_name ? postData.sfa_web_user_name : '', postData.sfa_web_user_id ? postData.sfa_web_user_id : 0, nowDateTime]);
        });
        
        var queryString = "INSERT INTO tg_beat_plan_detail (beat_plan_id, beat_name, description, user_id, user_name, beat_date, created_by_name, created_by, created_on) VALUES ?";
        
        db.query(queryString, [valueData], function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};

Master.deleteBeatData = function (postData) {
    console.log('postData==>', postData);
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            deleted: 1,
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_beat_plan", updateDataValues, postData.beat_plan_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};

Master.deleteBeatPlanData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            deleted: 1,
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_beat_plan_detail", updateDataValues, postData.id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};

Master.updateBeatData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            updated_by: postData.sfa_web_user_id ? postData.sfa_web_user_id : 0,
            updated_by_name: postData.sfa_web_user_name ? postData.sfa_web_user_name : '',
            updated_on: nowDateTime
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?"
        var filter = ["tg_beat_plan", updateDataValues, postData.beat_plan_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};

// Product hsn start

Master.getProductHsnCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if (postData.filter.search) {
            whereCondition += " AND (name LIKE '%" + postData.filter.search + "%'  OR code LIKE '%" + postData.filter.search + "%' OR description LIKE '%" + postData.filter.search + "%')";
        }
        if (postData.filter.name) {
            whereCondition += " AND (name LIKE '%" + postData.filter.name + "%')";
        }
        if (postData.filter.code) {
            whereCondition += " AND (code LIKE '%" + postData.filter.code + "%')";
        }
        if (postData.filter.description) {
            whereCondition += " AND (description LIKE '%" + postData.filter.description + "%')";
        }
        if (postData.filter.status) {
            whereCondition += " AND (status LIKE '%" + postData.filter.status + "%')";
        }
        if (postData.filter.created_on) {
            whereCondition += " AND (created_on = '" + postData.filter.created_on + "')";
        }
        
        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount FROM tg_master_hsn WHERE  1 = 1" + whereCondition
        var filter = [];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if (res.length) {
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


Master.getProductHsnList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if (postData.filter.search) {
            whereCondition += " AND (name LIKE '%" + postData.filter.search + "%'  OR code LIKE '%" + postData.filter.search + "%' OR description LIKE '%" + postData.filter.search + "%')";
        }
        if (postData.filter.name) {
            whereCondition += " AND (name LIKE '%" + postData.filter.name + "%')";
        }
        if (postData.filter.code) {
            whereCondition += " AND (code LIKE '%" + postData.filter.code + "%')";
        }
        if (postData.filter.description) {
            whereCondition += " AND (description LIKE '%" + postData.filter.description + "%')";
        }
        if (postData.filter.status) {
            whereCondition += " AND (status LIKE '%" + postData.filter.status + "%')";
        }
        if (postData.filter.created_on) {
            whereCondition += " AND (created_on = '" + postData.filter.created_on + "')";
        }
        
        var queryString = "SELECT *  FROM tg_master_hsn WHERE  1 = 1 " + whereCondition + " ORDER BY status DESC, name ASC LIMIT ? OFFSET ? ";
        var filter = [postData.limit, postData.start];
        
        console.log('queryString', queryString);
        console.log('filter', filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



Master.addProductHsnData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            name: postData.name ? postData.name : '',
            code: postData.code ? postData.code : '',
            description: postData.description ? postData.description : '',
            status: postData.status ? postData.status : 0,
            updated_on: nowDateTime,
            created_on: nowDateTime
        }
        
        var queryString = "INSERT INTO tg_master_hsn set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Master.updateProductHsnData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            name: postData.name ? postData.name : '',
            code: postData.code ? postData.code : '',
            description: postData.description ? postData.description : '',
            status: postData.status ? postData.status : 0,
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_master_hsn", updateDataValues, postData.hsn_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Master.getHsnDetail = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT *  FROM tg_master_hsn WHERE id = ? ";
        var filter = [postData.hsn_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if (res.length) {
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};


// Product hsn end



Master.getProductSizeCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if (postData.filter.search) {
            whereCondition += " AND (name LIKE '%" + postData.filter.search + "%'  OR code LIKE '%" + postData.filter.search + "%' OR description LIKE '%" + postData.filter.search + "%')";
        }
        
        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount FROM tg_master_product_size WHERE  1 = 1 AND deleted = 0" + whereCondition
        var filter = [];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if (res.length) {
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


Master.getProductSizeList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        // if(postData.filter.search){
        //     whereCondition += " AND (name LIKE '%"+postData.filter.search+"%'  OR code LIKE '%"+postData.filter.search+"%' OR description LIKE '%"+postData.filter.search+"%')"; 
        // }
        
        var queryString = "SELECT *  FROM tg_master_product_size WHERE  1 = 1 AND deleted = 0" + whereCondition + " ORDER BY size ASC LIMIT ? OFFSET ? ";
        var filter = [postData.limit, postData.start];
        
        console.log('queryString', queryString);
        console.log('filter', filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};




Master.getProductThicknessCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if (postData.filter.search) {
            whereCondition += " AND (name LIKE '%" + postData.filter.search + "%'  OR code LIKE '%" + postData.filter.search + "%' OR description LIKE '%" + postData.filter.search + "%')";
        }
        
        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount FROM tg_master_product_thickness WHERE  1 = 1 " + whereCondition
        var filter = [];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if (res.length) {
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


Master.getProductThicknessList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if (postData.filter.search) {
            whereCondition += " AND (name LIKE '%" + postData.filter.search + "%'  OR code LIKE '%" + postData.filter.search + "%' OR description LIKE '%" + postData.filter.search + "%')";
        }
        
        var queryString = "SELECT *  FROM tg_master_product_thickness WHERE  1 = 1 " + whereCondition + " ORDER BY name ASC LIMIT ? OFFSET ? ";
        var filter = [postData.limit, postData.start];
        
        console.log('queryString', queryString);
        console.log('filter', filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};




// role module start

Master.getRoleCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if (postData.filter.search) {
            whereCondition += " AND (name LIKE '%" + postData.filter.search + "%')";
        }
        if (postData.filter.name) {
            whereCondition += " AND (name LIKE '%" + postData.filter.name + "%')";
        }
        
        if (postData.filter.for_system_user) {
            whereCondition += " AND (for_system_user = '" + postData.filter.for_system_user + "')";
        }
        
        
        if (postData.filter.for_sales_user) {
            whereCondition += " AND (for_sales_user = '" + postData.filter.for_sales_user + "')";
        }
        
        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount FROM tg_master_role WHERE  status = 1 " + whereCondition
        var filter = [];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if (res.length) {
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


Master.getRoleListData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if (postData.filter.search) {
            whereCondition += " AND (name LIKE '%" + postData.filter.search + "%')";
        }
        
        if (postData.filter.name) {
            whereCondition += " AND (name LIKE '%" + postData.filter.name + "%')";
        }
        
        if (postData.filter.for_system_user) {
            whereCondition += " AND (for_system_user = '" + postData.filter.for_system_user + "')";
        }
        
        if (postData.filter.for_sales_user) {
            whereCondition += " AND (for_sales_user = '" + postData.filter.for_sales_user + "')";
        }
        
        var queryString = "SELECT *  FROM tg_master_role WHERE  status = 1 " + whereCondition + " ORDER BY status DESC, name ASC LIMIT ? OFFSET ? ";
        var filter = [postData.limit, postData.start];
        
        console.log('queryString', queryString);
        console.log('filter', filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



Master.addRoleData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            name: postData.name ? postData.name : '',
            status: postData.status ? postData.status : 0,
            for_system_user: postData.for_system_user ? postData.for_system_user : 0,
            for_sales_user: postData.for_sales_user ? postData.for_sales_user : 0,
            updated_on: nowDateTime,
            created_on: nowDateTime
        }
        
        var queryString = "INSERT INTO tg_master_role set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Master.updateRoleData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            name: postData.name ? postData.name : '',
            status: postData.status ? postData.status : 0,
            for_system_user: postData.for_system_user ? postData.for_system_user : 0,
            for_sales_user: postData.for_sales_user ? postData.for_sales_user : 0,
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_master_role", updateDataValues, postData.role_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Master.getRoleDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        
        var queryString = "SELECT *  FROM tg_master_role WHERE id = ?";
        var filter = [postData.role_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if (res.length) {
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};


// role module end



// postal master code start


Master.getPostalMasterCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if (postData.filter.search) {
            whereCondition += " AND (state_name LIKE '%" + postData.filter.search + "%'  OR district_name LIKE '%" + postData.filter.search + "%' OR city LIKE '%" + postData.filter.search + "%')";
        }
        if (postData.filter.state_name) {
            whereCondition += " AND (state_name LIKE '%" + postData.filter.state_name + "%' )";
        }
        if (postData.filter.district_name) {
            whereCondition += " AND (district_name LIKE '%" + postData.filter.district_name + "%' )";
        }
        if (postData.filter.city) {
            whereCondition += " AND (city LIKE '%" + postData.filter.city + "%' )";
        }
        if (postData.filter.area) {
            whereCondition += " AND (area LIKE '%" + postData.filter.area + "%' )";
        }
        if (postData.filter.zone) {
            whereCondition += " AND (zone LIKE '%" + postData.filter.zone + "%' )";
        }
        if (postData.filter.beat) {
            whereCondition += " AND (beat LIKE '%" + postData.filter.beat + "%' )";
        }
        if (postData.filter.pincode) {
            whereCondition += " AND (pincode LIKE '%" + postData.filter.pincode + "%' )";
        }
        
        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount FROM tg_master_postal WHERE  1 = 1 " + whereCondition
        var filter = [];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if (res.length) {
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


Master.getPostalMasterList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if (postData.filter.search) {
            whereCondition += " AND (state_name LIKE '%" + postData.filter.search + "%'  OR district_name LIKE '%" + postData.filter.search + "%' OR city LIKE '%" + postData.filter.search + "%')";
        }
        if (postData.filter.state_name) {
            whereCondition += " AND (state_name LIKE '%" + postData.filter.state_name + "%' )";
        }
        if (postData.filter.district_name) {
            whereCondition += " AND (district_name LIKE '%" + postData.filter.district_name + "%' )";
        }
        if (postData.filter.city) {
            whereCondition += " AND (city LIKE '%" + postData.filter.city + "%' )";
        }
        if (postData.filter.area) {
            whereCondition += " AND (area LIKE '%" + postData.filter.area + "%' )";
        }
        if (postData.filter.zone) {
            whereCondition += " AND (zone LIKE '%" + postData.filter.zone + "%' )";
        }
        if (postData.filter.beat) {
            whereCondition += " AND (beat LIKE '%" + postData.filter.beat + "%' )";
        }
        if (postData.filter.pincode) {
            whereCondition += " AND (pincode LIKE '%" + postData.filter.pincode + "%' )";
        }
        
        
        var queryString = "SELECT *  FROM tg_master_postal WHERE  1 = 1 " + whereCondition + " ORDER BY state_name ASC LIMIT ? OFFSET ? ";
        var filter = [postData.limit, postData.start];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};




Master.getPostalStateList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if (postData.filter.state_name) {
            whereCondition += " AND (state_name LIKE '%" + postData.filter.state_name + "%' )";
        }
        
        var queryString = "SELECT state_name  FROM tg_master_postal WHERE   1 = 1 AND status = 1 AND deleted = 0  " + whereCondition + " GROUP BY state_name ORDER BY state_name ASC";
        var filter = [];
        
        console.log('queryString', queryString);
        console.log('filter', filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Master.getPostalDistrictList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if (postData.filter.state_name) {
            whereCondition += " AND (state_name LIKE '%" + postData.filter.state_name + "%' )";
        }
        
        if (postData.filter.state_name_array?.length) {
            whereCondition += " AND (state_name IN (" + postData.filter.state_name_array + ") )";
        }
        
        var queryString = "SELECT district_name , state_name FROM tg_master_postal WHERE  1 = 1 AND status = 1 AND deleted = 0  " + whereCondition + " GROUP BY district_name ORDER BY district_name ASC";
        var filter = [];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Master.getPostalCityList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if (postData.filter.state_name) {
            whereCondition += " AND (state_name LIKE '%" + postData.filter.state_name + "%' )";
        }
        if (postData.filter.district_name) {
            whereCondition += " AND (district_name LIKE '%" + postData.filter.district_name + "%' )";
        }
        
        var queryString = "SELECT city  FROM tg_master_postal WHERE  1 = 1 AND status = 1 AND deleted = 0  " + whereCondition + " GROUP BY city ORDER BY city ASC";
        var filter = [];
        
        console.log('queryString', queryString);
        console.log('filter', filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Master.getPostalAreaList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if (postData.filter.state_name) {
            whereCondition += " AND (state_name LIKE '%" + postData.filter.state_name + "%' )";
        }
        if (postData.filter.district_name) {
            whereCondition += " AND (district_name LIKE '%" + postData.filter.district_name + "%' )";
        }
        if (postData.filter.city) {
            whereCondition += " AND (city LIKE '%" + postData.filter.city + "%' )";
        }
        
        var queryString = "SELECT area  FROM tg_master_postal WHERE  1 = 1 AND status = 1 AND deleted = 0  " + whereCondition + " GROUP BY area ORDER BY area ASC";
        var filter = [];
        
        console.log('queryString', queryString);
        console.log('filter', filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Master.getPostalZoneList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if (postData.filter.state_name) {
            whereCondition += " AND (state_name LIKE '%" + postData.filter.state_name + "%' )";
        }
        if (postData.filter.district_name) {
            whereCondition += " AND (district_name LIKE '%" + postData.filter.district_name + "%' )";
        }
        if (postData.filter.city) {
            whereCondition += " AND (city LIKE '%" + postData.filter.city + "%' )";
        }
        if (postData.filter.area) {
            whereCondition += " AND (area LIKE '%" + postData.filter.area + "%' )";
        }
        
        var queryString = "SELECT zone  FROM tg_master_postal WHERE  1 = 1 AND status = 1 AND deleted = 0  " + whereCondition + " AND zone IS NOT NULL GROUP BY zone ORDER BY zone ASC";
        var filter = [];
        
        console.log('queryString', queryString);
        console.log('filter', filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};

Master.getPostalBeatList = function (postData) {
    console.log(postData)
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if (postData.filter.state_name) {
            whereCondition += " AND (state_name LIKE '%" + postData.filter.state_name + "%' )";
        }
        if (postData.filter.district_name) {
            whereCondition += " AND (district_name LIKE '%" + postData.filter.district_name + "%' )";
        }
        if (postData.filter.city) {
            whereCondition += " AND (city LIKE '%" + postData.filter.city + "%' )";
        }
        if (postData.filter.area) {
            whereCondition += " AND (area LIKE '%" + postData.filter.area + "%' )";
        }
        if (postData.filter.zone) {
            whereCondition += " AND (zone LIKE '%" + postData.filter.zone + "%' )";
        }
        
        var queryString = "SELECT beat  FROM tg_master_postal WHERE  1 = 1 AND status = 1 AND deleted = 0  " + whereCondition + " AND beat IS NOT NULL GROUP BY beat ORDER BY beat ASC";
        var filter = [];
        
        console.log('queryString', queryString);
        console.log('filter', filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Master.getPostalPincodeList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if (postData.filter.state_name) {
            whereCondition += " AND (state_name LIKE '%" + postData.filter.state_name + "%' )";
        }
        if (postData.filter.district_name) {
            whereCondition += " AND (district_name LIKE '%" + postData.filter.district_name + "%' )";
        }
        if (postData.filter.city) {
            whereCondition += " AND (city LIKE '%" + postData.filter.city + "%' )";
        }
        if (postData.filter.area) {
            whereCondition += " AND (area LIKE '%" + postData.filter.area + "%' )";
        }
        if (postData.filter.zone) {
            whereCondition += " AND (zone LIKE '%" + postData.filter.zone + "%' )";
        }
        
        var queryString = "SELECT pincode  FROM tg_master_postal WHERE   1 = 1 AND status = 1 AND deleted = 0 " + whereCondition + " GROUP BY pincode ORDER BY pincode ASC";
        var filter = [];
        
        console.log('queryString', queryString);
        console.log('filter', filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



Master.getDetailByPincode = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        if (postData.filter.pincode) {
            whereCondition += " AND (pincode LIKE '%" + postData.filter.pincode + "%' )";
        }
        
        var queryString = "SELECT *  FROM tg_master_postal WHERE  1 = 1 AND status = 1 AND deleted = 0  " + whereCondition + " GROUP BY id ORDER BY id ASC";
        var filter = [];
        
        console.log('queryString', queryString);
        console.log('filter', filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



Master.getPostalMasterDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT *  FROM tg_master_postal WHERE  id = ?";
        var filter = [postData.postal_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if (res.length) {
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};


Master.addPostalMasterData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            state_name: postData.state_name ? postData.state_name : '',
            district_name: postData.district_name ? postData.district_name : '',
            city: postData.city ? postData.city : '',
            area: postData.area ? postData.area : '',
            zone: postData.zone ? postData.zone : '',
            beat: postData.beat ? postData.beat : '',
            pincode: postData.pincode ? postData.pincode : '',
            status: postData.status ? postData.status : 1,
            created_on: nowDateTime
        }
        
        var queryString = "INSERT INTO tg_master_postal set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Master.updatePostalMasterData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            area: postData.area ? postData.area : '',
            zone: postData.zone ? postData.zone : '',
            beat: postData.beat ? postData.beat : '',
            pincode: postData.pincode ? postData.pincode : '',
            status: postData.status ? postData.status : 0,
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_master_postal", updateDataValues, postData.postal_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



// postal master code end



// product master code start





Master.getProductCodeList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        var queryString = "SELECT tg_master_product.id,tg_master_product.product_name,tg_master_product.product_code,tg_master_product.product_category, tg_master_product.architect_point,  tg_master_product.carpenter_point,tg_master_product.retailer_point,tg_master_product.distributor_point,tg_master_product.sales_user_point ,  tg_master_product.dealer_point FROM tg_master_product WHERE status = 1 AND deleted = 0 GROUP BY tg_master_product.product_code ORDER BY ID DESC";
        var filter = [1,0];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var i = res.length - 1;
                if (res.length) {
                    res.forEach(x => {
                        x.encrypt_id = encrypt(x.id.toString());
                        if (i == 0) {
                            resolve(res);
                        }
                        i--;
                    });
                } else {
                    resolve(res);
                }
            }
        });
    });
};



Master.getProductCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if (postData.filter.search) {
            whereCondition += " AND (product_name LIKE '%" + postData.filter.search + "%'  OR product_code LIKE '%" + postData.filter.search + "%' OR product_group LIKE '%" + postData.filter.search + "%' OR description LIKE '%" + postData.filter.search + "%')";
        }
        
        if (postData.filter.product_name) {
            whereCondition += " AND (tg_master_product.product_name LIKE '%" + postData.filter.product_name + "%')";
        }
        
        
        if (postData.filter.product_code) {
            whereCondition += " AND (tg_master_product.product_code LIKE '%" + postData.filter.product_code + "%')";
        }
        
        
        if (postData.filter.brand) {
            whereCondition += " AND (tg_master_product.brand LIKE '%" + postData.filter.brand + "%')";
        }
        
        if (postData.filter.product_category) {
            whereCondition += " AND (tg_master_product.product_category LIKE '%" + postData.filter.product_category + "%')";
        }
        
        if (postData.filter.product_group) {
            whereCondition += " AND (tg_master_product.product_group LIKE '%" + postData.filter.product_group + "%')";
        }
        
        
        if (postData.filter.size) {
            whereCondition += " AND (tg_master_product.size LIKE '%" + postData.filter.size + "%')";
        }
        
        if (postData.filter.hsn_code) {
            whereCondition += " AND (tg_master_product.hsn_code LIKE '%" + postData.filter.hsn_code + "%')";
        }
        
        if (postData.filter.description) {
            whereCondition += " AND (description LIKE '%" + postData.filter.description + "%')";
        }
        if (postData.filter.status) {
            whereCondition += " AND (status LIKE '%" + postData.filter.status + "%')";
        }
        if (postData.filter.created_on) {
            whereCondition += " AND (DATE(tg_master_product.created_on) = '" + moment(new Date(postData.filter.created_on)).format('YYYY-MM-DD') + "')";
        }
        
        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount FROM tg_master_product WHERE  deleted = ? " + whereCondition
        var filter = [0];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if (res.length) {
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


Master.getProductList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if (postData.filter.search) {
            whereCondition += " AND (product_name LIKE '%" + postData.filter.search + "%'  OR product_code LIKE '%" + postData.filter.search + "%' OR product_group LIKE '%" + postData.filter.search + "%' OR description LIKE '%" + postData.filter.search + "%')";
        }
        
        if (postData.filter.product_name) {
            whereCondition += " AND (tg_master_product.product_name LIKE '%" + postData.filter.product_name + "%')";
        }
        
        
        if (postData.filter.product_code) {
            whereCondition += " AND (tg_master_product.product_code LIKE '%" + postData.filter.product_code + "%')";
        }
        
        
        if (postData.filter.brand) {
            whereCondition += " AND (tg_master_product.brand LIKE '%" + postData.filter.brand + "%')";
        }
        
        if (postData.filter.product_category) {
            whereCondition += " AND (tg_master_product.product_category LIKE '%" + postData.filter.product_category + "%')";
        }
        
        if (postData.filter.product_group) {
            whereCondition += " AND (tg_master_product.product_group LIKE '%" + postData.filter.product_group + "%')";
        }
        
        
        if (postData.filter.size) {
            whereCondition += " AND (tg_master_product.size LIKE '%" + postData.filter.size + "%')";
        }
        
        if (postData.filter.hsn_code) {
            whereCondition += " AND (tg_master_product.hsn_code LIKE '%" + postData.filter.hsn_code + "%')";
        }
        
        if (postData.filter.description) {
            whereCondition += " AND (description LIKE '%" + postData.filter.description + "%')";
        }
        if (postData.filter.batch_code) {
            whereCondition += " AND (batch_code LIKE '%" + postData.filter.batch_code + "%')";
        }
        if (postData.filter.status) {
            whereCondition += " AND (status LIKE '%" + postData.filter.status + "%')";
        }
        if (postData.filter.created_on) {
            whereCondition += " AND (DATE(tg_master_product.created_on) = '" + moment(new Date(postData.filter.created_on)).format('YYYY-MM-DD') + "')";
        }
        
        var queryString = "SELECT tg_master_product.*, IF(tg_master_product.product_image != '',CONCAT('" + postData.image_app_path + "', tg_master_product.product_image), '') as product_image_path from tg_master_product WHERE  deleted = ? " + whereCondition + " ORDER BY ID DESC LIMIT ? OFFSET ? ";
        var filter = [0, postData.limit, postData.start];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, async  function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var i = res.length - 1;
                if (res.length) {
                    res.forEach(async x => {
                        x.encrypt_id = encrypt(x.id.toString());

                        x.productDataDetail = await Master.getProductColorDetail({product_id : x.id})
                        x.productImageDetail = await Master.getProductImageDetail({product_id : x.id})
                        x.product_color = [];
                        if(x.productDataDetail?.length){
                            x.productDataDetail.map(y=>{
                                x.product_color.push(y.color)
                            })
                        }
                        x.product_image=[];
                    if(x.productImageDetail.length){
                        x.productImageDetail.map(m=>{
                            x.product_image.push(m.filename)
                        })
                    }

                        if (i == 0) {
                            resolve(res);
                        }
                        i--;
                    });
                } else {
                    resolve(res);
                }
            }
        });
    });
};



Master.addProductData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            product_name: postData.product_name ? postData.product_name : '',
            product_code: postData.product_code ? postData.product_code : '',
            product_category: postData.product_category ? postData.product_category : '',
            vendor_product_name: postData.vendor_product_name ? postData.vendor_product_name : '',
            vendor_product_code: postData.vendor_product_code ? postData.vendor_product_code : '',
            product_group: postData.product_group ? postData.product_group : '',
            rack_no: postData.rack_no ? postData.rack_no : '',
            unit: postData.product_unit ? postData.product_unit : '',
            brand: postData.brand ? postData.brand : '',
            size: postData.size ? postData.size : '',
            thickness: postData.thickness ? postData.thickness : '',
            sale_price: postData.sale_price ? postData.sale_price : 0,
            tax_percentage: postData.tax_percentage ? postData.tax_percentage : 0,
            discount_percentage: postData.discount_percentage ? postData.discount_percentage : 0,
            hsn_code: postData.hsn_code ? postData.hsn_code : '',
            stock_qty: postData.stock_qty ? postData.stock_qty : 0,
            min_qty: postData.min_qty ? postData.min_qty : 0,
            architect_point: postData.architect_point ? postData.architect_point : 0,
            dealer_point: postData.dealer_point ? postData.dealer_point : 0,
            carpenter_point: postData.carpenter_point ? postData.carpenter_point : 0,
            description: postData.description ? postData.description : '',
            retailer_point: postData.retailer_point ? postData.retailer_point : '',
            distributor_point: postData.distributor_point ? postData.distributor_point : '',
            sales_user_point: postData.sales_user_point ? postData.sales_user_point : '',
            batch_code : postData.batch_code ? postData.batch_code : '',
            length : postData.length ? postData.length : '',
            width : postData.width ? postData.width : '',
            height : postData.height ? postData.height : '',
            // product_image: postData.image_path ? postData.image_path : '',
            status: postData.status ? postData.status : 1,
            divison: postData.divison ? postData.divison : '',
            product_series : postData.product_series ? postData.product_series : '',
            packaging_inner : postData.packaging_inner ? postData.packaging_inner : '',
            packaging_outer : postData.packaging_outer ? postData.packaging_outer : '',
            updated_on: nowDateTime,
            created_on: nowDateTime
        }
        
        var queryString = "INSERT INTO tg_master_product set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                // console.log("data1234",res)
                resolve(res);
            }
        });
    });
};



Master.deleteAssignedColorData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            deleted: 1,
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE product_id = ?;"
        var filter = ["tg_master_product_attributes", updateDataValues, postData.product_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};
Master.deleteProductimage = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            deleted: 1,
            updated_on: nowDateTime,
            status: 0
        }
        
        var queryString = "UPDATE ?? SET ? WHERE product_id = ?;"
        var filter = ["tg_master_product_image", updateDataValues, postData.product_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Master.assigncolor = function (postData) {
    // console.log("postdata==>",postData)
    return new Promise(function (resolve, reject) {
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        var insertData = {
            product_id: postData.product_id ? postData.product_id : 0 ,
            color: postData.color ? postData.color : '',
            updated_on: nowDateTime,
            created_on: nowDateTime
        }
        console.log("inserteddata", insertData)
        
        var queryString = "INSERT INTO tg_master_product_attributes set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};
Master.addproductimage = function (postData) {
    // console.log("postdata==>",postData)
    return new Promise(function (resolve, reject) {
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        var insertData = {
            product_id: postData.product_id ? postData.product_id : 0 ,
            filename : postData.filename ? postData.filename:'',
            updated_on: nowDateTime,
            created_on: nowDateTime,
            status:1
        }
        console.log("inserteddata", insertData)
        
        var queryString = "INSERT INTO tg_master_product_image set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Master.updateProductData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            product_name: postData.product_name ? postData.product_name : '',
            product_code: postData.product_code ? postData.product_code : '',
            product_category: postData.product_category ? postData.product_category : '',
            vendor_product_name: postData.vendor_product_name ? postData.vendor_product_name : '',
            vendor_product_code: postData.vendor_product_code ? postData.vendor_product_code : '',
            product_group: postData.product_group ? postData.product_group : '',
            rack_no: postData.rack_no ? postData.rack_no : '',
            unit: postData.product_unit ? postData.product_unit : '',
            brand: postData.brand ? postData.brand : '',
            size: postData.size ? postData.size : '',
            thickness: postData.thickness ? postData.thickness : '',
            sale_price: postData.sale_price ? postData.sale_price : 0,
            tax_percentage: postData.tax_percentage ? postData.tax_percentage : 0,
            discount_percentage: postData.discount_percentage ? postData.discount_percentage : 0,
            hsn_code: postData.hsn_code ? postData.hsn_code : '',
            stock_qty: postData.stock_qty ? postData.stock_qty : 0,
            min_qty: postData.min_qty ? postData.min_qty : 0,
            architect_point: postData.architect_point ? postData.architect_point : 0,
            dealer_point: postData.dealer_point ? postData.dealer_point : 0,
            carpenter_point: postData.carpenter_point ? postData.carpenter_point : 0,
            description: postData.description ? postData.description : '',
            retailer_point: postData.retailer_point ? postData.retailer_point : '',
            distributor_point: postData.distributor_point ? postData.distributor_point : '',
            sales_user_point: postData.sales_user_point ? postData.sales_user_point : '',
            batch_code : postData.batch_code ? postData.batch_code : '',
            length : postData.length ? postData.length : '',
            width : postData.width ? postData.width : '',
            height : postData.height ? postData.height : '',
            // product_image: postData.image_path ? postData.image_path : '',
            status: postData.status ? postData.status : 1,
            divison: postData.divison ? postData.divison : '',
            product_series : postData.product_series ? postData.product_series : '',
            packaging_inner : postData.packaging_inner ? postData.packaging_inner : '',
            packaging_outer : postData.packaging_outer ? postData.packaging_outer : '',
            updated_on: nowDateTime,
        }
        

        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_master_product", updateDataValues, postData.product_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



Master.deleteProductData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            deleted: 1,
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_master_product", updateDataValues, postData.product_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



Master.getProductDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        // var queryString = "SELECT tg_master_product.*, IF(tg_master_product.product_image != '' ,CONCAT('" + postData.image_app_path + "', tg_master_product.product_image), '')  as product_image_path  FROM tg_master_product WHERE  id = ?";
        var queryString = "SELECT * from tg_master_product where id = ?"
        var filter = [postData.product_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter,async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if (res.length) {
                    data = res[0];
                    data.productDataDetail = await Master.getProductColorDetail({product_id : data.id})
                    data.productImageDetail = await Master.getProductImageDetail({product_id : data.id})
                    data.product_color = [];
                    if(data.productDataDetail.length){
                        data.productDataDetail.map(x=>{
                            data.product_color.push(x.color)
                        })
                    }
                    data.product_image=[];
                    if(data.productImageDetail.length){
                        data.productImageDetail.map(x=>{
                            data.product_image.push(x.filename)
                        })
                    }
                }
                resolve(data);
            }
        });
    });
};


Master.getProductColorDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT tg_master_product_attributes.*  FROM tg_master_product_attributes WHERE  product_id = ?";
        var filter = [postData.product_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



// product master code end



// feedback code start

Master.getFeedbackCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        if (postData.type == 'unread') {
            whereCondition += " AND (`read` = 0 AND created_by_type = 'lms')";
        } else if (postData.type == 'read') {
            whereCondition += " AND (`read` = 1 AND created_by_type = 'lms')";
        } else {
            whereCondition += " AND (1 = 1)";
        }
        
        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount FROM tg_chat_data WHERE  1 = 1 " + whereCondition + " GROUP BY customer_id";
        var filter = [];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res.length);
            }
        });
    });
};



Master.getFeedbackListCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        if (postData.filter.search) {
            whereCondition += " AND (tg_customer.first_name LIKE '%" + postData.filter.search + "%'  OR tg_customer.mobile LIKE '%" + postData.filter.search + "%' )";
        }
        if (postData.filter.name) {
            whereCondition += " AND (tg_customer.first_name LIKE '%" + postData.filter.name + "%')";
        }
        
        if (postData.filter.mobile_no) {
            whereCondition += " AND (tg_customer.mobile LIKE '%" + postData.filter.mobile_no + "%')";
        }
        
        if (postData.filter.address) {
            whereCondition += " AND (tg_customer.street LIKE '%" + postData.filter.address + "%' OR tg_customer.state_name LIKE '%" + postData.filter.address + "%' OR tg_customer.district_name LIKE '%" + postData.filter.address + "%' OR tg_customer.pincode LIKE '%" + postData.filter.address + "%')";
        }
        
        if (postData.filter.created_on) {
            postData.filter.created_on = moment(postData.filter.created_on).format('YYYY-MM-DD');
            whereCondition += " AND (DATE(tg_chat_data.created_on) = '" + postData.filter.created_on + "')";
        }
        
        
        if (postData.filter.type == 'unread') {
            whereCondition += " AND (`tg_chat_data`.`read` = 0 AND tg_chat_data.created_by_type = 'lms')";
        } else if (postData.filter.type == 'read') {
            whereCondition += " AND (`tg_chat_data`.`read` = 1 AND tg_chat_data.created_by_type = 'lms')";
        } else {
            whereCondition += " AND (1 = 1)";
        }
        
        var queryString = "SELECT IF(COUNT(tg_chat_data.id),COUNT(tg_chat_data.id),0) as totalCount FROM tg_chat_data LEFT JOIN tg_customer ON tg_customer.id = tg_chat_data.customer_id  WHERE  1 = 1 " + whereCondition + " GROUP BY customer_id";
        var filter = [];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                console.log("Count response",res)
                resolve(res.length);
            }
        });
    });
};


Master.getFeedbackList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if (postData.filter.search) {
            whereCondition += " AND (tg_customer.first_name LIKE '%" + postData.filter.search + "%'  OR tg_customer.mobile LIKE '%" + postData.filter.search + "%' )";
        }
        if (postData.filter.name) {
            whereCondition += " AND (tg_customer.first_name LIKE '%" + postData.filter.name + "%')";
        }
        
        if (postData.filter.mobile_no) {
            whereCondition += " AND (tg_customer.mobile LIKE '%" + postData.filter.mobile_no + "%')";
        }
        
        if (postData.filter.address) {
            whereCondition += " AND (tg_customer.street LIKE '%" + postData.filter.address + "%' OR tg_customer.state_name LIKE '%" + postData.filter.address + "%' OR tg_customer.district_name LIKE '%" + postData.filter.address + "%' OR tg_customer.pincode LIKE '%" + postData.filter.address + "%')";
        }
        
        
        if (postData.filter.status) {
            whereCondition += " AND (status LIKE '%" + postData.filter.status + "%')";
        }
        if (postData.filter.created_on) {
            postData.filter.created_on = moment(postData.filter.created_on).format('YYYY-MM-DD');
            whereCondition += " AND (DATE(tg_chat_data.created_on) = '" + postData.filter.created_on + "')";
        }
        
        if (postData.filter.type == 'unread') {
            whereCondition += " AND (`tg_chat_data`.`read` = 0 AND tg_chat_data.created_by_type = 'lms')";
        } else if (postData.filter.type == 'read') {
            whereCondition += " AND (`tg_chat_data`.`read` = 1 AND tg_chat_data.created_by_type = 'lms')";
        } else {
            whereCondition += " AND (1 = 1)";
        }
        
        var queryString = "SELECT tg_chat_data.*, tg_customer.first_name, tg_customer.mobile,tg_customer.street,tg_customer.state_name,tg_customer.district_name,tg_customer.city,tg_customer.area,tg_customer.pincode  FROM tg_chat_data  LEFT JOIN tg_customer ON tg_customer.id = tg_chat_data.customer_id WHERE  1 = 1 " + whereCondition + "  GROUP BY tg_chat_data.customer_id  ORDER BY tg_chat_data.ID ASC LIMIT ? OFFSET ? ";
        var filter = [postData.limit, postData.start];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                console.log("list response",res)
                if (res.length) {
                    var i = res.length - 1;
                    res.forEach(async element => {
                        element.cust_encrypt_id = encrypt(element.customer_id.toString());
                        // element.chatDetailData = await Master.getFeedbackDetailData(element);
                        element.unread_message = await Master.getFeedbackUnreadCountData(element);
                        if (i == 0) {
                            resolve(res);
                        }
                        i--;
                    });
                } else {
                    resolve(res);
                }
            }
        });
    });
};


Master.getFeedbackDetailData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = "";
        var queryString = "SELECT tg_chat_data.*, IF(tg_chat_data.attachment_filename != '' ,CONCAT('" + postData.image_app_path + "', tg_chat_data.attachment_filename), '')  as attachment_filename_path, IF(tg_customer.profile_image != '',CONCAT('" + postData.image_app_path + "', tg_customer.profile_image), '') as profile_image_path, tg_customer.first_name, tg_customer.mobile,tg_customer.street,tg_customer.state_name,tg_customer.district_name,tg_customer.city,tg_customer.area,tg_customer.pincode FROM tg_chat_data LEFT JOIN tg_customer ON tg_customer.id = tg_chat_data.customer_id   WHERE  customer_id = ? " + whereCondition + " ORDER BY ID ASC";
        var filter = [postData.customer_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Master.getFeedbackUnreadCountData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = "";
        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount  FROM tg_chat_data  WHERE  customer_id = ? AND `read` = ? AND created_by_type = ?";
        var filter = [postData.customer_id, '0', 'app'];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var totalCount = 0;
                if (res.length) {
                    totalCount = res[0].totalCount;
                }
                resolve(totalCount);
            }
        });
    });
};


Master.sendFeedbackMessage = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            customer_id: postData.customer_id ? postData.customer_id : 0,
            message: postData.message ? postData.message : '',
            attachment_filename: postData.attachment_filename ? postData.attachment_filename : '',
            created_on: nowDateTime,
            created_by: postData.sfa_web_user_id ? postData.sfa_web_user_id : 0,
            created_by_type: postData.sfa_web_user_type ? postData.sfa_web_user_type : '',
            created_by_name: postData.sfa_web_user_name ? postData.sfa_web_user_name : '',
        }
        
        var queryString = "INSERT INTO tg_chat_data set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



Master.markReadMessage = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            read: 1,
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE customer_id = ?;"
        var filter = ["tg_chat_data", updateDataValues, postData.customer_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};

// feedback code end



// site module code start


Master.getSiteListCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if (postData.filter.search) {
            whereCondition += " AND (tg_customer.first_name LIKE '%" + postData.filter.search + "%'  OR tg_customer.mobile LIKE '%" + postData.filter.search + "%' )";
        }
        if (postData.filter.name) {
            whereCondition += " AND (tg_customer.first_name LIKE '%" + postData.filter.name + "%')";
        }
        
        if (postData.filter.mobile_no) {
            whereCondition += " AND (tg_customer.mobile LIKE '%" + postData.filter.mobile_no + "%')";
        }
        
        if (postData.filter.title) {
            whereCondition += " AND (tg_customer_site.title LIKE '%" + postData.filter.title + "%')";
        }
        
        if (postData.filter.description) {
            whereCondition += " AND (tg_customer_site.description LIKE '%" + postData.filter.description + "%')";
        }
        
        if (postData.filter.address) {
            whereCondition += " AND (tg_customer.street LIKE '%" + postData.filter.address + "%' OR tg_customer.state_name LIKE '%" + postData.filter.address + "%' OR tg_customer.district_name LIKE '%" + postData.filter.address + "%' OR tg_customer.pincode LIKE '%" + postData.filter.address + "%')";
        }
        
        var queryString = "SELECT IF(COUNT(tg_customer_site.id),COUNT(tg_customer_site.id),0) as totalCount FROM tg_customer_site  LEFT JOIN tg_customer ON tg_customer.id = tg_customer_site.customer_id WHERE  1 = 1 " + whereCondition;
        var filter = [];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if (res.length) {
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


Master.getSiteListData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        if (postData.filter.search) {
            whereCondition += " AND (tg_customer.first_name LIKE '%" + postData.filter.search + "%'  OR tg_customer.mobile LIKE '%" + postData.filter.search + "%' )";
        }
        if (postData.filter.name) {
            whereCondition += " AND (tg_customer.first_name LIKE '%" + postData.filter.name + "%')";
        }
        
        if (postData.filter.mobile_no) {
            whereCondition += " AND (tg_customer.mobile LIKE '%" + postData.filter.mobile_no + "%')";
        }
        
        if (postData.filter.address) {
            whereCondition += " AND (tg_customer.street LIKE '%" + postData.filter.address + "%' OR tg_customer.state_name LIKE '%" + postData.filter.address + "%' OR tg_customer.district_name LIKE '%" + postData.filter.address + "%' OR tg_customer.pincode LIKE '%" + postData.filter.address + "%')";
        }
        
        if (postData.filter.title) {
            whereCondition += " AND (tg_customer_site.title LIKE '%" + postData.filter.title + "%')";
        }
        
        if (postData.filter.description) {
            whereCondition += " AND (tg_customer_site.description LIKE '%" + postData.filter.description + "%')";
        }
        
        if (postData.filter.status) {
            whereCondition += " AND (status LIKE '%" + postData.filter.status + "%')";
        }
        if (postData.filter.created_on) {
            whereCondition += " AND (created_on = '" + postData.filter.created_on + "')";
        }
        
        var queryString = "SELECT tg_customer_site.*, tg_customer.first_name, tg_customer.mobile,tg_customer.street,tg_customer.state_name,tg_customer.district_name,tg_customer.city,tg_customer.area,tg_customer.pincode  FROM tg_customer_site  LEFT JOIN tg_customer ON tg_customer.id = tg_customer_site.customer_id WHERE  1 = 1 " + whereCondition + " ORDER BY ID DESC LIMIT ? OFFSET ? ";
        var filter = [postData.limit, postData.start];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var i = res.length - 1;
                if (res.length) {
                    res.forEach(async x => {
                        x.image_app_path = postData.image_app_path;
                        var siteImage = await Master.getSiteListImage(x);
                        x.siteImage = siteImage.length ? siteImage[0].site_image : [];
                        x.encrypt_id = encrypt(x.id.toString());
                        if (i == 0) {
                            resolve(res);
                        }
                        i--;
                    });
                } else {
                    resolve(res);
                }
            }
        });
    });
};


Master.getSiteListImage = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        var queryString = "SELECT CONCAT('" + postData.image_app_path + "', tg_customer_site_data.site_image) as site_image  FROM tg_customer_site_data WHERE  site_id = ? ORDER BY ID ASC" + whereCondition;
        var filter = [postData.id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Master.getSiteDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        var queryString = "SELECT tg_customer_site.*, tg_customer.first_name, tg_customer.mobile,tg_customer.street,tg_customer.state_name,tg_customer.district_name,tg_customer.city,tg_customer.area,tg_customer.pincode  FROM tg_customer_site  LEFT JOIN tg_customer ON tg_customer.id = tg_customer_site.customer_id WHERE  tg_customer_site.id = ? " + whereCondition;
        var filter = [postData.site_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var i = res.length - 1;
                if (res.length) {
                    res.forEach(async x => {
                        x.image_app_path = postData.image_app_path;
                        x.siteImage = await Master.getSiteListImage(x);
                        x.encrypt_id = encrypt(x.id.toString());
                        if (i == 0) {
                            resolve(res);
                        }
                        i--;
                    });
                } else {
                    resolve(res);
                }
            }
        });
    });
};


// site module code end



// banner code start

Master.getBannerCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if (postData.filter.search) {
            whereCondition += " AND (name LIKE '%" + postData.filter.search + "%')";
        }
        if (postData.filter.name) {
            whereCondition += " AND (name LIKE '%" + postData.filter.name + "%')";
        }
        
        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount FROM tg_master_banner WHERE  1 = 1 AND deleted = ? " + whereCondition
        var filter = [0];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if (res.length) {
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


Master.getBannerListData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if (postData.filter.search) {
            whereCondition += " AND (name LIKE '%" + postData.filter.search + "%')";
        }
        
        if (postData.filter.name) {
            whereCondition += " AND (name LIKE '%" + postData.filter.name + "%')";
        }
        
        var queryString = "SELECT *  FROM tg_master_banner WHERE  1 = 1 AND tg_master_banner.deleted = ? " + whereCondition + " ORDER BY status DESC, name ASC LIMIT ? OFFSET ? ";
        var filter = [0, postData.limit, postData.start];
        
        console.log('queryString', queryString);
        console.log('filter', filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



Master.addBannerData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            name: postData.name ? postData.name : '',
            status: postData.status ? postData.status : 1,
            image_path: postData.image_path ? postData.image_path : '',
            ordering: postData.ordering ? postData.ordering : 9999,
            distributor_banner : postData.distributor_banner == true ? 1 : 0,
            retailer_banner : postData.retailer_banner == true ? 1 : 0,
            sales_user_banner : postData.sales_user_banner == true ? 1 : 0,
            updated_at: nowDateTime,
            created_at: nowDateTime
        }
        
        var queryString = "INSERT INTO tg_master_banner set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Master.updateBannerData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            name: postData.name ? postData.name : '',
            status: postData.status ? postData.status : 0,
            image_path: postData.image_path ? postData.image_path : '',
            ordering: postData.ordering ? postData.ordering : 9999,
            distributor_banner : postData.distributor_banner == true ? 1 : 0,
            retailer_banner : postData.retailer_banner == true ? 1 : 0,
            sales_user_banner : postData.sales_user_banner == true ? 1 : 0,
            updated_at: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_master_banner", updateDataValues, postData.banner_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



Master.deleteBannerData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            deleted: 1,
            updated_at: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_master_banner", updateDataValues, postData.banner_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Master.getBannerDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        
        var queryString = "SELECT *  FROM tg_master_banner WHERE id = ?";
        var filter = [postData.banner_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if (res.length) {
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};

// banner code end



Master.base64ToFile = async function (postData) {
    
    // console.log('postData',postData);
    
    return new Promise(async function (resolve, reject) {
        
        var monthYear = moment(new Date()).format('YYYY-MM');
        var base64String = postData.base64 ? postData.base64 : '';
        
        // var base64Data = Buffer.from(base64String.replace(/^data:video\/\w+;base64,/, ""),'base64');
        const fileType = base64String.split(';')[0].split('/')[1];
        const format = base64String.substring(base64String.indexOf('data:') + 5, base64String.indexOf(';base64'));
        
        console.log('format', format);
        var getFileTypeValue = format.split('/')[0];
        console.log('getFileTypeValue', getFileTypeValue);
        
        if (getFileTypeValue == 'video') {
            var base64Data = Buffer.from(base64String.replace(/^data:video\/\w+;base64,/, ""), 'base64');
        } else if (getFileTypeValue == 'application') {
            // console.log('else if');
            var base64Data = Buffer.from(base64String.replace(/^data:application\/\w+;base64,/, ""), 'base64');
        } else {
            // console.log('else');
            var base64Data = Buffer.from(base64String.replace(/^data:image\/\w+;base64,/, ""), 'base64');
        }
        
        // console.log('base64Data',base64Data);
        
        var fileName = getUniqueFilename(fileType);
        const params = {
            Bucket: s3.config.s3bucket,
            Key: s3.config.s3bucket + '/asean-ply/' + monthYear + '/' + fileName, // File name you want to save as in S3
            Body: base64Data,
            // Body: Buffer.from(base64String, 'base64'), // <---------
            ContentEncoding: 'base64', // required
            // ContentType: 'video/'+fileType // required. Notice the back ticks
            ContentType: format
        }
        
        console.log('params', params);
        
        let location = '';
        let key = '';
        try {
            var data = {};
            const { Location, Key } = await s3.upload(params).promise();
            location = Location;
            key = Key;
            console.log('successfully uploaded the image!', location);
            data.fileName = fileName ? monthYear + '/' + fileName : '';
            data.Location = location;
            console.log('getFileTypeValue *_*', getFileTypeValue);
            console.log('fileType *_*', fileType);
            resolve(data);
        } catch (error) {
            console.log('error', error);
            reject(error);
        }
        
    });
}


Master.unlinkFile = async function (postData) {
    return new Promise(async function (resolve, reject) {
        
        var fileName = postData.filename ? postData.filename : '';
        
        s3.deleteObject({
            Bucket: s3.config.s3bucket,
            Key: 'asean-ply/' + fileName
        }, function (err, data) {
            if (err) {
                console.log('err', err);
                return reject(err);
            }
            console.log('data', data);
            console.log('file deleted successfully');
            resolve(data);
        });
    });
}


// referral point master

Master.getReferralPointMaster = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT tg_master_point.* FROM tg_master_point WHERE  status = ? ";
        var filter = [1];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};

Master.updateReferralPointMaster = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            welcome_point: postData.welcome_point ? postData.welcome_point : 0,
            birthday_points: postData.birthday_points ? postData.birthday_points : 0,
            registeration_referral_point: postData.registeration_referral_point ? postData.registeration_referral_point : 0,
            retailer_sales_user_point: postData.retailer_sales_user_point ? postData.retailer_sales_user_point : 0,
            retailer_distributor_point: postData.retailer_distributor_point ? postData.retailer_distributor_point : 0,
            referral_user_point: postData.referral_user_point ? postData.referral_user_point : 0,
            referral_owner_point: postData.referral_owner_point ? postData.referral_owner_point : 0,
            min_gift_redeem: postData.min_gift_redeem ? postData.min_gift_redeem : 0,
            status: postData.status ? postData.status : 0,
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_master_point", updateDataValues, postData.id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};




// Content Module code start


Master.getContentTypeList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT * FROM tg_master_content_type WHERE  status = ? ORDER BY ordering ASC ";
        var filter = [1];
        
        console.log('queryString', queryString);
        console.log('filter', filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Master.getContentDataCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if (postData.filter.search) {
            whereCondition += " AND (name LIKE '%" + postData.filter.search + "%')";
        }
        if (postData.filter.name) {
            whereCondition += " AND (name LIKE '%" + postData.filter.name + "%')";
        }
        
        if (postData.filter.type) {
            whereCondition += " AND (type LIKE '%" + postData.filter.type + "%')";
        }
        
        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount FROM tg_master_content WHERE  1 = 1  AND deleted = ? " + whereCondition
        var filter = [0];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if (res.length) {
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


Master.getContentListData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if (postData.filter.search) {
            whereCondition += " AND (name LIKE '%" + postData.filter.search + "%')";
        }
        
        if (postData.filter.name) {
            whereCondition += " AND (name LIKE '%" + postData.filter.name + "%')";
        }
        
        if (postData.filter.type) {
            whereCondition += " AND (type LIKE '%" + postData.filter.type + "%')";
        }
        
        var queryString = "SELECT title,description,status,ordering,id , type, youtube_url, youtube_id, IF(tg_master_content.file_path != '',CONCAT('" + postData.image_app_path + "', tg_master_content.file_path), '') as file_path FROM tg_master_content WHERE  1 = 1 AND deleted = ?  " + whereCondition + " ORDER BY ordering ASC, status DESC LIMIT ? OFFSET ? ";
        var filter = [0, postData.limit, postData.start];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var i = res.length - 1;
                if (res.length) {
                    res.forEach(x => {
                        x.encrypt_id = encrypt(x.id.toString());
                        if (i == 0) {
                            resolve(res);
                        }
                        i--;
                    });
                } else {
                    resolve(res);
                }
            }
        });
    });
};



Master.addContentData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            type: postData.type ? postData.type : '',
            title: postData.title ? postData.title : '',
            description: postData.description ? postData.description : '',
            status: 1,
            thumbnail_image: postData.thumbnail_image ? postData.thumbnail_image : '',
            youtube_url: postData.youtube_url ? postData.youtube_url : '',
            youtube_id: postData.youtube_id ? postData.youtube_id : '',
            url: postData.file_path ? postData.image_app_path + postData.file_path : '',
            file_path: postData.file_path ? postData.file_path : '',
            // audio_path: postData.audio_path ? postData.audio_path : '',
            ordering: postData.ordering ? postData.ordering : 9999,
            updated_on: nowDateTime,
            created_on: nowDateTime
        }
        
        var queryString = "INSERT INTO tg_master_content set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Master.updateContentData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            type: postData.type ? postData.type : '',
            title: postData.title ? postData.title : '',
            description: postData.description ? postData.description : '',
            status: postData.status ? postData.status : 0,
            deleted: postData.deleted ? postData.deleted : 0,
            thumbnail_image: postData.thumbnail_image ? postData.thumbnail_image : '',
            youtube_url: postData.youtube_url ? postData.youtube_url : '',
            youtube_id: postData.youtube_id ? postData.youtube_id : '',
            url: postData.file_path ? postData.image_app_path + postData.file_path : '',
            file_path: postData.file_path ? postData.file_path : '',
            // pdf_path: postData.pdf_path ? postData.pdf_path : '',
            // audio_path: postData.audio_path ? postData.audio_path : '',
            ordering: postData.ordering ? postData.ordering : 9999,
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_master_content", updateDataValues, postData.content_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Master.getContentDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        
        var queryString = "SELECT title,description,status,ordering,id , tg_master_content.*  FROM tg_master_content WHERE id = ?";
        var filter = [postData.content_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if (res.length) {
                    data = res[0];
                    data.encrypt_id = encrypt(data.id.toString());
                }
                resolve(data);
            }
        });
    });
};

// Content Module code end





var getUniqueFilename = function (fileType) {
    var timestamp = (new Date()).getTime();
    var randomInteger = Math.floor((Math.random() * 1000000) + 1);
    var randomCharacter = generateRandomNumber(25);
    return timestamp + '_' + randomInteger + '_' + randomCharacter + '.' + fileType;
};


function generateRandomNumber(length) {
    var result = '';
    var characters = 'ABCDEFGHJKMNPQRSTUVWXYZ';
    var charactersLength = characters.length;
    for (var i = 0; i < length; i++) {
        result += characters.charAt(Math.floor(Math.random() * charactersLength));
    }
    return result;
}

Master.getBankList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        var queryString = "SELECT *  FROM tg_master_bank WHERE  1 = 1 AND status = ?" + whereCondition + "";
        var filter = [1];
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


module.exports = Master;
