var db = require('../../config/db');
var path = require('path');
var moment = require('moment');
var http = require("https");
var request = require('request');
let jwt = require('jsonwebtoken');
var md5 = require('md5');
const { encrypt, decrypt, encrypter, my_simple_crypt } = require('../../config/common');


var Network = function (data) {
    
};

Network.getCustomerNetworkTypeList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT id,name,slug FROM tg_customer_type WHERE  status = ? ";
        var filter = [1];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                
                var i = res.length-1;
                if(res.length){
                    await res.forEach(async element => {
                        element.count= 0;
                        element.count = await Network.getNetworkCount({filter:{
                            cust_type_id : element.id,
                            status : 1,
                            deleted : 0
                        }})
                        // console.log('data',data);
                        if(i == 0){
                            resolve(res);
                        }
                        i--;
                    });
                }else{
                    resolve(res);
                }                
            }
        });
    });
};



Network.getLeadSourceListData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        var queryString = "SELECT id,name FROM tg_master_lead_source WHERE status  = ? "+whereCondition+" ORDER BY ordering ASC";
        var filter = [1];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



Network.getLeadStatusListData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        var queryString = "SELECT id,name FROM tg_customer_status WHERE status  = ? "+whereCondition+" ORDER BY ordering ASC";
        var filter = [1];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Network.getSystemUserList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        // console.log('whereCondition',whereCondition);
        var queryString = "SELECT tg_system_users.name,tg_system_users.id,tg_system_users.role,tg_master_role.name as role_name  FROM tg_system_users LEFT JOIN tg_master_role ON tg_master_role.id = tg_system_users.role WHERE tg_system_users.status = ? AND tg_system_users.deleted = ? ORDER BY  tg_system_users.name ASC ";
        var filter = [1, 0];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Network.getSalesUserList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        // if(postData.filter.roleIds.length){
        //     whereCondition += " AND (tg_system_users.role IN ("+postData.filter.roleIds+") )"; 
        // }

        if(postData.filter.name){
            whereCondition += "AND(tg_system_users.name = '"+postData.filter.name+"')"
        }
        
        // console.log('whereCondition',whereCondition);
        var queryString = "SELECT tg_system_users.name,tg_system_users.emp_code,tg_system_users.id,tg_system_users.role,tg_master_role.name as role_name  FROM tg_system_users LEFT JOIN tg_master_role ON tg_master_role.id = tg_system_users.role WHERE tg_system_users.status = ? AND tg_system_users.deleted = ? AND tg_system_users.role != ? " +whereCondition+ " ORDER BY  tg_system_users.name ASC ";
        var filter = [1, 0, 1];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Network.getNetworkCountByStatus = function (postData) {
    
    return new Promise(function (resolve, reject) { 
        
        var whereCondition = '';
        if(postData.status != 'All'){
            whereCondition += " AND (status = '"+postData.status+"')"; 
        }
        if(postData.cust_type_id){
            whereCondition += " AND (cust_type_id = '"+postData.cust_type_id+"')"; 
        }
        
        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount FROM tg_customer WHERE deleted = ? "+ whereCondition
        var filter = [0];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};

Network.getNetworkCount = function (postData) {
    console.log("disdataa",postData)
    
    return new Promise(function (resolve, reject) { 
        
        var whereCondition = '';
        
        if(postData.filter.name){
            whereCondition += " AND (tg_customer.company_name LIKE '%"+postData.filter.name+"%'  OR tg_customer.cust_code LIKE '%"+postData.filter.name+"%' OR tg_customer.mobile LIKE '%"+postData.filter.name+"%' OR tg_customer.first_name LIKE '%"+postData.filter.name+"%' OR tg_customer.last_name LIKE '%"+postData.filter.name+"%' )"; 
        }
        
        if(postData.filter.search){
            whereCondition += " AND (tg_customer.company_name LIKE '%"+postData.filter.search+"%'  OR tg_customer.cust_code LIKE '%"+postData.filter.search+"%' OR tg_customer.mobile LIKE '%"+postData.filter.search+"%' OR tg_customer.first_name LIKE '%"+postData.filter.search+"%' OR tg_customer.last_name LIKE '%"+postData.filter.search+"%' )"; 
        }
        
        
        if(postData.filter.company_name){
            whereCondition += " AND (tg_customer.company_name LIKE '%"+postData.filter.company_name+"%')"; 
        }
        if(postData.filter.cust_code){
            whereCondition += " AND (tg_customer.cust_code LIKE '%"+postData.filter.cust_code+"%')"; 
        }
        if(postData.filter.cust_type_id){
            whereCondition += " AND (tg_customer.cust_type_id = '"+postData.filter.cust_type_id+"')"; 
        }
        if(postData.filter.cust_type == 'all'){
            whereCondition += " AND (tg_customer.cust_type_id != 0)"; 
        }
        if(postData.filter.email){
            whereCondition += " AND (tg_customer.email LIKE '%"+postData.filter.email+"%')"; 
        }
        if(postData.filter.street){
            whereCondition += " AND (tg_customer.street LIKE '%"+postData.filter.street+"%')"; 
        }
        
        if(postData.filter.mobile_no){
            whereCondition += " AND (tg_customer.mobile LIKE '%"+postData.filter.mobile_no+"%')"; 
        }
        
        
        if(postData.filter.address){
            whereCondition += " AND (tg_customer.street LIKE '%"+postData.filter.address+"%' OR tg_customer.state_name LIKE '%"+postData.filter.address+"%' OR tg_customer.district_name LIKE '%"+postData.filter.address+"%' OR tg_customer.pincode LIKE '%"+postData.filter.address+"%')"; 
        }
        
        if(postData.filter.district){
            whereCondition += " AND (tg_customer.district_name LIKE '%"+postData.filter.district+"%')"; 
        }
        
       
        
        if(postData.filter.state_name){
            whereCondition += " AND (tg_customer.state_name LIKE '%"+postData.filter.state_name+"%')"; 
        }
        
        if(postData.filter.state){
            whereCondition += " AND (tg_customer.state_name LIKE '%"+postData.filter.state+"%')"; 
        }
        
        
        if(postData.filter.branch){
            whereCondition += " AND (tg_customer.branch LIKE '%"+postData.filter.branch+"%')"; 
        }
        
        
        if(postData.filter.mobile){
            whereCondition += " AND (tg_customer.mobile LIKE '%"+postData.filter.mobile+"%')"; 
        }
        
        if(postData.filter.created_on){
            whereCondition += " AND (DATE(tg_customer.created_on) = '"+moment(postData.filter.created_on).format('YYYY-MM-DD')+"')"; 
        }
        
        if(postData.filter.created_by){
            whereCondition += " AND (tg_customer.created_by_name LIKE '%"+postData.filter.created_by+"%')"; 
        }
        
        if(postData.filter.lead_source){
            whereCondition += " AND (tg_customer.lead_source LIKE '%"+postData.filter.lead_source+"%')"; 
        }
        
        if(postData.filter.status){
            whereCondition += " AND (tg_customer.status = '"+postData.filter.status+"')"; 
        }
        
        if(postData.filter.is_lead){
            whereCondition += " AND (tg_customer.is_lead = '"+postData.filter.is_lead+"')"; 
        }
        
        
        if(postData.filter.deleted){
            whereCondition += " AND (tg_customer.deleted = '"+postData.filter.deleted+"')"; 
        }
        
        
        if(postData.user_assignedDrIds){
            whereCondition += " AND (tg_customer.id IN ("+postData.user_assignedDrIds+") OR (tg_customer.created_by IN ("+postData.user_id+")) )"; 
        }
        if(postData.user_id){
            whereCondition += " AND (tg_customer.created_by = '"+postData.user_id+"')"; 
        }
        
        
        if(postData.filter.date_from && postData.filter.date_to) {
            whereCondition += 'AND ( DATE(tg_customer.created_on) BETWEEN  "' + moment(new Date(postData.filter.date_from)).format('YYYY-MM-DD') + '" AND "' + moment(new Date(postData.filter.date_to)).format('YYYY-MM-DD') + '" )';
        }
        
        
        
        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount FROM tg_customer WHERE deleted = ? AND 1 = 1 "+ whereCondition
        var filter = [0];
        
        console.log('queryString',queryString);
        console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


Network.getNetworkList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        if(postData.filter.name){
            whereCondition += " AND (tg_customer.company_name LIKE '%"+postData.filter.name+"%'  OR tg_customer.cust_code LIKE '%"+postData.filter.name+"%' OR tg_customer.mobile LIKE '%"+postData.filter.name+"%' OR tg_customer.first_name LIKE '%"+postData.filter.name+"%' OR tg_customer.last_name LIKE '%"+postData.filter.name+"%' )"; 
        }
        
        if(postData.filter.search){
            whereCondition += " AND (tg_customer.company_name LIKE '%"+postData.filter.search+"%'  OR tg_customer.cust_code LIKE '%"+postData.filter.search+"%' OR tg_customer.mobile LIKE '%"+postData.filter.search+"%' OR tg_customer.first_name LIKE '%"+postData.filter.search+"%' OR tg_customer.last_name LIKE '%"+postData.filter.search+"%' )"; 
        }
        
        
        if(postData.filter.company_name){
            whereCondition += " AND (tg_customer.company_name LIKE '%"+postData.filter.company_name+"%')"; 
        }
        if(postData.filter.cust_code){
            whereCondition += " AND (tg_customer.cust_code LIKE '%"+postData.filter.cust_code+"%')"; 
        }
        if(postData.filter.cust_type_id){
            whereCondition += " AND (tg_customer.cust_type_id = '"+postData.filter.cust_type_id+"')"; 
        }
        if(postData.filter.cust_type == 'all'){
            whereCondition += " AND (tg_customer.cust_type_id != 0)"; 
        }
        if(postData.filter.email){
            whereCondition += " AND (tg_customer.email LIKE '%"+postData.filter.email+"%')"; 
        }
        if(postData.filter.street){
            whereCondition += " AND (tg_customer.street LIKE '%"+postData.filter.street+"%')"; 
        }
        
        if(postData.filter.address){
            whereCondition += " AND (tg_customer.street LIKE '%"+postData.filter.address+"%' OR tg_customer.state_name LIKE '%"+postData.filter.address+"%' OR tg_customer.district_name LIKE '%"+postData.filter.address+"%' OR tg_customer.pincode LIKE '%"+postData.filter.address+"%')"; 
        }
        
        if(postData.filter.district){
            whereCondition += " AND (tg_customer.district_name LIKE '%"+postData.filter.district+"%')"; 
        }
        
        if(postData.filter.district_name){
            whereCondition += " AND (tg_customer.district_name LIKE '%"+postData.filter.district_name+"%')"; 
        }
        
        if(postData.filter.state_name){
            whereCondition += " AND (tg_customer.state_name LIKE '%"+postData.filter.state_name+"%')"; 
        }
        
        if(postData.filter.state){
            whereCondition += " AND (tg_customer.state_name LIKE '%"+postData.filter.state+"%')"; 
        }
        
        
        if(postData.filter.branch){
            whereCondition += " AND (tg_customer.branch LIKE '%"+postData.filter.branch+"%')"; 
        }
        
        
        if(postData.filter.mobile){
            whereCondition += " AND (tg_customer.mobile LIKE '%"+postData.filter.mobile+"%')"; 
        }
        if(postData.filter.se_name){
            whereCondition += " AND (tg_customer.se_name LIKE '%"+postData.filter.se_name+"%')"; 
        }
        
        
        if(postData.filter.created_on){
            whereCondition += " AND (DATE(tg_customer.created_on) = '"+moment(postData.filter.created_on).format('YYYY-MM-DD')+"')"; 
        }
        
        if(postData.filter.created_by){
            whereCondition += " AND (tg_customer.created_by_name LIKE '%"+postData.filter.created_by+"%')"; 
        }
        
        if(postData.filter.lead_source){
            whereCondition += " AND (tg_customer.lead_source LIKE '%"+postData.filter.lead_source+"%')"; 
        }
        
        if(postData.filter.status){
            whereCondition += " AND (tg_customer.status = '"+postData.filter.status+"')"; 
        }
        
        // if(postData.filter.is_lead){
        //     whereCondition += " AND (tg_customer.is_lead = '"+postData.filter.is_lead+"')"; 
        // }
        
        
        if(postData.filter.deleted){
            whereCondition += " AND (tg_customer.deleted = '"+postData.filter.deleted+"')"; 
        }
        
        
        if(postData.user_assignedDrIds){
            whereCondition += " AND (tg_customer.id IN ("+postData.user_assignedDrIds+") OR (tg_customer.created_by IN ("+postData.user_id+")) )"; 
        }
        if(postData.user_id){
            whereCondition += " AND (tg_customer.created_by = '"+postData.user_id+"')"; 
        }
        
        
        if(postData.filter.date_from && postData.filter.date_to) {
            whereCondition += 'AND ( DATE(tg_customer.created_on) BETWEEN  "' + moment(new Date(postData.filter.date_from)).format('YYYY-MM-DD') + '" AND "' + moment(new Date(postData.filter.date_to)).format('YYYY-MM-DD') + '" )';
        }
        
        
        
        // console.log('whereCondition',whereCondition);
        var queryString = "SELECT *  FROM tg_customer WHERE deleted = ? AND 1 = 1 "+ whereCondition +" ORDER BY id DESC LIMIT ? OFFSET ? ";
        var filter = [0, postData.limit, postData.start];
        
        console.log('queryString',queryString);
        console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var i = res.length - 1;
                if(res.length){
                    res.forEach(async x => {
                        x.encrypt_id = encrypt(x.id.toString());
                        // x.wallet_points = await Network.getNetworkWalletPoints({'customer_id' : x.id});
                        x.redeem_request = await Network.getRedeemRequestCount( {"filter" : {'customer_id' : x.id}})
                        
                        var getDistributionNetworkAssignedUserDetail = await Network.getDistributionNetworkAssignedUserDetail({'customer_id' : x.id});
                        // console.log('getDistributionNetworkAssignedUserDetail',getDistributionNetworkAssignedUserDetail);
                        if(getDistributionNetworkAssignedUserDetail.length){
                            x.se_name = getDistributionNetworkAssignedUserDetail[0].user_name ? getDistributionNetworkAssignedUserDetail[0].user_name : '';
                            x.se_id = getDistributionNetworkAssignedUserDetail[0].user_id ? getDistributionNetworkAssignedUserDetail[0].user_id : '';
                            x.encrypt_se_id = encrypt(x.se_id.toString());
                            x.se_code = getDistributionNetworkAssignedUserDetail[0].user_code ? getDistributionNetworkAssignedUserDetail[0].user_code : '';
                        }
                        
                        var getDistributionNetworkDealerDetail = await Network.getDistributionNetworkDealerDetail({'customer_id' : x.id});
                        // console.log('getDistributionNetworkDealerDetail',getDistributionNetworkDealerDetail);
                        if(getDistributionNetworkDealerDetail.length){
                            x.dealer_counter_name = getDistributionNetworkDealerDetail[0].name ? getDistributionNetworkDealerDetail[0].name : '';
                            x.dealer_id = getDistributionNetworkDealerDetail[0].name ? getDistributionNetworkDealerDetail[0].dealer_id : '';
                            x.encrypt_dealer_id = encrypt(x.dealer_id.toString());
                            x.dealer_counter_cp_name = getDistributionNetworkDealerDetail[0].cp_name ? getDistributionNetworkDealerDetail[0].cp_name : '';
                            x.dealer_counter_mobile = getDistributionNetworkDealerDetail[0].mobile ? getDistributionNetworkDealerDetail[0].mobile : '';
                            x.dealer_counter_status = 'Active';
                            x.dealer_counter_address = getDistributionNetworkDealerDetail[0].address ? getDistributionNetworkDealerDetail[0].address : '';
                        }
                        if(i==0){
                            resolve(res);
                        }
                        i--;
                    });
                }else{
                    resolve(res);
                }
            }
        });
    });
};


Network.getRedeemRequestCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        if(postData.filter.customer_id){
            whereCondition += " AND (customer_id = '"+postData.filter.customer_id+"')"; 
        }
        
        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount FROM tg_customer_redeem_request WHERE  1 = 1 "+ whereCondition
        var filter = [];
        
        // console.log('queryString',queryString);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


Network.getNetworkWalletPoints = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT IF(SUM(point),SUM(point),0) as totalPoints  FROM tg_customer_wallet_detail WHERE customer_id = ?"
        var filter = [postData.customer_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        // console.log('postData',postData);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var totalPoints = 0;
                if(res.length){
                    totalPoints = res[0].totalPoints;
                }
                resolve(totalPoints);
            }
        });
    });
};



Network.addDistributionNetworkData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            cust_code : postData.cust_code ? postData.cust_code : null,
            cust_type: postData.cust_type ? postData.cust_type : null,
            cust_type_id: postData.cust_type_id ? postData.cust_type_id : 0,
            company_type : postData.company_type ? postData.company_type : '',
            company_name : postData.company_name ? postData.company_name : '',
            gst_no : postData.gst_no ? postData.gst_no : null,
            first_name: postData.first_name ? postData.first_name : '',
            last_name: postData.last_name ? postData.last_name : '',
            mobile: postData.mobile ? postData.mobile : null,
            email: postData.email ? postData.email : null,
            street: postData.street ? postData.street : '',
            state_name: postData.state_name ? postData.state_name : '',
            district_name: postData.district_name ? postData.district_name : '',
            city: postData.city ? postData.city : '',
            area: postData.area ? postData.area : '',
            zone: postData.zone ? postData.zone : '',
            beat:postData.beat ? postData.beat : '',
            pincode: postData.pincode ? postData.pincode : '',
            // branch : postData.branch.name ? postData.branch.name : '',
            status : postData.status ? postData.status : '',
            profile_image : postData.profile_image ? postData.profile_image : '',
            session_token : postData.session_token ? postData.session_token : '',
            fcm_token : postData.fcm_token ? postData.fcm_token : '',
            date_of_birth : postData.date_of_birth ? postData.date_of_birth : '0000-00-00',
            date_of_anniversary : postData.date_of_anniversary ? postData.date_of_anniversary : '0000-00-00',
            bank_name : postData.bank_name ? postData.bank_name : '',
            account_number : postData.account_number ? postData.account_number : '',
            account_holder_name : postData.account_holder_name ? postData.account_holder_name : '',
            ifsc_code : postData.ifsc_code ? postData.ifsc_code : '',
            cheque_image : postData.cheque_image ? postData.cheque_image : '',
            referral_code : postData.user_referral_code ? postData.user_referral_code : null,
            referred_by_code : postData.referral_code ? postData.referral_code : null,
            lead_source : postData.lead_source ? postData.lead_source : '',
            is_lead : postData.is_lead ? postData.is_lead : 0,
            remark : postData.remark ? postData.remark : '',
            registered: 0,
            otp_valid_upto: 60,
            updated_on: nowDateTime,
            created_on: nowDateTime,
            created_by : postData.sfa_web_user_id ? postData.sfa_web_user_id : 0,
            created_by_type : postData.sfa_web_user_type ? postData.sfa_web_user_type : '',
            created_by_name : postData.sfa_web_user_name ? postData.sfa_web_user_name : '',
        }
        
        var queryString = "INSERT INTO tg_customer set ?";
        
        console.log('insertData',insertData);
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Network.updateDistributionNetworkData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            cust_type: postData.cust_type ? postData.cust_type : null,
            company_type : postData.company_type ? postData.company_type : '',
            company_name : postData.company_name ? postData.company_name : '',
            first_name: postData.first_name ? postData.first_name : '',
            last_name: postData.last_name ? postData.last_name : '',
            mobile: postData.mobile ? postData.mobile : null,
            email: postData.email ? postData.email : null,
            street: postData.street ? postData.street : '',
            status: postData.status ? postData.status : '',
            state_name: postData.state_name ? postData.state_name : '',
            district_name: postData.district_name ? postData.district_name : '',
            city: postData.city ? postData.city : '',
            area: postData.area ? postData.area : '',
            zone: postData.zone ? postData.zone : '',
            beat:postData.beat ? postData.beat : '',
            pincode: postData.pincode ? postData.pincode : '',
            branch : postData.branch?.name ? postData.branch.name : '',
            profile_image : postData.profile_image ? postData.profile_image : '',
            fcm_token : postData.fcm_token ? postData.fcm_token : '',
            date_of_birth : postData.date_of_birth ? postData.date_of_birth : '0000-00-00',
            // date_of_anniversary : postData.date_of_anniversary ? postData.date_of_anniversary : '0000-00-00',
            bank_name : postData.bank_name ? postData.bank_name : '',
            account_number : postData.account_number ? postData.account_number : '',
            account_holder_name : postData.account_holder_name ? postData.account_holder_name : '',
            ifsc_code : postData.ifsc_code ? postData.ifsc_code : '',
            cheque_image : postData.cheque_image ? postData.cheque_image : '',
            updated_on: nowDateTime,
        }
        
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_customer", updateDataValues, postData.customer_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Network.addDistributionAssignedSalesUser = function (postData) {
    return new Promise(async function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            customer_id : postData.customer_id ? postData.customer_id : 0,
            user_id : postData.user_id ? postData.user_id : 0,
            user_name : postData.user_name ? postData.user_name : '',
            user_code : postData.emp_code ? postData.emp_code : '',
            deleted : 0,
            created_on:nowDateTime,
        }
        
        var queryString = "INSERT INTO tg_customer_assigned_user set ?";
        
        // console.log('insertData',insertData);
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Network.updateDistributionAssignedSalesUser = function (postData) {
    return new Promise(async function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            deleted : 1,
            updated_on:nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE customer_id = ?;"
        var filter = ["tg_customer_assigned_user", updateDataValues, postData.customer_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Network.addBonusPointData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            customer_id : postData.customer_id ? postData.customer_id : 0,
            type : postData.type ? postData.type : '',
            point : postData.point ? postData.point : 0,
            remark : postData.remark ? postData.remark : '',
            created_on: nowDateTime
        }
        
        var queryString = "INSERT INTO tg_customer_wallet_detail set ?";
        
        db.query(queryString, insertData, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var updateNetworkWalletPoints = await Network.updateNetworkWalletPoints(postData);
                console.log('updateNetworkWalletPoints',updateNetworkWalletPoints);
                resolve(res);
            }
        });
    });
};


Network.updateNetworkWalletPoints = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var queryString = "UPDATE ?? SET wallet_points = wallet_points + ?, updated_on = ? WHERE id = ?;"
        var filter = ["tg_customer", postData.point, nowDateTime, postData.customer_id];
        
        console.log('queryString',queryString);
        console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



Network.addDistributionNetworkContactData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        const valueData = [];
        // console.log('postData',postData);
        if (postData.basicDetail.contactDetail.length > 0) {
            postData.basicDetail.contactDetail.forEach(async x => {
                valueData.push([postData.customer_id, x.name ? x.name : '', x.email ? x.email : null, x.mobile ? x.mobile : null, x.designation ? x.designation : '', nowDateTime, nowDateTime]); 
            });
            
            var sql = "INSERT INTO tg_customer_contact (customer_id,name, email, mobile, designation, updated_on, created_on) VALUES ?";
            db.query(sql, [valueData], function (err, res) {
                if (err) {
                    console.log("error: ", err);
                    return reject(err);
                } else {
                    resolve(res);
                }
            });
        } else {
            resolve([]);
        }
        
    });
}


Network.assignDistributionNetworkBrandData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        const valueData = [];
        // console.log('postData',postData);
        if (postData.brandDetail.length > 0) {
            postData.brandDetail.forEach(async x => {
                valueData.push([postData.customer_id, x.brand_id ? x.brand_id : '', x.brand_name ? x.brand_name : '', nowDateTime]); 
            });
            
            var sql = "INSERT INTO tg_customer_brand_assign (customer_id,brand_id, brand_name, created_on) VALUES ?";
            db.query(sql, [valueData], function (err, res) {
                if (err) {
                    console.log("error: ", err);
                    return reject(err);
                } else {
                    resolve(res);
                }
            });
        } else {
            resolve([]);
        }
        
    });
}


Network.assignDistributionNetworkUserData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        const valueData = [];
        console.log('postData',postData);
        if (postData.basicDetail.assignedUser.length > 0) {
            postData.basicDetail.assignedUser.forEach(async x => {
                valueData.push([postData.customer_id, x.id ? x.id : '', x.name ? x.name : '',x.emp_code ? x.emp_code : '', nowDateTime]); 
            });
            
            // var sql = "INSERT INTO tg_customer_sys_user_assign (customer_id,user_id, user_name, created_on) VALUES ?";
            var sql = "INSERT INTO tg_customer_assigned_user (customer_id,user_id, user_name,user_code, created_on) VALUES ?";
            
            console.log('sql',sql);
            console.log('valueData',valueData);
            // return false;
            
            db.query(sql, [valueData], function (err, res) {
                if (err) {
                    console.log("error: ", err);
                    return reject(err);
                } else {
                    resolve(res);
                }
            });
        } else {
            resolve([]);
        }
        
    });
}




Network.updateDistributionNetworkContactData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            name: postData.name ? postData.name : '',
            email: postData.email ? postData.email : '',
            designation: postData.designation ? postData.designation : '',
            mobile: postData.mobile ? postData.mobile : '',
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_customer_contact", updateDataValues, postData.contact_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Network.deleteDistributionNetworkContactData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            updated_on : nowDateTime,
            deleted : 1
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_customer_contact", updateDataValues, postData.contact_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



Network.distributionNetworkLogData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            customer_id: postData.customer_id ? postData.customer_id : 0,
            type: postData.type ? postData.type : '',
            description: postData.description ? postData.description : '',
            created_on: nowDateTime,
            created_by : postData.created_by ? postData.created_by : 0,
            created_by_type : postData.created_by_type ? postData.created_by_type : '',
            created_by_name : postData.created_by_name ? postData.created_by_name : '',
        }
        
        var queryString = "INSERT INTO tg_customer_log set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Network.deleteNetworkDealerData = function (postData) {
    return new Promise(async function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            deleted : 1,
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE customer_id = ?"
        var filter = ["tg_customer_dealer", updateDataValues, postData.customer_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Network.addNetworkDealerData = function (postData) {
    return new Promise(async function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            customer_id : postData.customer_id ? postData.customer_id : 0,
            dealer_id : postData.dealer ? postData.dealer : 0,
            name : postData.dealer_name ? postData.dealer_name : '',
            cp_name : postData.dealer_cp_name ? postData.dealer_cp_name : '',
            address : postData.dealer_address ? postData.dealer_address : '',
            mobile : postData.dealer_mobile ? postData.dealer_mobile : '',
            created_on:nowDateTime,
            updated_on:nowDateTime
        }
        
        var queryString = "INSERT INTO tg_customer_dealer set ?";
        
        console.log('insertData',insertData);
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Network.deleteCustomerDocument = function (postData) {
    return new Promise(async function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            deleted : 1,
            updated_on: nowDateTime,
        }
        
        // var queryString = "UPDATE ?? SET ? WHERE customer_id = ? AND doc_type = ?;"
        // var filter = ["tg_customer_document", updateDataValues, postData.cust_id, postData.doc_type];
        
        var queryString = "UPDATE ?? SET ? WHERE customer_id = ?"
        var filter = ["tg_customer_document", updateDataValues, postData.customer_id];
        

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Network.addCustomerDocument = function (postData) {
    return new Promise(async function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            customer_id : postData.customer_id ? postData.customer_id : 0,
            doc_type : postData.doc_type ? postData.doc_type : '',
            doc_type_value : postData.doc_type_value ? postData.doc_type_value : '',
            doc_filename : postData.doc_filename ? postData.doc_filename : '',
            doc_filename_1 : postData.doc_filename_1 ? postData.doc_filename_1 : '',
            created_on:nowDateTime
        }
        
        var queryString = "INSERT INTO tg_customer_document set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



Network.getDistributionNetworkBasicDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT tg_customer.*,CONCAT('"+postData.image_app_path+"', tg_customer.profile_image) as profile_image_path , IF(tg_customer.cheque_image != '',CONCAT('"+postData.image_app_path+"', tg_customer.cheque_image), '') as cheque_image_path FROM tg_customer WHERE  id = ?"
        var filter = [postData.customer_id];
        
        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    // console.log('getLogDetail',getLogDetail);
                    
                    data = res[0];
                    data.date_of_birth = data.date_of_birth == '0000-00-00' ? '' : data.date_of_birth;
                    data.date_of_anniversary = data.date_of_anniversary == '0000-00-00' ? '' : data.date_of_anniversary;
                    // var getWalletPoints = await Network.getNetworkWalletPoints(postData);
                    // data.wallet_points = getWalletPoints ? getWalletPoints : 0;
                }
                resolve(data);
            }
        });
    });
};


Network.getCustTypeById = function (postData) {
    
    return new Promise(function (resolve, reject) {       
        
        var queryString = "SELECT tg_customer.cust_type_id FROM tg_customer WHERE  id = ?";
        var filter = [postData.id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0]
                }
                resolve(data);
            }
        });
    });
};


Network.getDistributionNetworkContactDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT * FROM tg_customer_contact WHERE  customer_id = ? AND deleted = ? ORDER BY id DESC"
        var filter = [postData.customer_id, 0];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {}
                if(res.length){
                    data = res[0]
                }
                resolve(data);
            }
        });
    });
};


Network.getDistributionNetworkDealerDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT * FROM tg_customer_dealer WHERE  customer_id = ? AND deleted = ? ORDER BY id DESC"
        var filter = [postData.customer_id, 0];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Network.getDistributionNetworkDocumentDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {       
        
        var queryString = "SELECT tg_customer_document.*,CONCAT('"+postData.image_app_path+"', tg_customer_document.doc_filename) as doc_filename_path,  IF(tg_customer_document.doc_filename_1 != '',CONCAT('"+postData.image_app_path+"', tg_customer_document.doc_filename_1), '') as doc_filename_1_path FROM tg_customer_document WHERE  customer_id = ? AND `deleted` = ? ORDER BY id DESC"
        var filter = [postData.customer_id, 0];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Network.getDistributionNetworkAssignedUserDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {       
        
        var queryString = "SELECT tg_customer_assigned_user.* FROM tg_customer_assigned_user WHERE  customer_id = ? AND `deleted` = ? ORDER BY id DESC"
        var filter = [postData.customer_id, 0];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Network.getDistributionNetworkUserAssigned = function (postData) {
    
    return new Promise(function (resolve, reject) {       
        
        var queryString = "SELECT GROUP_CONCAT(DISTINCT customer_id) AS dr_ids FROM tg_customer_assigned_user WHERE  user_id = ? AND `deleted` = ? ORDER BY id DESC"
        var filter = [postData.user_id, 0];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var drIds = '';
                if(res.length){
                    drIds = res[0].dr_ids;
                }
                console.log("response---->",res)
                resolve(drIds);
            }
        });
    });
};


Network.getAssignedBrandDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT * FROM tg_customer_brand_assign WHERE  customer_id = ?  ORDER BY id DESC"
        var filter = [postData.customer_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Network.getAssignedUserDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT * FROM tg_customer_sys_user_assign WHERE  customer_id = ? ORDER BY id DESC"
        var filter = [postData.customer_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {}
                if(res.length){
                    data = res[0]
                }
                resolve(data);
            }
        });
    });
};


Network.getAssignedSalesUserDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT * FROM tg_customer_assigned_user WHERE  customer_id = ?  AND deleted = ? ORDER BY id DESC"
        var filter = [postData.customer_id, 0];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Network.getDealerPartnerDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        
        var queryString = "SELECT tg_customer_partner.*, IF(tg_customer_partner.aadhaar_front != '',CONCAT('"+postData.image_app_path+"', tg_customer_partner.aadhaar_front), '') as aadhaar_front_path, IF(tg_customer_partner.pan != '',CONCAT('"+postData.image_app_path+"', tg_customer_partner.pan), '') as pan_path, IF(tg_customer_partner.aadhaar_back != '',CONCAT('"+postData.image_app_path+"', tg_customer_partner.aadhaar_back), '') as aadhaar_back_path FROM tg_customer_partner WHERE  customer_id = ? AND `deleted` = ? ORDER BY id DESC"
        
        var filter = [postData.customer_id, 0];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Network.getDistributionNetworkLogDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT * FROM tg_customer_log WHERE  customer_id = ? ORDER BY id DESC"
        var filter = [postData.customer_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Network.stockLedgerMaintaindata = async function (postData) {
    return new Promise(async function (resolve, reject) {
        
        return resolve(true);
        
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        var old_stock = 0;
        var new_stock = 0;
        var getOldProductStock = await Network.getOldProductStock(postData);
        console.log('getOldProductStock',getOldProductStock.new_stock);
        var old_stock = getOldProductStock.new_stock == undefined ? 0 : getOldProductStock.new_stock;
        
        if(postData.type == 'stockin' || postData.type == 'stockreverse'){
            new_stock = parseInt(old_stock) + parseInt(postData.stock);
        }else{
            new_stock = parseInt(old_stock) - parseInt(postData.stock);
        }
        
        var insertData = {
            type: postData.type ? postData.type : '',
            product_id: postData.product_id ? postData.product_id : 0,
            invoice_id: postData.invoice_id ? postData.invoice_id : 0,
            invoice_no: postData.invoice_no ? postData.invoice_no : 0,
            po_id: postData.po_id ? postData.po_id : 0,
            po_no: postData.po_no ? postData.po_no : 0,
            customer_id: postData.customer_id ? postData.customer_id : 0,
            vendor_id: postData.vendor_id ? postData.vendor_id : 0,
            old_stock: old_stock ? old_stock : 0,
            stock: postData.stock ? postData.stock : 0,
            new_stock: new_stock ? new_stock : 0,
            remark : postData.remark ? postData.remark : '',
            created_on: nowDateTime
        }
        
        // console.log('insertData',insertData);
        
        var queryString = "INSERT INTO tg_product_stock_ledger set ?";
        
        db.query(queryString, insertData, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var updateProductStock = await Network.updateProductStock(insertData);
                resolve(res);
            }
        });
    });
};



Network.updateProductStock = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            stock_qty : postData.new_stock,
            updated_on: nowDateTime,
        }
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_master_product", updateDataValues, postData.product_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Network.getOldProductStock = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT new_stock FROM tg_product_stock_ledger WHERE  product_id = ? ORDER BY id DESC LIMIT 1"
        var filter = [postData.product_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};



Network.deleteDrData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            deleted : 1,
            
            cust_code : null,
            gst_no : null,
            referral_code : null,
            email : null,
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_customer", updateDataValues, postData.customer_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Network.updateDrStatus = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            status : postData.status ? postData.status : '',
            status_by : postData.sfa_web_user_id ? postData.sfa_web_user_id : 0,
            status_by_name : postData.sfa_web_user_name ? postData.sfa_web_user_name : '',
            status_remark : postData.status_remark ? postData.status_remark : '',
            is_lead : postData.is_lead,
            status_on : nowDateTime,
            updated_on: nowDateTime,
        }
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_customer", updateDataValues, postData.customer_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Network.updateDrLoginStatus = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            login_block : postData.login_block ? postData.login_block : 0,
            login_block_on : nowDateTime,
            login_block_by : postData.sfa_web_user_id ? postData.sfa_web_user_id : 0,
            login_block_by_name : postData.sfa_web_user_name ? postData.sfa_web_user_name : '',
            updated_on: nowDateTime,
        }
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_customer", updateDataValues, postData.customer_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



Network.findReferredCode = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT id,first_name FROM tg_customer WHERE referral_code = ?"
        var filter = [postData.referred_by_code];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                console.log('res',res);
                var data = {};
                if(res.length){
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};


Network.getReferralBonusPoint = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT * FROM tg_master_point WHERE status = ?"
        var filter = [1];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                console.log('res',res);
                var data = {};
                if(res.length){
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};


Network.sendWalletPoints = function (postData) {
    return new Promise(async function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        var insertData = {
            customer_id: postData.customer_id ? postData.customer_id : 0,
            user_id: postData.user_id ? postData.user_id : 0,
            against_customer_id: postData.against_customer_id ? postData.against_customer_id : 0,
            coupon_id: postData.coupon_id ? postData.coupon_id : 0,
            type: postData.type ? postData.type : '',
            point : postData.point ? postData.point : 0,
            created_on:nowDateTime
        }
        
        
        var queryString = "INSERT INTO tg_customer_wallet_detail set ?";
        
        db.query(queryString, insertData, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var updateNetworkWalletPoints = await Network.updateNetworkWalletPoints(postData);
                console.log('updateNetworkWalletPoints',updateNetworkWalletPoints);                
                resolve(res);
            }
        });
    });
};


Network.updateReferredDetails = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            referred_by : postData.referred_by ? postData.referred_by : 0,
            referred_by_name : postData.referred_by_name ? postData.referred_by_name : '',
            referred_by_code : postData.referred_by_code ? postData.referred_by_code : '',
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_customer", updateDataValues, postData.id];
        
        
        console.log('queryString',queryString);
        console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Network.getProductDiscountListCount = function (postData) {
    
    return new Promise(function (resolve, reject) { 
        
        var whereCondition = '';
        
        
        if(postData.filter.created_on){
            whereCondition += " AND (tg_customer_product_discount.created_on = '"+postData.filter.created_on+"')"; 
        }
        
        if(postData.filter.search){
            whereCondition += " AND (tg_master_product.product_name LIKE '%"+postData.filter.search+"%'  OR tg_master_product.product_code LIKE '%"+postData.filter.search+"%' OR tg_master_product.product_group LIKE '%"+postData.filter.search+"%' OR tg_master_product.description LIKE '%"+postData.filter.search+"%')"; 
        }
        
        if(postData.filter.dr_data){
            whereCondition += " AND (tg_customer.company_name LIKE '%"+postData.filter.dr_data+"%'  OR tg_customer.cust_code LIKE '%"+postData.filter.search+"%' OR tg_customer.email LIKE '%"+postData.filter.dr_data+"%' OR tg_customer.mobile LIKE '%"+postData.filter.dr_data+"%')"; 
        }
        
        if(postData.filter.product_name){
            whereCondition += " AND (REPLACE(`tg_master_product`.`product_name`,' ','') LIKE '%"+postData.filter.product_name+"%')"; 
        }
        if(postData.filter.product_code){
            whereCondition += " AND (REPLACE(`tg_master_product`.`product_code`,' ','') LIKE '%"+postData.filter.product_code+"%')"; 
        }
        if(postData.filter.product_group){
            whereCondition += " AND (REPLACE(`tg_master_product`.`product_group`,' ','') LIKE '%"+postData.filter.product_group+"%')"; 
        }
        if(postData.filter.description){
            whereCondition += " AND (tg_master_product.description LIKE '%"+postData.filter.description+"%')"; 
        }
        if(postData.filter.status){
            whereCondition += " AND (tg_master_product.status LIKE '%"+postData.filter.status+"%')"; 
        }
        
        if(postData.filter.customer_id){
            whereCondition += " AND (tg_customer_product_discount.customer_id = '"+postData.filter.customer_id+"')"; 
        }
        if(postData.filter.created_by_name){
            whereCondition += " AND (tg_customer_product_discount.created_by_name LIKE '%"+postData.filter.created_by_name+"%')"; 
        }
        
        if(postData.filter.min_qty){
            whereCondition += " AND (tg_customer_product_discount.min_qty  "+postData.filter.min_qty+")"; 
        }
        if(postData.filter.discount){
            whereCondition += " AND (tg_customer_product_discount.discount  "+postData.filter.discount+")"; 
        }
        
        // console.log('filter',postData.filter);
        // console.log('whereCondition',whereCondition);
        
        var queryString = "SELECT IF(COUNT(tg_customer_product_discount.id),COUNT(tg_customer_product_discount.id),0) as totalCount FROM tg_customer_product_discount LEFT JOIN tg_customer ON tg_customer.id = tg_customer_product_discount.customer_id  WHERE  1 = 1 AND tg_customer_product_discount.deleted = ? "+ whereCondition;
        var filter = [0];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


Network.getProductDiscountList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        if(postData.filter.created_on){
            whereCondition += " AND (tg_customer_product_discount.created_on = '"+postData.filter.created_on+"')"; 
        }
        
        if(postData.filter.search){
            whereCondition += " AND (tg_master_product.product_name LIKE '%"+postData.filter.search+"%'  OR tg_master_product.product_code LIKE '%"+postData.filter.search+"%' OR tg_master_product.product_group LIKE '%"+postData.filter.search+"%' OR tg_master_product.description LIKE '%"+postData.filter.search+"%')"; 
        }
        
        if(postData.filter.dr_data){
            whereCondition += " AND (tg_customer.company_name LIKE '%"+postData.filter.dr_data+"%'  OR tg_customer.cust_code LIKE '%"+postData.filter.search+"%' OR tg_customer.email LIKE '%"+postData.filter.dr_data+"%' OR tg_customer.mobile LIKE '%"+postData.filter.dr_data+"%')"; 
        }
        
        if(postData.filter.product_name){
            whereCondition += " AND (REPLACE(`tg_master_product`.`product_name`,' ','') LIKE '%"+postData.filter.product_name+"%')"; 
        }
        if(postData.filter.product_code){
            whereCondition += " AND (REPLACE(`tg_master_product`.`product_code`,' ','') LIKE '%"+postData.filter.product_code+"%')"; 
        }
        if(postData.filter.product_group){
            whereCondition += " AND (REPLACE(`tg_master_product`.`product_group`,' ','') LIKE '%"+postData.filter.product_group+"%')"; 
        }
        if(postData.filter.description){
            whereCondition += " AND (tg_master_product.description LIKE '%"+postData.filter.description+"%')"; 
        }
        if(postData.filter.status){
            whereCondition += " AND (tg_master_product.status LIKE '%"+postData.filter.status+"%')"; 
        }
        
        if(postData.filter.customer_id){
            whereCondition += " AND (tg_customer_product_discount.customer_id = '"+postData.filter.customer_id+"')"; 
        }
        if(postData.filter.created_by_name){
            whereCondition += " AND (tg_customer_product_discount.created_by_name LIKE '%"+postData.filter.created_by_name+"%')"; 
        }
        
        if(postData.filter.discount){
            whereCondition += " AND (tg_customer_product_discount.discount  "+postData.filter.discount+")"; 
        }
        
        if(postData.filter.min_qty){
            whereCondition += " AND (tg_customer_product_discount.min_qty  "+postData.filter.min_qty+")"; 
        }
        
        // console.log('whereCondition',whereCondition);
        var queryString = "SELECT tg_customer_product_discount.* , tg_master_product.product_name,tg_master_product.product_group,tg_master_product.product_code,tg_customer.company_name, tg_customer.cust_code, tg_customer.email,tg_customer.mobile,tg_customer.landline_no,tg_customer.cust_type FROM tg_customer_product_discount LEFT JOIN tg_customer ON tg_customer.id = tg_customer_product_discount.customer_id LEFT JOIN tg_master_product ON tg_master_product.id = tg_customer_product_discount.product_id  WHERE  1 = 1 AND tg_customer_product_discount.deleted = ? "+ whereCondition +" ORDER BY tg_customer_product_discount.id DESC LIMIT ? OFFSET ? ";
        var filter = [0, postData.limit, postData.start];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                
                var i = res.length - 1;
                if(res.length){
                    res.forEach(x => {
                        x.encrypt_id = encrypt(x.id.toString());
                        if(i==0){
                            resolve(res);
                        }
                        i--;
                    });
                }else{
                    resolve(res);
                }
                
            }
        });
    });
};



Network.addDistributionNetworkProductDiscount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            name: postData.name ? postData.name : '',
            customer_id: postData.customer_id ? postData.customer_id : '',
            product_id: postData.product_id ? postData.product_id : 0,
            min_qty: postData.min_qty ? postData.min_qty : '',
            discount: postData.discount ? postData.discount : '',
            updated_on: nowDateTime,
            created_on: nowDateTime,
            created_by : postData.sfa_web_user_id ? postData.sfa_web_user_id : 0,
            created_by_name : postData.sfa_web_user_name ? postData.sfa_web_user_name : 0,
        }
        
        var queryString = "INSERT INTO tg_customer_product_discount set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



Network.updateDistributionNetworkProductDiscount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            name: postData.name ? postData.name : '',
            customer_id: postData.customer_id ? postData.customer_id : '',
            product_id: postData.product_id ? postData.product_id : 0,
            min_qty: postData.min_qty ? postData.min_qty : '',
            discount: postData.discount ? postData.discount : '',
            updated_on: nowDateTime,
            updated_by : postData.sfa_web_user_id ? postData.sfa_web_user_id : 0,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_customer_product_discount", updateDataValues, postData.discount_product_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



// point summary module list start

Network.getDrPointListCount = function (postData) {
    console.log("salesuser",postData)
    
    return new Promise(function (resolve, reject) { 
        
        var whereCondition = '';
        
        if(postData.filter.customer_id){
            whereCondition += " AND (tg_customer_wallet_detail.customer_id = '"+postData.filter.customer_id+"')"; 
        }
        
        // console.log('filter',postData.filter);
        // console.log('whereCondition',whereCondition);
        
        var queryString = "SELECT IF(COUNT(tg_customer_wallet_detail.id),COUNT(tg_customer_wallet_detail.id),0) as totalCount FROM tg_customer_wallet_detail LEFT JOIN tg_customer ON tg_customer.id = tg_customer_wallet_detail.customer_id  WHERE  1 = 1 "+ whereCondition;
        var filter = [];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


Network.getDrPointListData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if(postData.filter.customer_id){
            whereCondition += " AND (tg_customer_wallet_detail.customer_id = '"+postData.filter.customer_id+"')"; 
        }
        if(postData.filter.user_id){
            whereCondition += " AND (tg_customer_wallet_detail.user_id = '"+postData.filter.user_id+"')"; 
        }
        
        // var queryString = "SELECT tg_customer_wallet_detail.*, tg_coupon.coupon_code,tg_coupon.product_name,tg_coupon.product_code,tg_coupon.used_on as coupon_scanned_on, tg_customer.first_name as against_first_name, tg_customer.last_name as against_last_name, tg_customer.cust_type as against_cust_type FROM tg_customer_wallet_detail LEFT JOIN tg_customer ON tg_customer.id = tg_customer_wallet_detail.against_customer_id   LEFT JOIN tg_coupon ON tg_coupon.id = tg_customer_wallet_detail.coupon_id  WHERE 1 = 1 "+whereCondition+" ORDER BY tg_customer_wallet_detail.ID DESC LIMIT ? OFFSET ?";
        // var filter = [postData.limit ? postData.limit : 1000, postData.start ? postData.start : 0];
        
        var queryString = "SELECT tg_customer_wallet_detail.*,IF(tg_master_product.product_image != '' , CONCAT('"+postData.image_app_path+"', tg_master_product.product_image), '' ) as product_image_path,tg_offer.title as offer_title,tg_offer.code as offer_code, tg_master_gift.title as gift_title, CONCAT('"+postData.image_app_path+"', tg_master_gift.image_filename) as gift_image_filename , tg_coupon.coupon_code,tg_coupon.product_name,tg_coupon.product_code,tg_coupon.used_by_retailer_name,tg_coupon.used_on as coupon_scanned_on, tg_customer.first_name as against_first_name, tg_customer.last_name as against_last_name, tg_customer.cust_type as against_cust_type FROM tg_customer_wallet_detail LEFT JOIN tg_customer ON tg_customer.id = tg_customer_wallet_detail.against_customer_id   LEFT JOIN tg_coupon ON tg_coupon.id = tg_customer_wallet_detail.coupon_id LEFT JOIN tg_master_gift ON tg_master_gift.id = tg_customer_wallet_detail.gift_id LEFT JOIN tg_master_product ON tg_master_product.id = tg_customer_wallet_detail.product_id LEFT JOIN tg_offer ON tg_offer.id = tg_customer_wallet_detail.offer_id  WHERE 1 =  1 "+whereCondition+" ORDER BY tg_customer_wallet_detail.ID DESC LIMIT ? OFFSET ?";
        var filter = [postData.limit ? postData.limit : 1000, postData.start ? postData.start : 0];
        
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                
                var i = res.length - 1;
                if(res.length){
                    res.forEach(x => {
                        x.encrypt_id = encrypt(x.id.toString());
                        x.offer_encrypt_id = encrypt(x.offer_id.toString());
                        if(i==0){
                            resolve(res);
                        }
                        i--;
                    });
                }else{
                    resolve(res);
                }
                
            }
        });
    });
};


// point summary module list end




// sheet upload module start


Network.getSheetUploadCount = function (postData) {
    
    return new Promise(function (resolve, reject) { 
        
        var whereCondition = '';
        
        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount FROM tg_customer_project_sheet WHERE 1 = 1 "+ whereCondition
        var filter = [];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


Network.getSheetUploadList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = ''; 
        // console.log('whereCondition',whereCondition);
        var queryString = "SELECT tg_customer_project_sheet.*, tg_customer.cust_type, tg_customer.first_name,tg_customer.last_name,tg_customer.mobile  FROM tg_customer_project_sheet LEFT JOIN tg_customer ON tg_customer.id = tg_customer_project_sheet.customer_id WHERE 1 = 1 "+ whereCondition +" GROUP BY tg_customer_project_sheet.id ORDER BY id DESC LIMIT ? OFFSET ? ";
        var filter = [postData.limit, postData.start];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var i = res.length - 1;
                if(res.length){
                    res.forEach(async x => {
                        x.sheetData = await Network.getSheetUploadListData(x);
                        x.sheetDataCount = x.sheetData.length ? x.sheetData.length : 0;
                        if(i==0){
                            resolve(res);
                        }
                        i--;
                    });
                }else{
                    resolve(res);
                }
            }
        });
    });
};




Network.getSheetUploadListData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = ''; 
        // console.log('whereCondition',whereCondition);
        var queryString = "SELECT tg_customer_project_sheet_data.*  FROM tg_customer_project_sheet_data  WHERE 1 = 1 "+ whereCondition;
        var filter = [];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



Network.updateSheetPoints = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            status : postData.status ? postData.status : 'Pending',
            verified_qty : postData.verified_qty ? postData.verified_qty : 0,
            status_by : postData.sfa_web_user_id ? postData.sfa_web_user_id : 0,
            status_by_name : postData.sfa_web_user_name ? postData.sfa_web_user_name : '',
            status_on : nowDateTime,
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_customer_project_sheet_data", updateDataValues, postData.sheet_data_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


// sheet upload module end


// project module start


Network.getProjectListCount = function (postData) {
    
    return new Promise(function (resolve, reject) { 
        
        var whereCondition = '';
        
        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount FROM tg_customer_project WHERE 1 = 1 "+ whereCondition
        var filter = [];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


Network.getProjectList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = ''; 
        // console.log('whereCondition',whereCondition);
        var queryString = "SELECT tg_customer_project.*, tg_customer.cust_type, tg_customer.first_name,tg_customer.last_name,tg_customer.mobile  FROM tg_customer_project LEFT JOIN tg_customer ON tg_customer.id = tg_customer_project.customer_id WHERE 1 = 1 "+ whereCondition +" GROUP BY tg_customer_project.id ORDER BY id DESC LIMIT ? OFFSET ? ";
        var filter = [postData.limit, postData.start];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var i = res.length - 1;
                if(res.length){
                    res.forEach(async x => {
                        // x.sheetData = await Network.getSheetUploadListData(x);
                        // x.sheetDataCount = x.sheetData.length ? x.sheetData.length : 0;
                        if(i==0){
                            resolve(res);
                        }
                        i--;
                    });
                }else{
                    resolve(res);
                }
            }
        });
    });
};



// project  module end


module.exports = Network;
