var db = require('../../config/db');
var path = require('path');
var moment = require('moment');
var http = require("https");
var request = require('request');
let jwt = require('jsonwebtoken');
var md5 = require('md5');
const { encrypt, decrypt, encrypter, my_simple_crypt } = require('../../config/common');

var FCM = require('fcm-node');
var serverKey = process.env.FCM_SERVER_KEY;
var fcmProject = new FCM(serverKey);

var Notification = function (data) {
    
};


Notification.getNotificationTypeList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
     
        var queryString = "SELECT tg_master_notification_type.* FROM tg_master_notification_type WHERE  1 = 1 "+ whereCondition +" ORDER BY  ID DESC";
        var filter = [];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Notification.getNotificationDataCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = ''; 
        if(postData.filter.created_on){
            whereCondition += " AND (DATE(tg_customer_notification.created_on) = '"+moment(new Date(postData.filter.created_on)).format('YYYY-MM-DD')+"')"; 
        }

        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount FROM tg_customer_notification WHERE  1 = 1  GROUP BY notification_code "+ whereCondition
        var filter = [];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res.length);
            }
        });
    });
};


Notification.getNotificationDataList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';   
        if(postData.filter.created_on){
            whereCondition += " AND (DATE(tg_customer_notification.created_on) = '"+moment(new Date(postData.filter.created_on)).format('YYYY-MM-DD')+"')"; 
        }
        var queryString = "SELECT tg_customer_notification.*,  IF(tg_customer_notification.image != '' , CONCAT('"+postData.image_app_path+"', tg_customer_notification.image), '' ) as image_path , tg_customer.first_name, tg_customer.last_name, tg_customer.cust_type, tg_customer.cust_type_id FROM tg_customer_notification LEFT JOIN tg_customer ON  tg_customer.id = tg_customer_notification.customer_id  WHERE  1 = 1 "+ whereCondition +"    GROUP BY notification_code ORDER BY ID  DESC LIMIT ? OFFSET ? ";
        var filter = [postData.limit, postData.start];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                if(res.length){
                    var i = res.length - 1;
                    res.forEach(async x => {
                        x.customer_encrypt_id = encrypt(x.customer_id.toString());
                        x.notification_count = await Notification.getNotificationDataListCount({"filter" : {"notification_code" : x.notification_code}})
                        if(i == 0){
                            resolve(res);
                        }
                        i--;
                    });
                }else{
                    resolve(res);
                }
            }
        });
    });
};


Notification.getNotificationDataListCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = ''; 
        if(postData.filter.created_on){
            whereCondition += " AND (DATE(tg_customer_notification.created_on) = '"+moment(new Date(postData.filter.created_on)).format('YYYY-MM-DD')+"')"; 
        }
        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount FROM tg_customer_notification WHERE  1 = 1 "+ whereCondition
        var filter = [];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


Notification.getNotificationDataListDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';   
        if(postData.filter.created_on){
            whereCondition += " AND (DATE(tg_customer_notification.created_on) = '"+moment(new Date(postData.filter.created_on)).format('YYYY-MM-DD')+"')"; 
        }

        if(postData.filter.notification_code){
            whereCondition += " AND (tg_customer_notification.notification_code = '"+postData.filter.notification_code+"')"; 
        }
             
        var queryString = "SELECT tg_customer_notification.*,  IF(tg_customer_notification.image != '' , CONCAT('"+postData.image_app_path+"', tg_customer_notification.image), '' ) as image_path , tg_customer.first_name, tg_customer.last_name, tg_customer.cust_type, tg_customer.cust_type_id FROM tg_customer_notification LEFT JOIN tg_customer ON  tg_customer.id = tg_customer_notification.customer_id  WHERE  1 = 1 "+ whereCondition +" ORDER BY ID  DESC LIMIT ? OFFSET ? ";
        var filter = [postData.limit, postData.start];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                if(res.length){
                    var i = res.length - 1;
                    res.forEach(async x => {
                        x.customer_encrypt_id = encrypt(x.customer_id.toString());
                        if(i == 0){
                            resolve(res);
                        }
                        i--;
                    });
                }else{
                    resolve(res);
                }
            }
        });
    });
};


Notification.sendNotificationData = function (postData) {
    // save in db
    var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
    
    return new Promise(async function (resolve, reject) {
        
        var insertData = {
            customer_id: postData.customer_id ? postData.customer_id : 0,
            title: postData.title ? postData.title : '',
            remark: postData.remark ? postData.remark : '',
            notification_code: postData.notification_code ? postData.notification_code : null,
            notification_type: postData.notification_type ? postData.notification_type : '',
            redirect: postData.redirect ? postData.redirect : 0,
            image: postData.image ? postData.image : '',
            route: postData.route ? postData.route : '',
            status: 0,
            created_on: nowDateTime
        }
        
        console.log('postData', postData);
        
        db.query("INSERT INTO tg_customer_notification set ?", insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                reject(err);
            }
            else {
                var notification_id = res.insertId;
                console.log('notification_id', notification_id);
                var queryString = "SELECT fcm_token FROM tg_customer WHERE id = ?;"
                var filter = [postData.customer_id ? postData.customer_id : 0];
                db.query(queryString, filter, function (err, res) {
                    if (err) {
                        console.log("error: ", err);
                        resolve(err);
                    }
                    else {
                        var Tokens = [];
                        if (res.length) {
                            
                            var i = res.length-1;
                            res.forEach(element => {

                                // var a = isHTML(postData.remark);
                                // console.log('a',a);
                                var remark = postData.remark ? postData.remark : postData.remark;
                                // postData.remark.replaceAll(/<\/?[^>]+(>|$)/gi, "")

                                var message = {
                                    to: element.fcm_token,    
                                    notification: {
                                        title: postData.title,
                                        body: remark ? remark : '',
                                        image: postData.image ? postData.image_app_path + postData.image : '',
                                    },
                                    
                                    data: {  //you can send only notification or only data(or include both)
                                        redirect: postData.redirect ? postData.redirect.toString() : '',
                                        route: postData.route ? postData.route.toString() : '',
                                    },
                                    android: {
                                        notification: {
                                            sound: 'default',
                                            click_action: "FCM_PLUGIN_ACTIVITY",
                                        },
                                    },
                                };
                                
                                fcmProject.send(message, function (err, response) {
                                    if (err) {
                                        // console.log(JSON.parse(err));
                                        console.log("Something has gone wrong!", err);
                                    } else {
                                        console.log("Successfully sent with response: ", response);
                                    }
                                    
                                    resolve(response);
                                });
                                
                                
                            });
                            
                        }else{
                            resolve(res);
                        }
                    }
                });
            }
        }); 
    });    
};


// sfa code


Notification.getNotificationDataCount_salesUser = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = ''; 
        if(postData.filter.created_on){
            whereCondition += " AND (DATE(tg_user_notification.created_on) = '"+moment(new Date(postData.filter.created_on)).format('YYYY-MM-DD')+"')"; 
        }

        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount FROM tg_user_notification WHERE  1 = 1 AND tg_user_notification.notification_code IS NOT NULL GROUP BY notification_code "+ whereCondition
        var filter = [];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res.length);
            }
        });
    });
};


Notification.getNotificationDataList_salesUser = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';   
        if(postData.filter.created_on){
            whereCondition += " AND (DATE(tg_user_notification.created_on) = '"+moment(new Date(postData.filter.created_on)).format('YYYY-MM-DD')+"')"; 
        }
        var queryString = "SELECT tg_user_notification.*,  IF(tg_user_notification.image != '' , CONCAT('"+postData.image_app_path+"', tg_user_notification.image), '' ) as image_path , tg_system_users.name, tg_system_users.emp_code, tg_system_users.designation FROM tg_user_notification LEFT JOIN tg_system_users ON  tg_system_users.id = tg_user_notification.user_id  WHERE  1 = 1 AND tg_user_notification.notification_code IS NOT NULL "+ whereCondition +"  GROUP BY notification_code ORDER BY ID  DESC LIMIT ? OFFSET ? ";
        var filter = [postData.limit, postData.start];
        
        console.log('queryString',queryString);
        console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                if(res.length){
                    var i = res.length - 1;
                    res.forEach(async x => {
                        x.user_encrypt_id = encrypt(x.user_id.toString());
                        x.notification_count = await Notification.getNotificationDataListCount_salesUser({"filter" : {"notification_code" : x.notification_code}})
                        if(i == 0){
                            resolve(res);
                        }
                        i--;
                    });
                }else{
                    resolve(res);
                }
            }
        });
    });
};


Notification.getNotificationDataListCount_salesUser = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = ''; 
        if(postData.filter.created_on){
            whereCondition += " AND (DATE(tg_user_notification.created_on) = '"+moment(new Date(postData.filter.created_on)).format('YYYY-MM-DD')+"')"; 
        }
        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount FROM tg_user_notification WHERE  1 = 1 AND tg_user_notification.notification_code IS NOT NULL "+ whereCondition
        var filter = [];
        
        console.log('queryString',queryString);

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                console.log('res',res);
                var data = {};
                if(res.length){
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


Notification.getNotificationDataListDetail_salesUser = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';   
        if(postData.filter.created_on){
            whereCondition += " AND (DATE(tg_user_notification.created_on) = '"+moment(new Date(postData.filter.created_on)).format('YYYY-MM-DD')+"')"; 
        }

        if(postData.filter.notification_code){
            whereCondition += " AND (tg_user_notification.notification_code = '"+postData.filter.notification_code+"')"; 
        }
             
        var queryString = "SELECT tg_user_notification.*,  IF(tg_user_notification.image != '' , CONCAT('"+postData.image_app_path+"', tg_user_notification.image), '' ) as image_path , tg_system_users.name, tg_system_users.emp_code, tg_system_users.designation FROM tg_user_notification LEFT JOIN tg_system_users ON  tg_system_users.id = tg_user_notification.user_id  WHERE  1 = 1 AND tg_user_notification.notification_code IS NOT NULL "+ whereCondition +" ORDER BY ID  DESC LIMIT ? OFFSET ? ";
        var filter = [postData.limit, postData.start];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                if(res.length){
                    var i = res.length - 1;
                    res.forEach(async x => {
                        x.user_encrypt_id = encrypt(x.user_id.toString());
                        if(i == 0){
                            resolve(res);
                        }
                        i--;
                    });
                }else{
                    resolve(res);
                }
            }
        });
    });
};


Notification.sendNotificationDataToUser = function (postData) {
    // save in db
    var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
    
    return new Promise(async function (resolve, reject) {
        
        var insertData = {
            user_id: postData.user_id ? postData.user_id : 0,
            title: postData.title ? postData.title : '',
            remark: postData.remark ? postData.remark : '',
            notification_code: postData.notification_code ? postData.notification_code : null,
            notification_type: postData.notification_type ? postData.notification_type : '',
            redirect: postData.redirect ? postData.redirect : 0,
            expense_id: postData.expense_id ? postData.expense_id : 0,
            leave_id: postData.leave_id ? postData.leave_id : 0,
            followup_id: postData.followup_id ? postData.followup_id : 0,
            travel_plan_id: postData.travel_plan_id ? postData.travel_plan_id : 0,
            image: postData.image ? postData.image : '',
            route: postData.route ? postData.route : '',
            status: 0,
            created_on: nowDateTime
        }
        
        // console.log('postData -> sendNotificationDataToUser', insertData);
        
        db.query("INSERT INTO tg_user_notification set ?", insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                reject(err);
            }
            else {
                var notification_id = res.insertId;
                console.log('notification_id', notification_id);
                var queryString = "SELECT fcm_token FROM tg_system_users WHERE id = ?;"
                var filter = [postData.user_id ? postData.user_id : 0];
                db.query(queryString, filter, function (err, res) {
                    if (err) {
                        console.log("error: ", err);
                        resolve(err);
                    }
                    else {
                        var Tokens = [];
                        if (res.length) {
                            
                            var i = res.length-1;
                            res.forEach(element => {

                                // var a = isHTML(postData.remark);
                                // console.log('a',a);
                                var remark = postData.remark ? postData.remark : postData.remark;
                                // postData.remark.replaceAll(/<\/?[^>]+(>|$)/gi, "")

                                var message = {
                                    to: element.fcm_token,    
                                    notification: {
                                        title: postData.title,
                                        body: remark ? remark : '',
                                        image: postData.image ? postData.image_app_path + postData.image : '',
                                    },
                                    
                                    data: {  //you can send only notification or only data(or include both)
                                        redirect: postData.redirect ? postData.redirect.toString() : '',
                                        route: postData.route ? postData.route.toString() : '',
                                    },
                                    android: {
                                        notification: {
                                            sound: 'default',
                                            click_action: "FCM_PLUGIN_ACTIVITY",
                                        },
                                    },
                                };
                                
                                fcmProject.send(message, function (err, response) {
                                    if (err) {
                                        // console.log(JSON.parse(err));
                                        console.log("Something has gone wrong!", err);
                                    } else {
                                        console.log("Successfully sent with response: ", response);
                                    }
                                    
                                    resolve(response);
                                });
                                
                                
                            });
                            
                        }else{
                            resolve(res);
                        }
                    }
                });
            }
        }); 
    });    
};


module.exports = Notification;