var db = require('../../config/db');
var path = require('path');
var moment = require('moment');
var http = require("https");
var request = require('request');
let jwt = require('jsonwebtoken');
var md5 = require('md5');
const { encrypt, decrypt, encrypter, my_simple_crypt } = require('../../config/common');
const Network = require("../../models/web/networkModel");


var Offer = function (data) {
    
};


Offer.getOfferCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if(postData.filter.search){
            whereCondition += " AND (title LIKE '%"+postData.filter.search+"%'  OR code LIKE '%"+postData.filter.search+"%' OR description LIKE '%"+postData.filter.search+"%')"; 
        }
        if(postData.filter.title){
            whereCondition += " AND (title LIKE '%"+postData.filter.title+"%')"; 
        }
        if(postData.filter.code){
            whereCondition += " AND (code LIKE '%"+postData.filter.code+"%')"; 
        }
        if(postData.filter.description){
            whereCondition += " AND (description LIKE '%"+postData.filter.description+"%')"; 
        }
        if(postData.filter.status){
            whereCondition += " AND (status LIKE '%"+postData.filter.status+"%')"; 
        }
        if(postData.filter.created_on){
            whereCondition += " AND (created_on = '"+postData.filter.created_on+"')"; 
        }
        
        if(postData.filter.applicable_for_name){
            whereCondition += " AND (applicable_for_name = '"+postData.filter.applicable_for_name+"')"; 
        }
        
        
        if(postData.type == 'active'){
            whereCondition += " AND (status = '1')"; 
        }else if(postData.type == 'deactive'){
            whereCondition += " AND (status = '0')"; 
        }else{
            whereCondition += " AND (1 = 1)"; 
        }
        
        if(postData.filter.date_from && postData.filter.date_to) {
            whereCondition += 'AND ( DATE(tg_offer.created_on) BETWEEN  "' + moment(new Date(postData.filter.date_from)).format('YYYY-MM-DD') + '" AND "' + moment(new Date(postData.filter.date_to)).format('YYYY-MM-DD') + '" )';
        }
        
        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount FROM tg_offer WHERE  deleted = ? "+ whereCondition
        var filter = [0];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


Offer.getOfferListData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if(postData.filter.search){
            whereCondition += " AND (title LIKE '%"+postData.filter.search+"%'  OR code LIKE '%"+postData.filter.search+"%' OR description LIKE '%"+postData.filter.search+"%')"; 
        }
        if(postData.filter.title){
            whereCondition += " AND (title LIKE '%"+postData.filter.title+"%')"; 
        }
        if(postData.filter.code){
            whereCondition += " AND (code LIKE '%"+postData.filter.code+"%')"; 
        }
        if(postData.filter.description){
            whereCondition += " AND (description LIKE '%"+postData.filter.description+"%')"; 
        }
        if(postData.filter.status){
            whereCondition += " AND (status LIKE '%"+postData.filter.status+"%')"; 
        }
        if(postData.filter.created_on){
            whereCondition += " AND (created_on = '"+postData.filter.created_on+"')"; 
        }
        
        if(postData.filter.applicable_for_name){
            whereCondition += " AND (applicable_for_name = '"+postData.filter.applicable_for_name+"')"; 
        }
        
        
        if(postData.filter.date_from && postData.filter.date_to) {
            whereCondition += 'AND ( DATE(tg_offer.created_on) BETWEEN  "' + moment(new Date(postData.filter.date_from)).format('YYYY-MM-DD') + '" AND "' + moment(new Date(postData.filter.date_to)).format('YYYY-MM-DD') + '" )';
        }
        
        
        if(postData.type == 'active'){
            whereCondition += " AND (status = '1')"; 
        }else if(postData.type == 'deactive'){
            whereCondition += " AND (status = '0')"; 
        }else{
            whereCondition += " AND (1 = 1)"; 
        }
        
        var queryString = "SELECT *  FROM tg_offer WHERE  deleted = ? "+ whereCondition +" ORDER BY id DESC LIMIT ? OFFSET ? ";
        var filter = [0, postData.limit, postData.start];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var i = res.length - 1;
                if(res.length){
                    res.forEach(async x => {
                        x.encrypt_id = encrypt(x.id.toString());
                        x.giftCount = await Offer.getOfferGiftDataCount({'offer_id' : x.id})
                        // x.couponCount = await Offer.getOfferCouponCount({'offer_id' : x.id})

                        x.offer_for = [];
                        if(x.distributor_offer){
                            x.offer_for.push({name : "Distributor"});
                        }
                        if(x.retailer_offer){
                            x.offer_for.push({name : "Retailer"});
                        }
                        if(x.sales_user_offer){
                            x.offer_for.push({name : "Sales User"});
                        }

                        if(i==0){
                            resolve(res);
                        }
                        i--;
                    });
                }else{
                    resolve(res);
                }
            }
        });
    });
};



Offer.addOfferData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            title : postData.title ? postData.title : '',
            code : postData.code ? postData.code : null,
            start_date : postData.start_date ? postData.start_date : '',
            end_date : postData.end_date ? postData.end_date : '',
            // applicable_for : postData.applicable_for ? postData.applicable_for : 0,
            // applicable_for_name : postData.applicable_for_name ? postData.applicable_for_name : 'All',
            distributor_offer : postData.distributor_offer ? postData.distributor_offer : 0,
            retailer_offer : postData.retailer_offer ? postData.retailer_offer : 0,
            sales_user_offer : postData.sales_user_offer ? postData.sales_user_offer : 0,
            description : postData.description ? postData.description : '',
            terms_condition : postData.terms_condition ? postData.terms_condition : '',
            status : postData.status ? postData.status : 0,
            created_on: nowDateTime,
            created_by : postData.sfa_web_user_id ? postData.sfa_web_user_id : '',
            created_by_name : postData.sfa_web_user_name ? postData.sfa_web_user_name : '',
            updated_on : nowDateTime
        }
        
        var queryString = "INSERT INTO tg_offer set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Offer.addOfferBannerData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            offer_id : postData.offer_id ? postData.offer_id : 0,   
            banner_filename : postData.banner_filename ? postData.banner_filename : '',   
            status : postData.status ? postData.status : 0,   
            created_on: nowDateTime,
            created_by : postData.sfa_web_user_id ? postData.sfa_web_user_id : '',
            created_by_name : postData.sfa_web_user_name ? postData.sfa_web_user_name : '',
            updated_on : nowDateTime
        }
        
        var queryString = "INSERT INTO tg_offer_banner set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Offer.addOfferSchemeData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            offer_id : postData.offer_id ? postData.offer_id : 0,   
            filename : postData.filename ? postData.filename : '',   
            status : postData.status ? postData.status : 0,   
            created_on: nowDateTime,
            created_by : postData.sfa_web_user_id ? postData.sfa_web_user_id : '',
            created_by_name : postData.sfa_web_user_name ? postData.sfa_web_user_name : '',
            updated_on : nowDateTime
        }
        
        var queryString = "INSERT INTO tg_offer_scheme set ?";  
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Offer.addOfferGiftData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            offer_id : postData.offer_id ? postData.offer_id : 0,   
            title : postData.title ? postData.title : '',   
            gift_id : postData.gift_id ? postData.gift_id : 0,   
            points : postData.points ? postData.points : 0,   
            description : postData.description ? postData.description : 0,   
            status : postData.status ? postData.status : 0,   
            image_filename : postData.image_filename ? postData.image_filename : '',   
            created_on: nowDateTime,
            created_by : postData.sfa_web_user_id ? postData.sfa_web_user_id : '',
            created_by_name : postData.sfa_web_user_name ? postData.sfa_web_user_name : '',
            updated_on : nowDateTime
        }
        
        var queryString = "INSERT INTO tg_offer_gift set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Offer.addOfferAreaData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            offer_id : postData.offer_id ? postData.offer_id : 0,   
            state_name : postData.state_name ? postData.state_name : '',   
            district_name : postData.district_name ? postData.district_name : 0,   
            status : 1,
            created_on: nowDateTime,
            created_by : postData.sfa_web_user_id ? postData.sfa_web_user_id : '',
            created_by_name : postData.sfa_web_user_name ? postData.sfa_web_user_name : ''
        }
        
        var queryString = "INSERT INTO tg_offer_state_district set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



Offer.addOfferSummaryData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            offer_id : postData.offer_id ? postData.offer_id : 0,   
            title : postData.title ? postData.title : '',   
            description : postData.description ? postData.description : 0,   
            created_on: nowDateTime,
            created_by : postData.created_by ? postData.created_by : '',
            created_by_name : postData.created_by_name ? postData.created_by_name : ''
        }
        
        var queryString = "INSERT INTO tg_offer_summary set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Offer.updateOfferData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            title : postData.title ? postData.title : '',
            code : postData.code ? postData.code : null,
            start_date : postData.start_date ? postData.start_date : '',
            end_date : postData.end_date ? postData.end_date : '',
            // applicable_for : postData.applicable_for ? postData.applicable_for : 0,
            // applicable_for_name : postData.applicable_for_name ? postData.applicable_for_name : 'All',
            distributor_offer : postData.distributor_offer ? postData.distributor_offer : 0,
            retailer_offer : postData.retailer_offer ? postData.retailer_offer : 0,
            sales_user_offer : postData.sales_user_offer ? postData.sales_user_offer : 0,
            description : postData.description ? postData.description : '',
            terms_condition : postData.terms_condition ? postData.terms_condition : '',
            status : postData.status ? postData.status : 0,
            updated_on : nowDateTime
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_offer", updateDataValues, postData.offer_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};

Offer.updateCouponValidUpto = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            valid_upto : postData.end_date ? postData.end_date : '',
            updated_on : nowDateTime
        }
        
        var queryString = "UPDATE ?? SET ? WHERE offer_id = ?;"
        var filter = ["tg_coupon", updateDataValues, postData.offer_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Offer.updateOfferStatusData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            status : postData.status ? postData.status : 0,
            updated_on : nowDateTime
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_offer", updateDataValues, postData.offer_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};

Offer.updateOfferGiftData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            title : postData.title ? postData.title : '',   
            gift_id : postData.gift_id ? postData.gift_id : 0,   
            points : postData.points ? postData.points : 0,   
            description : postData.description ? postData.description : 0,   
            status : postData.status ? postData.status : 0,   
            image_filename : postData.image_filename ? postData.image_filename : '',   
            updated_on : nowDateTime
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_offer_gift", updateDataValues, postData.id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Offer.updateOfferBannerData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            banner_filename : postData.banner_filename ? postData.banner_filename : '',   
            status : postData.status ? postData.status : 0,   
            updated_on : nowDateTime
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_offer_banner", updateDataValues, postData.banner_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



Offer.getOfferDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        var queryString = "SELECT tg_offer.*  FROM tg_offer WHERE  id = ? "+ whereCondition;
        var filter = [postData.offer_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};


Offer.getOfferBannerData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        var queryString = "SELECT tg_offer_banner.*, CONCAT('"+postData.image_app_path+"', tg_offer_banner.banner_filename) as banner_filename_path  FROM tg_offer_banner WHERE  offer_id = ? AND status = ? "+ whereCondition;
        var filter = [postData.offer_id, 1];
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Offer.getOfferSchemeData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        var queryString = "SELECT tg_offer_scheme.*, CONCAT('"+postData.image_app_path+"', tg_offer_scheme.filename) as filename_path  FROM tg_offer_scheme WHERE  offer_id = ? AND status = ? "+ whereCondition;
        var filter = [postData.offer_id, 1];
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Offer.getOfferGiftDataCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount FROM tg_offer_gift WHERE offer_id = ? AND status = ?";
        var filter = [postData.offer_id, 1];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};

Offer.getOfferCouponCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount FROM tg_coupon WHERE offer_id = ? AND status = ?";
        var filter = [postData.offer_id, 1];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


Offer.getOfferGiftData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        var queryString = "SELECT tg_offer_gift.* ,CONCAT('"+postData.image_app_path+"', tg_offer_gift.image_filename) as image_filename_path  FROM tg_offer_gift WHERE  offer_id = ? AND status = ? "+ whereCondition;
        var filter = [postData.offer_id, 1];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var i = res.length - 1;
                if(res.length){
                    res.forEach(async x => {
                        x.redeem_rqst_count = await Offer.getRedeemRequestCount({"filter" : { "gift_id" : x.gift_id, "offer_id" : x.offer_id}});
                        if(i==0){
                            resolve(res);
                        }
                        i--;
                    });
                }else{
                    resolve(res);
                }
            }
        });
    });
};


Offer.getOfferAreaData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        var queryString = "SELECT tg_offer_state_district.*  FROM tg_offer_state_district WHERE  offer_id = ? AND status = ? "+ whereCondition;
        var filter = [postData.offer_id, 1];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Offer.getOfferSummaryData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        var queryString = "SELECT tg_offer_summary.*  FROM tg_offer_summary WHERE  offer_id = ? "+ whereCondition;
        var filter = [postData.offer_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



Offer.deleteOfferData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            deleted : 1,
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_offer", updateDataValues, postData.offer_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Offer.deleteOfferGiftData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            status : 0,
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE offer_id = ?;"
        var filter = ["tg_offer_gift", updateDataValues, postData.offer_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



Offer.deleteOfferBannerData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            status : 0,
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE offer_id = ?;"
        var filter = ["tg_offer_banner", updateDataValues, postData.offer_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



Offer.deleteOfferSchemeData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            status : 0,
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE offer_id = ?;"
        var filter = ["tg_offer_scheme", updateDataValues, postData.offer_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Offer.deleteOfferAreaData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            status : 0,
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE offer_id = ?;"
        var filter = ["tg_offer_state_district", updateDataValues, postData.offer_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Offer.getGiftCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if(postData.filter.search){
            whereCondition += " AND (title LIKE '%"+postData.filter.search+"%'  OR code LIKE '%"+postData.filter.search+"%' OR description LIKE '%"+postData.filter.search+"%')"; 
        }
        if(postData.filter.title){
            whereCondition += " AND (title LIKE '%"+postData.filter.title+"%')"; 
        }
        if(postData.filter.code){
            whereCondition += " AND (code LIKE '%"+postData.filter.code+"%')"; 
        }
        if(postData.filter.description){
            whereCondition += " AND (description LIKE '%"+postData.filter.description+"%')"; 
        }
        
        if(postData.filter.created_on){
            whereCondition += " AND (created_on = '"+postData.filter.created_on+"')"; 
        }
        
        if(postData.filter.statusName != 'All' && postData.filter.statusName != undefined){
            whereCondition += " AND (status = '"+postData.filter.status+"')"; 
        }
        
        
        if(postData.filter.date_from && postData.filter.date_to) {
            whereCondition += 'AND ( DATE(tg_master_gift.created_on) BETWEEN  "' + moment(new Date(postData.filter.date_from)).format('YYYY-MM-DD') + '" AND "' + moment(new Date(postData.filter.date_to)).format('YYYY-MM-DD') + '" )';
        }
        
        
        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount FROM tg_master_gift WHERE  1 = 1 "+ whereCondition
        var filter = [];
        
        // console.log('queryString',queryString);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


Offer.getGiftListData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if(postData.filter.search){
            whereCondition += " AND (title LIKE '%"+postData.filter.search+"%'  OR code LIKE '%"+postData.filter.search+"%' OR description LIKE '%"+postData.filter.search+"%')"; 
        }
        if(postData.filter.title){
            whereCondition += " AND (title LIKE '%"+postData.filter.title+"%')"; 
        }
        if(postData.filter.code){
            whereCondition += " AND (code LIKE '%"+postData.filter.code+"%')"; 
        }
        if(postData.filter.description){
            whereCondition += " AND (description LIKE '%"+postData.filter.description+"%')"; 
        }
        if(postData.filter.status){
            whereCondition += " AND (status LIKE '%"+postData.filter.status+"%')"; 
        }
        if(postData.filter.created_on){
            whereCondition += " AND (created_on = '"+postData.filter.created_on+"')"; 
        }
        
        if(postData.filter.statusName != 'All' && postData.filter.statusName != undefined){
            whereCondition += " AND (status = '"+postData.filter.status+"')"; 
        }
        
        if(postData.filter.distributor_gift){
            whereCondition += " AND (distributor_gift = '"+postData.filter.distributor_gift+"')"; 
        }

        if(postData.filter.sales_user_gift){
            whereCondition += " AND (sales_user_gift = '"+postData.filter.sales_user_gift+"')"; 
        }

        if(postData.filter.retailer_gift){
            whereCondition += " AND (retailer_gift = '"+postData.filter.retailer_gift+"')"; 
        }

        if(postData.filter.date_from && postData.filter.date_to) {
            whereCondition += 'AND ( DATE(tg_master_gift.created_on) BETWEEN  "' + moment(new Date(postData.filter.date_from)).format('YYYY-MM-DD') + '" AND "' + moment(new Date(postData.filter.date_to)).format('YYYY-MM-DD') + '" )';
        }
        
        var queryString = "SELECT tg_master_gift.*, IF(tg_master_gift.image_filename != '', CONCAT('"+postData.image_app_path+"', tg_master_gift.image_filename), '') as image_filename_path  FROM tg_master_gift WHERE  1 = 1 And deleted = ? "+ whereCondition +" ORDER BY ID DESC LIMIT ? OFFSET ? ";
        var filter = [0,postData.limit, postData.start];
        
        console.log('queryString',queryString);
        console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var i = res.length - 1;
                if(res.length){
                    res.forEach(async x => {
                        x.encrypt_id = encrypt(x.id.toString());
                        
                        x.pending_redeem_req = await Offer.getRedeemRequestCount({"filter" : {"gift_id" : x.id , "redeem_status" : "Pending"}});
                        x.approved_redeem_req = await Offer.getRedeemRequestCount({"filter" : {"gift_id" : x.id, "redeem_status" : "Approved"}});
                        x.reject_redeem_req = await Offer.getRedeemRequestCount({"filter" : {"gift_id" : x.id, "redeem_status" : "Reject"}});                        
                        // x.total_redeem_req = await Offer.getRedeemRequestCount({"filter" : {"gift_id" : x.id}});  
                        
                        // x.distributor_redeem_req = await Offer.getRedeemRequestCount({"filter" : { "cust_type_id" : 1, "gift_id" : x.id}});
                        // x.retailer_redeem_req = await  Offer.getRedeemRequestCount({"filter" : { "cust_type_id" : 4, "gift_id" : x.id}});


                        x.user_type = [];
                        if(x.distributor_gift){
                            x.user_type.push({user_type : "Distributor"});
                        }
                        if(x.retailer_gift){
                            x.user_type.push({user_type : "Retailer"});
                        }
                        if(x.sales_user_gift){
                            x.user_type.push({user_type : "Sales User"});
                        }
                        // x.offer_encrypt_id = encrypt(x.offer_id.toString());
                        if(i==0){
                            resolve(res);
                        }
                        i--;
                    });
                }else{
                    resolve(res);
                }
            }
        });
    });
};



Offer.addGiftData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            title : postData.title ? postData.title : '',
            points : postData.points ? postData.points : 0 ,
            description : postData.description ? postData.description : '',
            image_filename : postData.image_filename ? postData.image_filename : '',
            distributor_gift : postData.distributor_gift == true ? 1 : 0,
            retailer_gift : postData.retailer_gift == true ? 1 : 0,
            sales_user_gift : postData.sales_user_gift == true ? 1 : 0,
            status : postData.status ? postData.status : 0,
            created_on: nowDateTime,
            created_by : postData.sfa_web_user_id ? postData.sfa_web_user_id : '',
            created_by_name : postData.sfa_web_user_name ? postData.sfa_web_user_name : '',
            updated_on : nowDateTime
        }
        
        var queryString = "INSERT INTO tg_master_gift set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



Offer.updateGiftData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            title : postData.title ? postData.title : '',
            points : postData.points ? postData.points : 0,
            description : postData.description ? postData.description : '',
            image_filename : postData.image_filename ? postData.image_filename : '',
            distributor_gift : postData.distributor_gift == true ? 1 : 0,
            retailer_gift : postData.retailer_gift == true ? 1 : 0,
            sales_user_gift : postData.sales_user_gift == true ? 1 : 0,
            status : postData.status ? postData.status : 0,
            updated_on : nowDateTime
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_master_gift", updateDataValues, postData.gift_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};

Offer.deletegiftData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            status : 0,
            deleted : 1,
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_master_gift", updateDataValues, postData.gift_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};

Offer.updateGiftStatusData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            status : postData.status ? postData.status : 0,
            updated_on : nowDateTime
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_master_gift", updateDataValues, postData.gift_id];

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Offer.getGiftDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        var queryString = "SELECT tg_master_gift.* , IF(tg_master_gift.image_filename != '', CONCAT('"+postData.image_app_path+"', tg_master_gift.image_filename), '') as image_filename_path  FROM tg_master_gift WHERE  id = ? "+ whereCondition;
        var filter = [postData.gift_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0];
                    data.encrypt_id = encrypt(data.id.toString());
                    data.pending_redeem_req = await Offer.getRedeemRequestCount({"filter" : {"gift_id" : data.id , "redeem_status" : "Pending"}});
                    data.approved_redeem_req = await Offer.getRedeemRequestCount({"filter" : {"gift_id" : data.id, "redeem_status" : "Approved"}});
                    data.reject_redeem_req = await Offer.getRedeemRequestCount({"filter" : {"gift_id" : data.id, "redeem_status" : "Reject"}});                        
                    data.total_redeem_req = await Offer.getRedeemRequestCount({"filter" : {"gift_id" : data.id}});  
                    
                    // data.carpenter_redeem_req = await Offer.getRedeemRequestCount({"filter" : { "cust_type_id" : 3, "gift_id" : data.id}});
                    // data.architect_redeem_req = await  Offer.getRedeemRequestCount({"filter" : { "cust_type_id" : 4, "gift_id" : data.id}});
                   
                }
                resolve(data);
            }
        });
    });
};


Offer.getMasterGiftDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        var queryString = "SELECT tg_master_gift.* , IF(tg_master_gift.image_filename != '', CONCAT('"+postData.image_app_path+"', tg_master_gift.image_filename), '') as image_filename_path  FROM tg_master_gift WHERE  id = ? "+ whereCondition;
        var filter = [postData.gift_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};


// coupon module start




Offer.getCouponCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if(postData.filter.search){
            whereCondition += " AND (title LIKE '%"+postData.filter.search+"%'  OR code LIKE '%"+postData.filter.search+"%' OR description LIKE '%"+postData.filter.search+"%')"; 
        }
        if(postData.filter.title){
            whereCondition += " AND (title LIKE '%"+postData.filter.title+"%')"; 
        }
        if(postData.filter.code){
            whereCondition += " AND (code LIKE '%"+postData.filter.code+"%')"; 
        }
        if(postData.filter.description){
            whereCondition += " AND (description LIKE '%"+postData.filter.description+"%')"; 
        }
        
        if(postData.filter.created_on){
            whereCondition += " AND (created_on = '"+postData.filter.created_on+"')"; 
        }
        
        
        if(postData.filter.date_from && postData.filter.date_to) {
            whereCondition += 'AND ( DATE(tg_coupon.created_on) BETWEEN  "' + moment(new Date(postData.filter.date_from)).format('YYYY-MM-DD') + '" AND "' + moment(new Date(postData.filter.date_to)).format('YYYY-MM-DD') + '" )';
        }
        
        
        if(postData.filter.used_by){
            whereCondition += " AND (used_by = '"+postData.filter.used_by+"')"; 
        }
        
        if(postData.filter.used_by_carpenter){
            whereCondition += " AND (used_by_carpenter = '"+postData.filter.used_by_carpenter+"')"; 
        }
        
        if(postData.filter.used_by_architect){
            whereCondition += " AND (used_by_architect = '"+postData.filter.used_by_architect+"')"; 
        }
        
        if(postData.filter.coupon_code){
            whereCondition += " AND (coupon_code = '"+postData.filter.coupon_code+"')"; 
        }
        
        if(postData.filter.product_code){
            whereCondition += " AND (product_code LIKE '%"+postData.filter.product_code+"%')"; 
        }
        
        if(postData.filter.product_category){
            whereCondition += " AND (product_category LIKE '%"+postData.filter.product_category+"%')"; 
        }
        
        if(postData.filter.used_by_name){
            whereCondition += " AND (used_by_name LIKE '%"+postData.filter.used_by_name+"%')"; 
        }
        
        
        
        if(postData.filter.offer_id){
            whereCondition += " AND (offer_id = '"+postData.filter.offer_id+"')"; 
        }
        
        if(postData.filter.coupon_ref){
            whereCondition += " AND (coupon_ref = '"+postData.filter.coupon_ref+"')"; 
        }
        
        if(postData.filter.statusName != 'All' && postData.filter.statusName != undefined){
            if(postData.filter.statusName == 'Scanned'){
                whereCondition += " AND (used_by != '0')"; 
            }
            if(postData.filter.statusName == 'Scanned By Retailer'){
                whereCondition += " AND (used_by_retailer != '0')"; 
            }
            if(postData.filter.statusName == 'Scanned By Carpenter'){
                whereCondition += " AND (used_by_carpenter != '0')"; 
            }
            if(postData.filter.statusName == 'Available'){
                whereCondition += " AND (used_by = '0')"; 
            }
        }
        
        if(postData.customer_encrypt_id){
            whereCondition += " AND (used_by = '"+decrypt(postData.customer_encrypt_id)+"')"; 
        }
        
        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount FROM tg_coupon WHERE  tg_coupon.status = ? "+ whereCondition
        var filter = [1];
        
        console.log('queryString',queryString);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


Offer.getCouponListData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if(postData.filter.search){
            whereCondition += " AND (title LIKE '%"+postData.filter.search+"%'  OR code LIKE '%"+postData.filter.search+"%' OR description LIKE '%"+postData.filter.search+"%')"; 
        }
        if(postData.filter.title){
            whereCondition += " AND (title LIKE '%"+postData.filter.title+"%')"; 
        }
        if(postData.filter.code){
            whereCondition += " AND (code LIKE '%"+postData.filter.code+"%')"; 
        }
        if(postData.filter.description){
            whereCondition += " AND (description LIKE '%"+postData.filter.description+"%')"; 
        }
        if(postData.filter.status){
            whereCondition += " AND (status LIKE '%"+postData.filter.status+"%')"; 
        }
        if(postData.filter.created_on){
            whereCondition += " AND (created_on = '"+postData.filter.created_on+"')"; 
        }
        
        if(postData.filter.offer_id){
            whereCondition += " AND (offer_id = '"+postData.filter.offer_id+"')"; 
        }
        
        
        if(postData.filter.coupon_code){
            whereCondition += " AND (coupon_code = '"+postData.filter.coupon_code+"')"; 
        }
        
        if(postData.filter.product_code){
            whereCondition += " AND (product_code LIKE '%"+postData.filter.product_code+"%')"; 
        }
    
        if(postData.filter.product_name){
            whereCondition += " AND (product_name LIKE '%"+postData.filter.product_name+"%')"; 
        }
        if(postData.filter.used_by_retailer_mobile){
            whereCondition += " AND (used_by_retailer_mobile LIKE '%"+postData.filter.mobile+"%')"; 
        }
        if (postData.filter.address) {
            whereCondition += " AND (tg_customer.state_name LIKE '%" + postData.filter.address + "%' OR tg_customer.district_name LIKE '%" + postData.filter.address + "%')";
        }
        
       
        
        
        if(postData.filter.used_by_retailer_name){
            whereCondition += " AND (used_by_retailer_name LIKE '%"+postData.filter.used_by_retailer_name+"%')"; 
        }
        
        
        if(postData.filter.coupon_ref){
            whereCondition += " AND (coupon_ref = '"+postData.filter.coupon_ref+"')"; 
        }
        
        if(postData.filter.used_by){
            whereCondition += " AND (used_by = '"+postData.filter.used_by+"')"; 
        }
        
        if(postData.filter.used_by_carpenter){
            whereCondition += " AND (used_by_carpenter = '"+postData.filter.used_by_carpenter+"')"; 
        }
        
        if(postData.filter.used_by_architect){
            whereCondition += " AND (used_by_architect = '"+postData.filter.used_by_architect+"')"; 
        }
        
        if(postData.filter.statusName != 'All' && postData.filter.statusName != undefined){
            if(postData.filter.statusName == 'Scanned'){
                whereCondition += " AND (used_by != '0')"; 
            }
            if(postData.filter.statusName == 'Scanned By Architect'){
                whereCondition += " AND (used_by_architect != '0')"; 
            }

            if(postData.filter.statusName == 'Scanned By Retailer'){
                whereCondition += " AND (used_by_retailer != '0')"; 
            }
            
            if(postData.filter.statusName == 'Scanned By Carpenter'){
                whereCondition += " AND (used_by_carpenter != '0')"; 
            }
            if(postData.filter.statusName == 'Available'){
                whereCondition += " AND (used_by = '0')"; 
            }
        }
        
        if(postData.customer_encrypt_id){
            whereCondition += " AND (used_by = '"+decrypt(postData.customer_encrypt_id)+"')"; 
        }
        
        if(postData.filter.date_from && postData.filter.date_to) {
            whereCondition += 'AND ( DATE(tg_coupon.created_on) BETWEEN  "' + moment(new Date(postData.filter.date_from)).format('YYYY-MM-DD') + '" AND "' + moment(new Date(postData.filter.date_to)).format('YYYY-MM-DD') + '" )';
        }
        
        
        var queryString = "SELECT tg_coupon.*, tg_customer.mobile, tg_customer.mobile as used_by_mobile, tg_customer.cust_type, tg_customer.state_name, tg_customer.district_name , tg_customer.city, tg_customer.pincode, tg_customer.cust_type_id, tg_offer.title as offer_title, tg_offer.code as offer_code, tg_offer.start_date as offer_start_date, tg_offer.end_date as offer_end_date FROM tg_coupon LEFT JOIN tg_customer ON tg_customer.id = tg_coupon.used_by  LEFT JOIN tg_offer ON tg_offer.id = tg_coupon.offer_id  WHERE  tg_coupon.status = ? "+ whereCondition +" ORDER BY ID DESC LIMIT ? OFFSET ? ";
        // var filter = [1, 50, 0];
        var filter = [1, postData.limit, postData.start];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var i = res.length - 1;
                if(res.length){
                    res.forEach(x => {
                        x.encrypt_id = encrypt(x.id.toString());
                        // x.scanned_carpenter = x.used_by_type_id == 3 ? 1 : 0;
                        // x.scanned_architect = x.used_by_type_id == 4 ? 1 : 0;
                        x.cust_type_id = postData.cust_type_id; // only use for distributor detail page data;  only use when front. dev. send customer_encrypt_id
                        x.point = x.used_by_type_id == 4 ? x.architect_point : x.carpenter_point;
                        x.offer_encrypt_id = encrypt(x.offer_id.toString());
                        x.cust_encrypt_id = encrypt(x.used_by.toString());
                        x.cust_architect_encrypt_id = encrypt(x.used_by_architect.toString());
                        x.cust_carpenter_encrypt_id = encrypt(x.used_by_carpenter.toString());
                        x.reopen_available = true;
                        if(i==0){
                            resolve(res);
                        }
                        i--;
                    });
                }else{
                    resolve(res);
                }
            }
        });
    });
};



Offer.getCouponGrouppedCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if(postData.filter.search){
            whereCondition += " AND (title LIKE '%"+postData.filter.search+"%'  OR code LIKE '%"+postData.filter.search+"%' OR description LIKE '%"+postData.filter.search+"%')"; 
        }
        if(postData.filter.title){
            whereCondition += " AND (title LIKE '%"+postData.filter.title+"%')"; 
        }
        if(postData.filter.code){
            whereCondition += " AND (code LIKE '%"+postData.filter.code+"%')"; 
        }
        if(postData.filter.description){
            whereCondition += " AND (description LIKE '%"+postData.filter.description+"%')"; 
        }
        
        if(postData.filter.created_on){
            whereCondition += " AND (created_on = '"+postData.filter.created_on+"')"; 
        }
        
        if(postData.filter.used_by){
            whereCondition += " AND (used_by = '"+postData.filter.used_by+"')"; 
        }
        
        if(postData.filter.offer_id){
            whereCondition += " AND (offer_id = '"+postData.filter.offer_id+"')"; 
        }
        
        if(postData.filter.statusName != 'All' && postData.filter.statusName != undefined){
            if(postData.filter.statusName == 'Scanned'){
                whereCondition += " AND (used_by != '0')"; 
            }
            if(postData.filter.statusName == 'Available'){
                whereCondition += " AND (used_by = '0')"; 
            }
        }
        
        
        if(postData.customer_encrypt_id){
            whereCondition += " AND (used_by = '"+decrypt(postData.customer_encrypt_id)+"')"; 
        }
        
        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount FROM tg_coupon WHERE  tg_coupon.status = ? "+ whereCondition + "GROUP BY tg_coupon.coupon_ref";
        var filter = [1];
        
        // console.log('queryString',queryString);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res.length;
                }
                resolve(data);
            }
        });
    });
};


// Offer.getCouponGrouppedList = function (postData) {
    
//     return new Promise(function (resolve, reject) {
        
//         var whereCondition = '';
//         if(postData.filter.search){
//             whereCondition += " AND (title LIKE '%"+postData.filter.search+"%'  OR code LIKE '%"+postData.filter.search+"%' OR description LIKE '%"+postData.filter.search+"%')";
//         }
//         if(postData.filter.title){
//             whereCondition += " AND (title LIKE '%"+postData.filter.title+"%')";
//         }
//         if(postData.filter.code){
//             whereCondition += " AND (code LIKE '%"+postData.filter.code+"%')";
//         }
//         if(postData.filter.description){
//             whereCondition += " AND (description LIKE '%"+postData.filter.description+"%')";
//         }
//         if(postData.filter.status){
//             whereCondition += " AND (status LIKE '%"+postData.filter.status+"%')";
//         }
//         if(postData.filter.created_on){
//             whereCondition += " AND (created_on = '"+postData.filter.created_on+"')";
//         }
        
//         if(postData.filter.offer_id){
//             whereCondition += " AND (offer_id = '"+postData.filter.offer_id+"')";
//         }
        
//         if(postData.filter.used_by){
//             whereCondition += " AND (used_by = '"+postData.filter.used_by+"')";
//         }
        
//         if(postData.filter.statusName != 'All' && postData.filter.statusName != undefined){
//             if(postData.filter.statusName == 'Scanned'){
//                 whereCondition += " AND (used_by != '0')";
//             }
//             if(postData.filter.statusName == 'Available'){
//                 whereCondition += " AND (used_by = '0')";
//             }
//         }
        
        
//         if(postData.customer_encrypt_id){
//             whereCondition += " AND (used_by = '"+decrypt(postData.customer_encrypt_id)+"')";
//         }
        
        
//         var queryString = "SELECT tg_coupon.*, tg_customer.mobile,tg_customer.cust_type, tg_customer.state_name, tg_customer.district_name  FROM tg_coupon LEFT JOIN tg_customer ON tg_customer.id = tg_coupon.used_by WHERE  tg_coupon.status = ? "+ whereCondition +" GROUP BY tg_coupon.coupon_ref  ORDER BY ID DESC LIMIT ? OFFSET ? ";
//         var filter = [1, postData.limit, postData.start];
        
//         // console.log('queryString',queryString);
//         // console.log('filter',filter);
        
//         db.query(queryString, filter, function (err, res) {
//             if (err) {
//                 console.log("error: ", err);
//                 return reject(err);
//             }
//             else {
//                 var i = res.length - 1;
//                 if(res.length){
//                     res.forEach(async x => {
//                         x.encrypt_id = encrypt(x.id.toString());
//                         x.scanned_carpenter = x.used_by_type_id == 3 ? 1 : 0;
//                         x.scanned_architect = x.used_by_type_id == 4 ? 1 : 0;
//                         x.point = x.used_by_type_id == 4 ? x.architect_point : x.carpenter_point;
//                         x.totalCouponCount = await Offer.getCouponCount({"filter" : {"coupon_ref" : x.coupon_ref}});
//                         x.availableCouponCount = await Offer.getCouponCount({"filter" : {"coupon_ref" : x.coupon_ref, "statusName" : "Available"}});
//                         x.usedCouponCount = await Offer.getCouponCount({"filter" : {"coupon_ref" : x.coupon_ref, "statusName" : "Scanned"}});
//                         // x.couponDetailData = await Offer.getCouponListData({"filter" : {"coupon_ref" : x.coupon_ref}, "start" : 0, "limit" : 100000});
//                         // x.offer_encrypt_id = encrypt(x.offer_id.toString());
//                         if(i==0){
//                             resolve(res);
//                         }
//                         i--;
//                     });
//                 }else{
//                     resolve(res);
//                 }
//             }
//         });
//     });
// };


Offer.getCouponGrouppedList = function (postData) {
    return new Promise(function (resolve, reject) {
        let whereCondition = '';
        let filter = [1]; // default filter value for status

        // Dynamically build WHERE condition and filter array
        for (let key in postData.filter) {
            if (postData.filter[key]) {
                if (key === 'statusName' && (postData.filter[key] !== 'All' && postData.filter[key] !== undefined)) {
                    if (postData.filter[key] === 'Scanned') {
                        whereCondition += " AND (used_by != '0')";
                    } else if (postData.filter[key] === 'Available') {
                        whereCondition += " AND (used_by = '0')";
                    }
                } else if (key === 'created_on' || key === 'offer_id' || key === 'used_by') {
                    whereCondition += ` AND (${key} = ?)`;
                    filter.push(postData.filter[key]);
                } else if (key === 'search') {
                    whereCondition += ` AND (title LIKE ? OR code LIKE ? OR description LIKE ?)`;
                    filter.push(`%${postData.filter[key]}%`, `%${postData.filter[key]}%`, `%${postData.filter[key]}%`);
                } else {
                    whereCondition += ` AND (${key} LIKE ?)`;
                    filter.push(`%${postData.filter[key]}%`);
                }
            }
        }

        // Handle customer_encrypt_id
        if (postData.customer_encrypt_id) {
            whereCondition += " AND (used_by = ?)";
            filter.push(decrypt(postData.customer_encrypt_id));
        }

        const queryString = `
            SELECT tg_coupon.*, tg_customer.mobile, tg_customer.cust_type, tg_customer.state_name, tg_customer.district_name  
            FROM tg_coupon 
            LEFT JOIN tg_customer ON tg_customer.id = tg_coupon.used_by 
            WHERE tg_coupon.status = ? ${whereCondition} 
            GROUP BY tg_coupon.coupon_ref 
            ORDER BY ID DESC 
            LIMIT ? OFFSET ?`;

        filter.push(postData.limit, postData.start);

        // Perform database query
        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            } else {
                if (res.length) {
                    for (const x of res) {
                        x.encrypt_id = encrypt(x.id.toString());
                        x.scanned_carpenter = x.used_by_type_id == 3 ? 1 : 0;
                        x.scanned_architect = x.used_by_type_id == 4 ? 1 : 0;
                        x.point = x.used_by_type_id == 4 ? x.architect_point : x.carpenter_point;
                        x.totalCouponCount = await Offer.getCouponCount({ "filter": { "coupon_ref": x.coupon_ref } });
                        // x.availableCouponCount = await Offer.getCouponCount({ "filter": { "coupon_ref": x.coupon_ref, "statusName": "Available" } });
                        // x.usedCouponCount = await Offer.getCouponCount({ "filter": { "coupon_ref": x.coupon_ref, "statusName": "Scanned" } });
                    }
                }
                resolve(res); // Resolve after all async actions are done
            }
        });
    });
};


Offer.addCouponData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            coupon_ref : postData.coupon_ref ? postData.coupon_ref :null,
            coupon_code : postData.coupon_code ? postData.coupon_code :null,
            offer_id : postData.offer_id ? postData.offer_id : 0,
            offer_title : postData.offer_title ? postData.offer_title : '',
            offer_code : postData.offer_code ? postData.offer_code : '',
            product_id : postData.product_id ? postData.product_id : 0,
            product_code : postData.product_code ? postData.product_code : '',
            product_name : postData.product_name ? postData.product_name : '',
            product_category : postData.product_category ? postData.product_category : '',
            description : postData.description ? postData.description : '',
            batch_number : postData.batch_number ? postData.batch_number : '',
            architect_point : postData.architect_point ? postData.architect_point : 0,
            carpenter_point : postData.carpenter_point ? postData.carpenter_point : 0,
            distributor_point : postData.distributor_point ? postData.distributor_point : 0,
            retailer_point : postData.retailer_point ? postData.retailer_point : 0,
            sales_user_point : postData.sales_user_point ? postData.sales_user_point : 0,
            valid_upto : postData.valid_upto ? postData.valid_upto : '0000-00-00',
            status : postData.status ? postData.status : 1,
            created_on: nowDateTime,
            created_by : postData.sfa_web_user_id ? postData.sfa_web_user_id : '',
            created_by_name : postData.sfa_web_user_name ? postData.sfa_web_user_name : '',
            updated_on : nowDateTime
        }
        
        var queryString = "INSERT INTO tg_coupon set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



Offer.updateCouponData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            status : postData.status ? postData.status : 0,
            updated_on : nowDateTime
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_coupon", updateDataValues, postData.coupon_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



Offer.getCouponDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        var queryString = "SELECT tg_coupon.id, tg_coupon.reopen  FROM tg_coupon WHERE  id = ? "+ whereCondition;
        var filter = [postData.coupon_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};


Offer.reopenCouponData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            used_by : 0,
            reopen : 1,
            reopen_by : postData.sfa_web_user_id,
            reopen_by_name : postData.sfa_web_user_name,
            reopen_on : nowDateTime,
            updated_on : nowDateTime
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_coupon", updateDataValues, postData.coupon_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


// deleted wala FLAG lena h yaa nhi to be think
Offer.deleteMultipleCoupon = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            status : 0,
            updated_on : nowDateTime
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_coupon", updateDataValues, postData.tg_coupon_id];
        
        console.log('updateDataValues',updateDataValues);
        console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};

Offer.deleteCouponGroup = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            // status : postData.status ? postData.status : 0,
            status : 0,
            updated_on : nowDateTime
        }
        
        var queryString = "UPDATE ?? SET ? WHERE coupon_ref = ?;"
        var filter = ["tg_coupon", updateDataValues, postData.coupon_ref];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


// coupon module end


// redeem module start

Offer.getRedeemRequestCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        var whereCondition = '';
        
        
        if(postData.filter.search){
            whereCondition += " AND (tg_customer.first_name LIKE '%"+postData.filter.search+"%'  OR tg_customer.mobile LIKE '%"+postData.filter.search+"%' )"; 
        }
        if(postData.filter.name){
            whereCondition += " AND (tg_customer.first_name LIKE '%"+postData.filter.name+"%')"; 
        }
        
        if(postData.filter.mobile){
            whereCondition += " AND (tg_customer.mobile LIKE '%"+postData.filter.mobile+"%')"; 
        }
        
        if(postData.filter.state_name){
            whereCondition += " AND (tg_customer.state_name LIKE '%"+postData.filter.state_name+"%')"; 
        }
        
        if(postData.filter.address){
            whereCondition += " AND (tg_customer.street LIKE '%"+postData.filter.address+"%' OR tg_customer.state_name LIKE '%"+postData.filter.address+"%' OR tg_customer.district_name LIKE '%"+postData.filter.address+"%' OR tg_customer.pincode LIKE '%"+postData.filter.address+"%')"; 
        }
        
        if(postData.filter.title){
            whereCondition += " AND (title LIKE '%"+postData.filter.title+"%')"; 
        }
        if(postData.filter.code){
            whereCondition += " AND (code LIKE '%"+postData.filter.code+"%')"; 
        }
        if(postData.filter.description){
            whereCondition += " AND (description LIKE '%"+postData.filter.description+"%')"; 
        }
        if(postData.filter.redeem_status){
            whereCondition += " AND (redeem_status = '"+postData.filter.redeem_status+"')"; 
        }
        
        if(postData.filter.gift_title){
            whereCondition += " AND (tg_customer_redeem_request.gift_title LIKE '%"+postData.filter.gift_title+"%')"; 
        }
        
        
        if(postData.filter.offer_title){
            whereCondition += " AND (tg_customer_redeem_request.offer_title LIKE '%"+postData.filter.offer_title+"%')"; 
        }
        
        if(postData.filter.customer_id){
            whereCondition += " AND (customer_id = '"+postData.filter.customer_id+"')"; 
        }
        
        if(postData.filter.cust_type_id){
            whereCondition += " AND (tg_customer_redeem_request.cust_type_id = '"+postData.filter.cust_type_id+"')"; 
        }
        
        if(postData.filter.offer_id){
            whereCondition += " AND (offer_id = '"+postData.filter.offer_id+"')"; 
        }
        
        if(postData.filter.gift_id){
            whereCondition += " AND (gift_id = '"+postData.filter.gift_id+"')"; 
        }
        
        if(postData.customer_encrypt_id){
            whereCondition += " AND (customer_id = '"+decrypt(postData.customer_encrypt_id)+"')"; 
        }
        
        if(postData.filter.statusName != 'All' && postData.filter.statusName != undefined){
            whereCondition += " AND (redeem_status = '"+postData.filter.statusName+"')"; 
        }
        
        
        if(postData.filter.date_from && postData.filter.date_to) {
            whereCondition += 'AND ( DATE(tg_customer_redeem_request.created_on) BETWEEN  "' + moment(new Date(postData.filter.date_from)).format('YYYY-MM-DD') + '" AND "' + moment(new Date(postData.filter.date_to)).format('YYYY-MM-DD') + '" )';
        }
        
        if(postData.filter.created_on) {
            whereCondition += 'AND ( DATE(tg_customer_redeem_request.created_on) =  "' + moment(new Date(postData.filter.created_on)).format('YYYY-MM-DD') + '" )';
        }
        
        
        var queryString = "SELECT IF(COUNT(tg_customer_redeem_request.id),COUNT(tg_customer_redeem_request.id),0) as totalCount FROM tg_customer_redeem_request  LEFT JOIN tg_customer ON tg_customer.id = tg_customer_redeem_request.customer_id  WHERE  1 = 1 "+ whereCondition
        var filter = [];
        
        // console.log('queryString',queryString);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


Offer.getRedeemRequestListData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        
        if(postData.filter.search){
            whereCondition += " AND (tg_customer.first_name LIKE '%"+postData.filter.search+"%'  OR tg_customer.mobile LIKE '%"+postData.filter.search+"%' )"; 
        }
        if(postData.filter.name){
            whereCondition += " AND (tg_customer.first_name LIKE '%"+postData.filter.name+"%')"; 
        }
        
        if(postData.filter.mobile){
            whereCondition += " AND (tg_customer.mobile LIKE '%"+postData.filter.mobile+"%')"; 
        }
        
        if(postData.filter.address){
            whereCondition += " AND (tg_customer.street LIKE '%"+postData.filter.address+"%' OR tg_customer.state_name LIKE '%"+postData.filter.address+"%' OR tg_customer.district_name LIKE '%"+postData.filter.address+"%' OR tg_customer.pincode LIKE '%"+postData.filter.address+"%')"; 
        }
        
        if(postData.filter.state_name){
            whereCondition += " AND (tg_customer.state_name LIKE '%"+postData.filter.state_name+"%')"; 
        }
        
        if(postData.filter.gift_title){
            whereCondition += " AND (tg_customer_redeem_request.gift_title LIKE '%"+postData.filter.gift_title+"%')"; 
        }
        if(postData.filter.gift_status){
            whereCondition += " AND (tg_customer_redeem_request.gift_status LIKE '%"+postData.filter.gift_status+"%')"; 
        }
        
        
        if(postData.filter.offer_title){
            whereCondition += " AND (tg_customer_redeem_request.offer_title LIKE '%"+postData.filter.offer_title+"%')"; 
        }
        
        
        if(postData.filter.code){
            whereCondition += " AND (code LIKE '%"+postData.filter.code+"%')"; 
        }
        if(postData.filter.description){
            whereCondition += " AND (description LIKE '%"+postData.filter.description+"%')"; 
        }
        if(postData.filter.redeem_status){
            whereCondition += " AND (redeem_status LIKE '%"+postData.filter.redeem_status+"%')"; 
        }
        if(postData.filter.cust_type_name){
            whereCondition += " AND (cust_type_name LIKE '%"+postData.filter.cust_type_name+"%')"; 
        }
        
        if(postData.filter.gift_title){
            whereCondition += " AND (gift_title LIKE '%"+postData.filter.gift_title+"%')"; 
        }
        
        if(postData.filter.customer_id){
            whereCondition += " AND (customer_id = '"+postData.filter.customer_id+"')"; 
        }
        
        if(postData.filter.statusName != 'All' && postData.filter.statusName != undefined){
            whereCondition += " AND (redeem_status = '"+postData.filter.statusName+"')"; 
        }
        
        if(postData.customer_encrypt_id){
            whereCondition += " AND (customer_id = '"+decrypt(postData.customer_encrypt_id)+"')"; 
        }
        
        if(postData.filter.offer_id){
            whereCondition += " AND (offer_id = '"+postData.filter.offer_id+"')"; 
        }
        
        
        if(postData.filter.date_from && postData.filter.date_to) {
            whereCondition += 'AND ( DATE(tg_customer_redeem_request.created_on) BETWEEN  "' + moment(new Date(postData.filter.date_from)).format('YYYY-MM-DD') + '" AND "' + moment(new Date(postData.filter.date_to)).format('YYYY-MM-DD') + '" )';
        }
        
        if(postData.filter.created_on) {
            whereCondition += 'AND ( DATE(tg_customer_redeem_request.created_on) =  "' + moment(new Date(postData.filter.created_on)).format('YYYY-MM-DD') + '" )';
        }
        
        
        var queryString = "SELECT tg_customer_redeem_request.*, tg_customer.first_name,tg_customer.last_name, tg_customer.mobile, tg_offer.title as offer_title, tg_offer.code as offer_code,tg_offer.end_date as offer_end_date, tg_customer.state_name  FROM tg_customer_redeem_request LEFT JOIN tg_customer ON tg_customer.id = tg_customer_redeem_request.customer_id LEFT JOIN tg_offer ON tg_offer.id = tg_customer_redeem_request.offer_id WHERE  1 = 1 "+ whereCondition +" ORDER BY ID DESC LIMIT ? OFFSET ? ";
        var filter = [postData.limit, postData.start];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var i = res.length - 1;
                if(res.length){
                    res.forEach(x => {
                        x.encrypt_id = encrypt(x.id.toString());
                        x.offer_encrypt_id = encrypt(x.offer_id.toString());
                        x.cust_encrypt_id = encrypt(x.customer_id.toString());
                        if(i==0){
                            resolve(res);
                        }
                        i--;
                    });
                }else{
                    resolve(res);
                }
            }
        });
    });
};


Offer.getRedeemRequestDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        var queryString = "SELECT tg_master_gift.title as gift_title, tg_master_gift.points as gift_points,tg_master_gift.description as gift_description ,tg_master_gift.created_by_name as gift_created_by_name, tg_master_gift.created_on as gift_created_on, tg_offer.end_date as offer_end_date ,tg_offer.start_date as offer_start_date  , tg_offer.status as offer_status , tg_customer_redeem_request.*, tg_customer.cust_type, tg_customer.first_name,tg_customer.last_name,tg_customer.mobile ,tg_customer.date_of_birth,tg_customer.street,tg_customer.state_name,tg_customer.district_name,tg_customer.city,tg_customer.area,tg_customer.pincode,tg_customer.status as customer_status, CONCAT('"+postData.image_app_path+"', tg_customer.profile_image) as profile_image_path,  IF(tg_master_gift.image_filename != '', CONCAT('"+postData.image_app_path+"', tg_master_gift.image_filename), '') as gift_image_filename_path  FROM tg_customer_redeem_request  LEFT JOIN tg_master_gift ON tg_master_gift.id = tg_customer_redeem_request.gift_id  LEFT JOIN tg_customer ON tg_customer.id = tg_customer_redeem_request.customer_id  LEFT JOIN tg_offer ON tg_offer.id = tg_customer_redeem_request.offer_id   WHERE  tg_customer_redeem_request.id = ? "+ whereCondition;
        var filter = [postData.redeem_request_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0];
                    data.offer_encrypt_id = encrypt(data.offer_id.toString());
                    data.cust_encrypt_id = encrypt(data.customer_id.toString());
                    data.customerDocument = await Network.getDistributionNetworkDocumentDetail({"customer_id" : data.customer_id, "image_app_path" : postData.image_app_path})
                    data.offerData = await Offer.getOfferBannerData({"offer_id" : data.offer_id, "image_app_path" : postData.image_app_path});                    
                }
                resolve(data);
            }
        });
    });
};


Offer.updateRedeemStatus = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            redeem_status : postData.redeem_status ? postData.redeem_status : '',
            redeem_status_remark : postData.redeem_status_remark ? postData.redeem_status_remark : '',
            redeem_status_on : nowDateTime,
            redeem_status_by : postData.sfa_web_user_id ? postData.sfa_web_user_id : 0,
            redeem_status_by_name : postData.sfa_web_user_name ? postData.sfa_web_user_name : ''
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_customer_redeem_request", updateDataValues, postData.redeem_request_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Offer.updateRedeemGiftStatus = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            gift_status : postData.gift_status ? postData.gift_status : '',
            shipment_type : postData.shipment_type ? postData.shipment_type : '',
            shipment_delivery_time : postData.shipment_delivery_time ? moment(postData.shipment_delivery_time).format('YYYY-MM-DD') : '0000-00-00',
            gift_status_remark : postData.gift_status_remark ? postData.gift_status_remark : '',
            gift_status_on : nowDateTime,
            gift_status_by : postData.sfa_web_user_id ? postData.sfa_web_user_id : 0,
            gift_status_by_name : postData.sfa_web_user_name ? postData.sfa_web_user_name : ''
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_customer_redeem_request", updateDataValues, postData.redeem_request_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


// redeem module emd

module.exports = Offer;
