var db = require('../../config/db');
var path = require('path');
var moment = require('moment');
var http = require("https");
var request = require('request');
let jwt = require('jsonwebtoken');
var md5 = require('md5');
const { encrypt, decrypt, encrypter, my_simple_crypt } = require('../../config/common');


var Purchase = function (data) {
    
};



Purchase.getVendorListData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if(postData.filter.search){
            whereCondition += " AND (tg_vendor.company_name LIKE '%"+postData.filter.search+"%'  OR tg_vendor.vendor_code LIKE '%"+postData.filter.search+"%' OR tg_vendor.mobile LIKE '%"+postData.filter.search+"%' )"; 
        }
        if(postData.filter.company_name){
            whereCondition += " AND (tg_vendor.company_name LIKE '%"+postData.filter.company_name+"%')"; 
        }
        if(postData.filter.vendor_code){
            whereCondition += " AND (tg_vendor.vendor_code LIKE '%"+postData.filter.vendor_code+"%')"; 
        }
        if(postData.filter.email){
            whereCondition += " AND (tg_vendor.email LIKE '%"+postData.filter.email+"%')"; 
        }
        if(postData.filter.mobile){
            whereCondition += " AND (tg_vendor.mobile LIKE '%"+postData.filter.mobile+"%')"; 
        }
        
        // console.log('whereCondition',whereCondition);
        var queryString = "SELECT tg_vendor.id,tg_vendor.company_name,tg_vendor.vendor_code,tg_vendor.email,tg_vendor.mobile, tg_vendor.state_name  FROM tg_vendor WHERE status = ? AND 1 = 1 "+ whereCondition +" ORDER BY tg_vendor.company_name ASC LIMIT ? OFFSET ? ";
        var filter = [1, postData.limit, postData.start];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Purchase.getPurchaseOrderNo = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT po_no FROM tg_purchase_order ORDER BY id DESC LIMIT 1";
        var filter = [];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};


Purchase.getPurchaseOrderCount = function (postData) {
    
    return new Promise(function (resolve, reject) { 
        
        var whereCondition = '';
        if(postData.filter.po_no){
            whereCondition += " AND (tg_purchase_order.po_no LIKE '%"+postData.filter.po_no+"%')"; 
        }

        if(postData.filter.vendor_data){
            whereCondition += " AND (tg_vendor.company_name LIKE '%"+postData.filter.vendor_data+"%' OR tg_vendor.mobile LIKE '%"+postData.filter.vendor_data+"%' OR  tg_vendor.vendor_code LIKE '%"+postData.filter.vendor_data+"%' OR  tg_vendor.email LIKE '%"+postData.filter.vendor_data+"%' )"; 
        }
        if(postData.filter.created_on){
            whereCondition += " AND (tg_purchase_order.created_on = '"+postData.filter.created_on+"')"; 
        }
        if(postData.filter.vendor_id){
            whereCondition += " AND (tg_purchase_order.vendor_id = '"+postData.filter.vendor_id+"')"; 
        }
        if(postData.filter.created_by_name){
            whereCondition += " AND (tg_purchase_order.created_by_name LIKE '%"+postData.filter.created_by_name+"%')"; 
        }
        // console.log('whereCondition',whereCondition);
        var queryString = "SELECT IF(COUNT(tg_purchase_order.id),COUNT(tg_purchase_order.id),0) as totalCount FROM ?? LEFT JOIN tg_vendor ON tg_vendor.id = tg_purchase_order.vendor_id  WHERE  1 = 1 AND tg_purchase_order.del = ? "+ whereCondition;
        var filter = ["tg_purchase_order",0];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


Purchase.getPurchaseOrderList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if(postData.filter.po_no){
            whereCondition += " AND (tg_purchase_order.po_no LIKE '%"+postData.filter.po_no+"%')"; 
        }

        if(postData.filter.vendor_data){
            whereCondition += " AND (tg_vendor.company_name LIKE '%"+postData.filter.vendor_data+"%' OR tg_vendor.mobile LIKE '%"+postData.filter.vendor_data+"%' OR  tg_vendor.vendor_code LIKE '%"+postData.filter.vendor_data+"%' OR  tg_vendor.email LIKE '%"+postData.filter.vendor_data+"%' )"; 
        }
        if(postData.filter.created_on){
            whereCondition += " AND (tg_purchase_order.created_on = '"+postData.filter.created_on+"')"; 
        }
        if(postData.filter.vendor_id){
            whereCondition += " AND (tg_purchase_order.vendor_id = '"+postData.filter.vendor_id+"')"; 
        }
        if(postData.filter.created_by_name){
            whereCondition += " AND (tg_purchase_order.created_by_name LIKE '%"+postData.filter.created_by_name+"%')"; 
        }

        // console.log('whereCondition',whereCondition);
        var queryString = "SELECT tg_purchase_order.*, tg_vendor.company_name, tg_vendor.vendor_code, tg_vendor.email,tg_vendor.mobile,tg_vendor.landline_no FROM ??  LEFT JOIN tg_vendor ON tg_vendor.id = tg_purchase_order.vendor_id  WHERE  1 = 1 AND tg_purchase_order.del = ? "+ whereCondition +" ORDER BY tg_purchase_order.id DESC LIMIT ? OFFSET ? ";
        var filter = ["tg_purchase_order", 0, postData.limit, postData.start];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {

                var i = res.length - 1;
                if(res.length){
                    res.forEach(x => {
                        x.encrypt_id = encrypt(x.id.toString());
                        if(i==0){
                            resolve(res);
                        }
                        i--;
                    });
                }else{
                    resolve(res);
                }

            }
        });
    });
};




Purchase.getOrderBasicDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT tg_purchase_order.*, tg_vendor.company_name, tg_vendor.vendor_code, tg_vendor.email,tg_vendor.mobile,tg_vendor.landline_no FROM tg_purchase_order LEFT JOIN tg_vendor ON tg_vendor.id = tg_purchase_order.vendor_id WHERE tg_purchase_order.id = ?";
        var filter = [postData.po_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};


Purchase.getOrderItemDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT tg_purchase_order_item.*, tg_master_product.product_name,tg_master_product.product_code,tg_master_product.product_group, tg_master_product.unit  FROM tg_purchase_order_item LEFT JOIN tg_master_product ON tg_master_product.id = tg_purchase_order_item.product_id  WHERE tg_purchase_order_item.po_id = ?";
        var filter = [postData.po_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Purchase.addPurchaseOrderData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');

        var insertData = {
            vendor_id: postData.vendor_id ? postData.vendor_id : 0,
            po_no: postData.po_no ? postData.po_no : null,
            po_date: postData.po_date ? postData.po_date : '',
            delivery_date: postData.delivery_date ? postData.delivery_date : '',
            // payment_date: postData.payment_date ? postData.payment_date : '',
            total_item: postData.total_item ? postData.total_item : 0,
            total_qty: postData.total_qty ? postData.total_qty : 0,
            freight_amt: postData.freight_amt ? postData.freight_amt : 0,
            cgst_amt: postData.cgst_amt ? postData.cgst_amt : 0,
            sgst_amt: postData.sgst_amt ? postData.sgst_amt : 0,
            igst_amt: postData.igst_amt ? postData.igst_amt : 0,
            total_amt: postData.total_amt ? postData.total_amt : 0,
            tax_amt: postData.tax_amt ? postData.tax_amt : 0,
            remark: postData.remark ? postData.remark : '',
            del: postData.del ? postData.del : 0,
            created_by: postData.created_by ? postData.created_by : 0,
            created_by_name: postData.created_by_name ? postData.created_by_name : '',
            updated_on: nowDateTime,
            created_on: nowDateTime
        }
        
        var queryString = "INSERT INTO tg_purchase_order set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



Purchase.addPurchaseOrderItemData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            po_id: postData.po_id ? postData.po_id : 0,
            vendor_id: postData.vendor_id ? postData.vendor_id : 0,
            product_id: postData.product_id ? postData.product_id : 0,
            qty: postData.qty ? postData.qty : 0,
            rate: postData.rate ? postData.rate : 0,
            discount_amt: postData.discount_amt ? postData.discount_amt : 0,
            discount: postData.discount ? postData.discount : 0,
            tax: postData.tax ? postData.tax : 0,
            tax_amt: postData.tax_amt ? postData.tax_amt : 0,
            total_amt: postData.total_amt ? postData.total_amt : 0,
            status: postData.status ? postData.status : 1,
            updated_on: nowDateTime,
            created_on: nowDateTime
        }
        
        var queryString = "INSERT INTO tg_purchase_order_item set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



Purchase.deletePoData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');

        var queryString = "UPDATE ?? SET `del` = ?, updated_on = ?  WHERE id = ?;"
        var filter = ["tg_purchase_order",  '1', nowDateTime, postData.po_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Purchase.deletePoDataItem = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');

        var queryString = "UPDATE ?? SET `status` = ?, updated_on = ?  WHERE po_id = ?;"
        var filter = ["tg_purchase_order_item",  '0', nowDateTime, postData.po_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


module.exports = Purchase;
