var db = require('../../config/db');
var path = require('path');
var moment = require('moment');
var http = require("https");
var request = require('request');
let jwt = require('jsonwebtoken');
var md5 = require('md5');
const SFA_masterModel = require("./../../models/web/SFA_masterModel");
const Network = require("./../../models/web/networkModel");
const Order = require("./../../models/web/orderModel");
const { encrypt, decrypt, encrypter, my_simple_crypt } = require('../../config/common');


var Report = function (data) {
    
};



Report.getProductGroupWiseReport = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if(postData.filter.search){
            whereCondition += " AND (tg_customer.company_name LIKE '%"+postData.filter.search+"%'  OR tg_customer.cust_code LIKE '%"+postData.filter.search+"%' OR tg_customer.mobile LIKE '%"+postData.filter.search+"%' )"; 
        }
        if(postData.filter.company_name){
            whereCondition += " AND (tg_customer.company_name LIKE '%"+postData.filter.company_name+"%')"; 
        }
        if(postData.filter.cust_code){
            whereCondition += " AND (tg_customer.cust_code LIKE '%"+postData.filter.cust_code+"%')"; 
        }
        if(postData.filter.email){
            whereCondition += " AND (tg_customer.email LIKE '%"+postData.filter.email+"%')"; 
        }
        if(postData.filter.mobile){
            whereCondition += " AND (tg_customer.mobile LIKE '%"+postData.filter.mobile+"%')"; 
        }
        
        // console.log('whereCondition',whereCondition);
        var queryString = "SELECT tg_customer_order.customer_id,tg_customer.company_name,tg_customer.cust_code,tg_customer.email,tg_customer.mobile,tg_customer.cust_type, tg_customer.state_name  FROM tg_customer_order LEFT JOIN tg_customer ON tg_customer.id =  tg_customer_order.customer_id WHERE  1 = 1 "+ whereCondition +" ORDER BY tg_customer.company_name ASC LIMIT ? OFFSET ? ";
        var filter = [postData.limit, postData.start];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



Report.getStockReportCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if(postData.filter.product_id){
            whereCondition += " AND (tg_product_stock_ledger.product_id = '"+postData.filter.product_id+"')"; 
        }
        
        if(postData.filter.customer_id){
            whereCondition += " AND (tg_product_stock_ledger.customer_id = '"+postData.filter.customer_id+"')"; 
        }
        
        if(postData.filter.customer_search){
            whereCondition += " AND (tg_customer.company_name LIKE '%"+postData.filter.customer_search+"%' OR tg_customer.cust_code LIKE '%"+postData.filter.customer_search+"%')"; 
        }
        
        if(postData.filter.date_from && postData.filter.date_to) {
            whereCondition += 'AND ( DATE(tg_product_stock_ledger.created_on) BETWEEN  "' + moment(new Date(postData.filter.date_from)).format('YYYY-MM-DD') + '" AND "' + moment(new Date(postData.filter.date_to)).format('YYYY-MM-DD') + '" )';
        }
        
        if(postData.filter.product_name){
            whereCondition += " AND (REPLACE(`tg_master_product`.`product_name`,' ','') LIKE '%"+postData.filter.product_name+"%')"; 
        }
        if(postData.filter.product_code){
            whereCondition += " AND (REPLACE(`tg_master_product`.`product_code`,' ','') LIKE '%"+postData.filter.product_code+"%')"; 
        }
        if(postData.filter.product_group){
            whereCondition += " AND (REPLACE(`tg_master_product`.`product_group`,' ','') LIKE '%"+postData.filter.product_group+"%')"; 
        }
        
        // console.log('whereCondition',whereCondition);
        var queryString = "SELECT  IF(COUNT(tg_product_stock_ledger.id),COUNT(tg_product_stock_ledger.id),0) as totalCount  FROM ?? LEFT JOIN tg_master_product ON tg_master_product.id =  tg_product_stock_ledger.product_id LEFT JOIN tg_customer ON tg_customer.id =  tg_product_stock_ledger.customer_id WHERE  1 = 1 "+ whereCondition;
        var filter = ["tg_product_stock_ledger"];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


Report.getStockReport = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if(postData.filter.product_id){
            whereCondition += " AND (tg_product_stock_ledger.product_id = '"+postData.filter.product_id+"')"; 
        }
        
        if(postData.filter.customer_id){
            whereCondition += " AND (tg_product_stock_ledger.customer_id = '"+postData.filter.customer_id+"')"; 
        }
        
        if(postData.filter.customer_search){
            whereCondition += " AND (tg_customer.company_name LIKE '%"+postData.filter.customer_search+"%' OR tg_customer.cust_code LIKE '%"+postData.filter.customer_search+"%')"; 
        }
        
        if(postData.filter.date_from && postData.filter.date_to) {
            whereCondition += 'AND ( DATE(tg_product_stock_ledger.created_on) BETWEEN  "' + moment(new Date(postData.filter.date_from)).format('YYYY-MM-DD') + '" AND "' + moment(new Date(postData.filter.date_to)).format('YYYY-MM-DD') + '" )';
        }
        
        if(postData.filter.product_name){
            whereCondition += " AND (REPLACE(`tg_master_product`.`product_name`,' ','') LIKE '%"+postData.filter.product_name+"%')"; 
        }
        if(postData.filter.product_code){
            whereCondition += " AND (REPLACE(`tg_master_product`.`product_code`,' ','') LIKE '%"+postData.filter.product_code+"%')"; 
        }
        if(postData.filter.product_group){
            whereCondition += " AND (REPLACE(`tg_master_product`.`product_group`,' ','') LIKE '%"+postData.filter.product_group+"%')"; 
        }
        
        
        var queryString = "SELECT tg_product_stock_ledger.*,tg_master_product.product_name,tg_master_product.product_code, tg_master_product.product_group, tg_customer.company_name,tg_customer.cust_code  FROM ?? LEFT JOIN tg_master_product ON tg_master_product.id =  tg_product_stock_ledger.product_id LEFT JOIN tg_customer ON tg_customer.id =  tg_product_stock_ledger.customer_id WHERE  1 = 1 "+ whereCondition +" ORDER BY tg_product_stock_ledger.id DESC LIMIT ? OFFSET ? ";
        var filter = ["tg_product_stock_ledger", postData.limit, postData.start];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                
                if(res.length){
                    var i = res.length - 1;
                    res.forEach(x => {
                        x.invoice_encrypt_id = encrypt(x.invoice_id.toString());
                        x.po_encrypt_id = encrypt(x.po_id.toString());
                        x.customer_encrypt_id = encrypt(x.customer_id.toString());
                        if(i == 0){
                            resolve(res);
                        }
                        i--;
                    });
                }else{
                    resolve(res);
                }
            }
        });
    });
};



// grouped stock report start

Report.getGroupedStockReportCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if(postData.filter.product_id){
            whereCondition += " AND (tg_product_stock_ledger.product_id = '"+postData.filter.product_id+"')"; 
        }
        
        if(postData.filter.customer_id){
            whereCondition += " AND (tg_product_stock_ledger.customer_id = '"+postData.filter.customer_id+"')"; 
        }
        
        if(postData.filter.customer_search){
            whereCondition += " AND (tg_customer.company_name LIKE '%"+postData.filter.customer_search+"%' OR tg_customer.cust_code LIKE '%"+postData.filter.customer_search+"%')"; 
        }
        
        if(postData.filter.date_from && postData.filter.date_to) {
            whereCondition += 'AND ( DATE(tg_product_stock_ledger.created_on) BETWEEN  "' + moment(new Date(postData.filter.date_from)).format('YYYY-MM-DD') + '" AND "' + moment(new Date(postData.filter.date_to)).format('YYYY-MM-DD') + '" )';
        }
        
        if(postData.filter.product_name){
            whereCondition += " AND (REPLACE(`tg_master_product`.`product_name`,' ','') LIKE '%"+postData.filter.product_name+"%')"; 
        }
        if(postData.filter.product_code){
            whereCondition += " AND (REPLACE(`tg_master_product`.`product_code`,' ','') LIKE '%"+postData.filter.product_code+"%')"; 
        }
        if(postData.filter.product_group){
            whereCondition += " AND (REPLACE(`tg_master_product`.`product_group`,' ','') LIKE '%"+postData.filter.product_group+"%')"; 
        }
        
        // console.log('whereCondition',whereCondition);
        var queryString = "SELECT  IF(COUNT(tg_product_stock_ledger.id),COUNT(tg_product_stock_ledger.id),0) as totalCount  FROM ?? LEFT JOIN tg_master_product ON tg_master_product.id =  tg_product_stock_ledger.product_id  WHERE  1 = 1 "+ whereCondition + " GROUP BY tg_product_stock_ledger.product_id";
        var filter = ["tg_product_stock_ledger"];
        
        console.log('queryString',queryString);
        console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res.length);
            }
        });
    });
};


Report.getGroupedStockReport = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if(postData.filter.product_id){
            whereCondition += " AND (tg_product_stock_ledger.product_id = '"+postData.filter.product_id+"')"; 
        }
        
        if(postData.filter.customer_id){
            whereCondition += " AND (tg_product_stock_ledger.customer_id = '"+postData.filter.customer_id+"')"; 
        }
        
        if(postData.filter.customer_search){
            whereCondition += " AND (tg_customer.company_name LIKE '%"+postData.filter.customer_search+"%' OR tg_customer.cust_code LIKE '%"+postData.filter.customer_search+"%')"; 
        }
        
        if(postData.filter.date_from && postData.filter.date_to) {
            whereCondition += 'AND ( DATE(tg_product_stock_ledger.created_on) BETWEEN  "' + moment(new Date(postData.filter.date_from)).format('YYYY-MM-DD') + '" AND "' + moment(new Date(postData.filter.date_to)).format('YYYY-MM-DD') + '" )';
        }
        
        if(postData.filter.product_name){
            whereCondition += " AND (REPLACE(`tg_master_product`.`product_name`,' ','') LIKE '%"+postData.filter.product_name+"%')"; 
        }
        if(postData.filter.product_code){
            whereCondition += " AND (REPLACE(`tg_master_product`.`product_code`,' ','') LIKE '%"+postData.filter.product_code+"%')"; 
        }
        if(postData.filter.product_group){
            whereCondition += " AND (REPLACE(`tg_master_product`.`product_group`,' ','') LIKE '%"+postData.filter.product_group+"%')"; 
        }
        
        
        var queryString = "SELECT tg_product_stock_ledger.product_id,tg_master_product.product_name,tg_master_product.product_code, tg_master_product.product_group ,tg_master_product.stock_qty FROM ?? LEFT JOIN tg_master_product ON tg_master_product.id =  tg_product_stock_ledger.product_id  WHERE  1 = 1 "+ whereCondition +" GROUP BY tg_product_stock_ledger.product_id ORDER BY tg_product_stock_ledger.product_id DESC LIMIT ? OFFSET ? ";
        var filter = ["tg_product_stock_ledger", postData.limit, postData.start];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


// grouped stock report end


Report.getSaleReport = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if(postData.filter.product_id){
            whereCondition += " AND (tg_product_stock_ledger.product_id = '"+postData.filter.product_id+"')"; 
        }
        
        if(postData.filter.customer_id){
            whereCondition += " AND (tg_product_stock_ledger.customer_id = '"+postData.filter.customer_id+"')"; 
        }
        
        if(postData.filter.customer_search){
            whereCondition += " AND (tg_customer.company_name LIKE '%"+postData.filter.customer_search+"%' OR tg_customer.cust_code LIKE '%"+postData.filter.customer_search+"%')"; 
        }
        
        // console.log('whereCondition',whereCondition);
        var queryString = "SELECT tg_product_stock_ledger.*,tg_master_product.product_name,tg_master_product.product_code, tg_master_product.product_group, tg_customer.company_name,tg_customer.cust_code  FROM ?? LEFT JOIN tg_master_product ON tg_master_product.id =  tg_product_stock_ledger.product_id LEFT JOIN tg_customer ON tg_customer.id =  tg_product_stock_ledger.customer_id WHERE  1 = 1 "+ whereCondition +" ORDER BY tg_product_stock_ledger.id DESC LIMIT ? OFFSET ? ";
        var filter = ["tg_product_stock_ledger", postData.limit, postData.start];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



// sales executive report

Report.getSalesExecutiveAnalyseReport = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if(postData.filter.user_id){
            whereCondition += " AND (tg_system_users.id = '"+postData.filter.user_id+"')"; 
        }
        
        // console.log('whereCondition',whereCondition);
        var queryString = "SELECT tg_system_users.name, tg_system_users.designation,tg_system_users.state_name  FROM ??  WHERE 1 = 1 " + whereCondition;
        var filter = ["tg_system_users"];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else{
                var data = {};
                if(res.length){
                    data = res[0];
                    // get distributor assigned means cust type
                    // attendance count
                    // checkin count
                    
                }
                
                resolve(data);
            }
        });
    });
};



Report.getDailyWorkingReport = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        // console.log('whereCondition',whereCondition);
        var queryString = "SELECT tg_system_users.id, tg_system_users.name, tg_system_users.designation,tg_system_users.state_name , tg_system_users.emp_code, tg_system_user_assign.assigned_user_id,tg_system_user_assign.assigned_user_name FROM ??  LEFT JOIN tg_system_user_assign ON tg_system_user_assign.user_id = tg_system_users.id WHERE 1 = 1  AND tg_system_users.role != ? " + whereCondition;
        var filter = ["tg_system_users", 1];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else{
                var i = res.length - 1;
                if(res.length){
                    res.forEach(async x => {
                        x.encrypt_id = encrypt(x.id.toString());

                        x.checkinData = await SFA_masterModel.getCheckinDataCountByCustType({filter:{'checkin_date' : postData.report_date,'user_id' : x.id}});

                        x.primary_order_count =  await Order.getOrderCount({filter:{'order_type' : 'Primary', 'created_on' : postData.report_date,'created_by' : x.id}})

                        x.secondary_order_count =  await Order.getOrderCount({filter:{'order_type' : 'Secondary', 'created_on' : postData.report_date,'created_by' : x.id}})

                        x.primary_order_value =  await Order.getOrderAmountSum({filter:{'order_type' : 'Primary', 'created_on' : postData.report_date,'created_by' : x.id}})

                        x.secondary_order_value =  await Order.getOrderAmountSum({filter:{'order_type' : 'Secondary', 'created_on' : postData.report_date,'created_by' : x.id}})
                        
                        x.new_lead =  await Network.getNetworkCount({filter:{'is_lead' : "1", 'created_on' : postData.report_date}})


                        var getAttendanceData = await SFA_masterModel.getAttendanceDataList({limit:10,start:0, "filter" : {'attend_date' : postData.report_date,'user_id' : x.id}})

                        x.attendanceData = getAttendanceData;

                        // Order.getOrderCount

                        if(i==0){
                            resolve(res);
                        }
                        i--;
                    });
                }else{
                    resolve(res);
                }
            }
        });
    });
};


module.exports = Report;
